/*! For license information please see workerMain.js.LICENSE.txt */
(function(){var e,t,n,r,i=["require","exports","vs/editor/common/core/range","vs/editor/common/core/position","vs/base/common/strings","vs/base/common/platform","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/event","vs/base/common/errors","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/objects","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/base/common/stopwatch","vs/nls","vs/base/common/arrays","vs/base/common/cache","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/smartLinesDiffComputer","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/path","vs/base/common/cancellation","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/nls!vs/base/common/worker/simpleWorker","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],o=function(e){for(var t=[],n=0,r=e.length;n<r;n++)t[n]=i[e[n]];return t},s=this,a="object"==typeof global?global:{};!function(e){e.global=s;var t=function(){function t(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}return Object.defineProperty(t.prototype,"isWindows",{get:function(){return this._detect(),this._isWindows},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"isNode",{get:function(){return this._detect(),this._isNode},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"isElectronRenderer",{get:function(){return this._detect(),this._isElectronRenderer},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"isWebWorker",{get:function(){return this._detect(),this._isWebWorker},enumerable:!1,configurable:!0}),Object.defineProperty(t.prototype,"isElectronNodeIntegrationWebWorker",{get:function(){return this._detect(),this._isElectronNodeIntegrationWebWorker},enumerable:!1,configurable:!0}),t.prototype._detect=function(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&"renderer"===process.type,this._isWebWorker="function"==typeof e.global.importScripts,this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&"worker"===process.type)},t._isWindows=function(){return!!(typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0)||typeof process<"u"&&"win32"===process.platform},t}();e.Environment=t}(r||(r={})),function(e){var t=function(e,t,n){this.type=e,this.detail=t,this.timestamp=n};e.LoaderEvent=t;var n=function(){function n(e){this._events=[new t(1,"",e)]}return n.prototype.record=function(n,r){this._events.push(new t(n,r,e.Utilities.getHighPerformanceTimestamp()))},n.prototype.getEvents=function(){return this._events},n}();e.LoaderEventRecorder=n;var r=function(){function e(){}return e.prototype.record=function(e,t){},e.prototype.getEvents=function(){return[]},e.INSTANCE=new e,e}();e.NullLoaderEventRecorder=r}(r||(r={})),e=r||(r={}),t=function(){function t(){}return t.fileUriToFilePath=function(e,t){if(t=decodeURI(t).replace(/%23/g,"#"),e){if(/^file:\/\/\//.test(t))return t.substr(8);if(/^file:\/\//.test(t))return t.substr(5)}else if(/^file:\/\//.test(t))return t.substr(7);return t},t.startsWith=function(e,t){return e.length>=t.length&&e.substr(0,t.length)===t},t.endsWith=function(e,t){return e.length>=t.length&&e.substr(e.length-t.length)===t},t.containsQueryString=function(e){return/^[^\#]*\?/gi.test(e)},t.isAbsolutePath=function(e){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(e)},t.forEachProperty=function(e,t){if(e){var n=void 0;for(n in e)e.hasOwnProperty(n)&&t(n,e[n])}},t.isEmpty=function(e){var n=!0;return t.forEachProperty(e,(function(){n=!1})),n},t.recursiveClone=function(e){if(!e||"object"!=typeof e||e instanceof RegExp||!Array.isArray(e)&&Object.getPrototypeOf(e)!==Object.prototype)return e;var n=Array.isArray(e)?[]:{};return t.forEachProperty(e,(function(e,r){n[e]=r&&"object"==typeof r?t.recursiveClone(r):r})),n},t.generateAnonymousModule=function(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="},t.isAnonymousModule=function(e){return t.startsWith(e,"===anonymous")},t.getHighPerformanceTimestamp=function(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=e.global.performance&&"function"==typeof e.global.performance.now),this.HAS_PERFORMANCE_NOW?e.global.performance.now():Date.now()},t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,t}(),e.Utilities=t,function(e){function t(e){if(e instanceof Error)return e;var t=new Error(e.message||String(e)||"Unknown Error");return e.stack&&(t.stack=e.stack),t}e.ensureError=t;var n=function(){function n(){}return n.validateConfigurationOptions=function(n){if("string"!=typeof(n=n||{}).baseUrl&&(n.baseUrl=""),"boolean"!=typeof n.isBuild&&(n.isBuild=!1),"object"!=typeof n.paths&&(n.paths={}),"object"!=typeof n.config&&(n.config={}),typeof n.catchError>"u"&&(n.catchError=!1),typeof n.recordStats>"u"&&(n.recordStats=!1),"string"!=typeof n.urlArgs&&(n.urlArgs=""),"function"!=typeof n.onError&&(n.onError=function(e){return"loading"===e.phase?(console.error('Loading "'+e.moduleId+'" failed'),console.error(e),console.error("Here are the modules that depend on it:"),void console.error(e.neededBy)):"factory"===e.phase?(console.error('The factory function of "'+e.moduleId+'" has thrown an exception'),console.error(e),console.error("Here are the modules that depend on it:"),void console.error(e.neededBy)):void 0}),Array.isArray(n.ignoreDuplicateModules)||(n.ignoreDuplicateModules=[]),n.baseUrl.length>0&&(e.Utilities.endsWith(n.baseUrl,"/")||(n.baseUrl+="/")),"string"!=typeof n.cspNonce&&(n.cspNonce=""),typeof n.preferScriptTags>"u"&&(n.preferScriptTags=!1),n.nodeCachedData&&"object"==typeof n.nodeCachedData&&("string"!=typeof n.nodeCachedData.seed&&(n.nodeCachedData.seed="seed"),("number"!=typeof n.nodeCachedData.writeDelay||n.nodeCachedData.writeDelay<0)&&(n.nodeCachedData.writeDelay=7e3),!n.nodeCachedData.path||"string"!=typeof n.nodeCachedData.path)){var r=t(new Error("INVALID cached data configuration, 'path' MUST be set"));r.phase="configuration",n.onError(r),n.nodeCachedData=void 0}return n},n.mergeConfigurationOptions=function(t,r){void 0===t&&(t=null),void 0===r&&(r=null);var i=e.Utilities.recursiveClone(r||{});return e.Utilities.forEachProperty(t,(function(t,n){"ignoreDuplicateModules"===t&&typeof i.ignoreDuplicateModules<"u"?i.ignoreDuplicateModules=i.ignoreDuplicateModules.concat(n):"paths"===t&&typeof i.paths<"u"?e.Utilities.forEachProperty(n,(function(e,t){return i.paths[e]=t})):"config"===t&&typeof i.config<"u"?e.Utilities.forEachProperty(n,(function(e,t){return i.config[e]=t})):i[t]=e.Utilities.recursiveClone(n)})),n.validateConfigurationOptions(i)},n}();e.ConfigurationOptionsUtil=n;var r=function(){function t(e,t){if(this._env=e,this.options=n.mergeConfigurationOptions(t),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),""===this.options.baseUrl&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){var r=this.options.nodeRequire.main.filename,i=Math.max(r.lastIndexOf("/"),r.lastIndexOf("\\"));this.options.baseUrl=r.substring(0,i+1)}}return t.prototype._createIgnoreDuplicateModulesMap=function(){this.ignoreDuplicateModulesMap={};for(var e=0;e<this.options.ignoreDuplicateModules.length;e++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[e]]=!0},t.prototype._createSortedPathsRules=function(){var t=this;this.sortedPathsRules=[],e.Utilities.forEachProperty(this.options.paths,(function(e,n){Array.isArray(n)?t.sortedPathsRules.push({from:e,to:n}):t.sortedPathsRules.push({from:e,to:[n]})})),this.sortedPathsRules.sort((function(e,t){return t.from.length-e.from.length}))},t.prototype.cloneAndMerge=function(e){return new t(this._env,n.mergeConfigurationOptions(e,this.options))},t.prototype.getOptionsLiteral=function(){return this.options},t.prototype._applyPaths=function(t){for(var n,r=0,i=this.sortedPathsRules.length;r<i;r++)if(n=this.sortedPathsRules[r],e.Utilities.startsWith(t,n.from)){for(var o=[],s=0,a=n.to.length;s<a;s++)o.push(n.to[s]+t.substr(n.from.length));return o}return[t]},t.prototype._addUrlArgsToUrl=function(t){return e.Utilities.containsQueryString(t)?t+"&"+this.options.urlArgs:t+"?"+this.options.urlArgs},t.prototype._addUrlArgsIfNecessaryToUrl=function(e){return this.options.urlArgs?this._addUrlArgsToUrl(e):e},t.prototype._addUrlArgsIfNecessaryToUrls=function(e){if(this.options.urlArgs)for(var t=0,n=e.length;t<n;t++)e[t]=this._addUrlArgsToUrl(e[t]);return e},t.prototype.moduleIdToPaths=function(t){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(t))return this.isBuild()?["empty:"]:["node|"+t];var n,r=t;if(e.Utilities.endsWith(r,".js")||e.Utilities.isAbsolutePath(r))!e.Utilities.endsWith(r,".js")&&!e.Utilities.containsQueryString(r)&&(r+=".js"),n=[r];else for(var i=0,o=(n=this._applyPaths(r)).length;i<o;i++)this.isBuild()&&"empty:"===n[i]||(e.Utilities.isAbsolutePath(n[i])||(n[i]=this.options.baseUrl+n[i]),!e.Utilities.endsWith(n[i],".js")&&!e.Utilities.containsQueryString(n[i])&&(n[i]=n[i]+".js"));return this._addUrlArgsIfNecessaryToUrls(n)},t.prototype.requireToUrl=function(t){var n=t;return e.Utilities.isAbsolutePath(n)||(n=this._applyPaths(n)[0],e.Utilities.isAbsolutePath(n)||(n=this.options.baseUrl+n)),this._addUrlArgsIfNecessaryToUrl(n)},t.prototype.isBuild=function(){return this.options.isBuild},t.prototype.shouldInvokeFactory=function(t){return!!(!this.options.isBuild||e.Utilities.isAnonymousModule(t)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[t])},t.prototype.isDuplicateMessageIgnoredFor=function(e){return this.ignoreDuplicateModulesMap.hasOwnProperty(e)},t.prototype.getConfigForModule=function(e){if(this.options.config)return this.options.config[e]},t.prototype.shouldCatchError=function(){return this.options.catchError},t.prototype.shouldRecordStats=function(){return this.options.recordStats},t.prototype.onError=function(e){this.options.onError(e)},t}();e.Configuration=r}(r||(r={})),function(e){var t=function(){function e(e){this._env=e,this._scriptLoader=null,this._callbackMap={}}return e.prototype.load=function(e,t,o,s){var a=this;if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new r;else if(this._env.isElectronRenderer){var l=e.getConfig().getOptionsLiteral().preferScriptTags;this._scriptLoader=l?new n:new i(this._env)}else this._env.isNode?this._scriptLoader=new i(this._env):this._scriptLoader=new n;var u={callback:o,errorback:s};this._callbackMap.hasOwnProperty(t)?this._callbackMap[t].push(u):(this._callbackMap[t]=[u],this._scriptLoader.load(e,t,(function(){return a.triggerCallback(t)}),(function(e){return a.triggerErrorback(t,e)})))},e.prototype.triggerCallback=function(e){var t=this._callbackMap[e];delete this._callbackMap[e];for(var n=0;n<t.length;n++)t[n].callback()},e.prototype.triggerErrorback=function(e,t){var n=this._callbackMap[e];delete this._callbackMap[e];for(var r=0;r<n.length;r++)n[r].errorback(t)},e}(),n=function(){function t(){}return t.prototype.attachListeners=function(e,t,n){var r=function(){e.removeEventListener("load",i),e.removeEventListener("error",o)},i=function(e){r(),t()},o=function(e){r(),n(e)};e.addEventListener("load",i),e.addEventListener("error",o)},t.prototype.load=function(t,n,r,i){if(/^node\|/.test(n)){var s=t.getConfig().getOptionsLiteral(),a=o(t.getRecorder(),s.nodeRequire||e.global.nodeRequire),l=n.split("|"),u=null;try{u=a(l[1])}catch(e){return void i(e)}t.enqueueDefineAnonymousModule([],(function(){return u})),r()}else{var c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript"),this.attachListeners(c,r,i);var d=t.getConfig().getOptionsLiteral().trustedTypesPolicy;d&&(n=d.createScriptURL(n)),c.setAttribute("src",n);var h=t.getConfig().getOptionsLiteral().cspNonce;h&&c.setAttribute("nonce",h),document.getElementsByTagName("head")[0].appendChild(c)}},t}(),r=function(){function t(){this._cachedCanUseEval=null}return t.prototype._canUseEval=function(e){return null===this._cachedCanUseEval&&(this._cachedCanUseEval=function(e){var t=e.getConfig().getOptionsLiteral().trustedTypesPolicy;try{return(t?self.eval(t.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}(e)),this._cachedCanUseEval},t.prototype.load=function(t,n,r,i){if(/^node\|/.test(n)){var s=t.getConfig().getOptionsLiteral(),a=o(t.getRecorder(),s.nodeRequire||e.global.nodeRequire),l=n.split("|"),u=null;try{u=a(l[1])}catch(e){return void i(e)}t.enqueueDefineAnonymousModule([],(function(){return u})),r()}else{var c=t.getConfig().getOptionsLiteral().trustedTypesPolicy;if((!/^((http:)|(https:)|(file:))/.test(n)||n.substring(0,self.origin.length)===self.origin)&&this._canUseEval(t))return void fetch(n).then((function(e){if(200!==e.status)throw new Error(e.statusText);return e.text()})).then((function(e){e=e+"\n//# sourceURL="+n,(c?self.eval(c.createScript("",e)):new Function(e)).call(self),r()})).then(void 0,i);try{c&&(n=c.createScriptURL(n)),importScripts(n),r()}catch(e){i(e)}}},t}(),i=function(){function t(e){this._env=e,this._didInitialize=!1,this._didPatchNodeRequire=!1}return t.prototype._init=function(e){this._didInitialize||(this._didInitialize=!0,this._fs=e("fs"),this._vm=e("vm"),this._path=e("path"),this._crypto=e("crypto"))},t.prototype._initNodeRequire=function(e,t){var n=t.getConfig().getOptionsLiteral().nodeCachedData;if(n&&!this._didPatchNodeRequire){this._didPatchNodeRequire=!0;var r=this,i=e("module");i.prototype._compile=function(e,o){var s,l=i.wrap(e.replace(/^#!.*/,"")),u=t.getRecorder(),c=r._getCachedDataPath(n,o),d={filename:o};try{var h=r._fs.readFileSync(c);s=h.slice(0,16),d.cachedData=h.slice(16),u.record(60,c)}catch{u.record(61,c)}var f=new r._vm.Script(l,d),g=f.runInThisContext(d),m=r._path.dirname(o),p=function(e){var t=e.constructor,n=function(t){try{return e.require(t)}finally{}};return(n.resolve=function(n,r){return t._resolveFilename(n,e,!1,r)}).paths=function(n){return t._resolveLookupPaths(n,e)},n.main=process.mainModule,n.extensions=t._extensions,n.cache=t._cache,n}(this),b=[this.exports,p,this,o,m,process,a,Buffer],y=g.apply(this.exports,b);return r._handleCachedData(f,l,c,!d.cachedData,t),r._verifyCachedData(f,l,c,s,t),y}}},t.prototype.load=function(n,r,i,s){var a=this,l=n.getConfig().getOptionsLiteral(),u=o(n.getRecorder(),l.nodeRequire||e.global.nodeRequire),c=l.nodeInstrumenter||function(e){return e};this._init(u),this._initNodeRequire(u,n);var d=n.getRecorder();if(/^node\|/.test(r)){var h=r.split("|"),f=null;try{f=u(h[1])}catch(e){return void s(e)}n.enqueueDefineAnonymousModule([],(function(){return f})),i()}else{r=e.Utilities.fileUriToFilePath(this._env.isWindows,r);var g=this._path.normalize(r),m=this._getElectronRendererScriptPathOrUri(g),p=Boolean(l.nodeCachedData),b=p?this._getCachedDataPath(l.nodeCachedData,r):void 0;this._readSourceAndCachedData(g,b,d,(function(e,r,o,l){if(e)s(e);else{var u;u=r.charCodeAt(0)===t._BOM?t._PREFIX+r.substring(1)+t._SUFFIX:t._PREFIX+r+t._SUFFIX,u=c(u,g);var d={filename:m,cachedData:o},h=a._createAndEvalScript(n,u,d,i,s);a._handleCachedData(h,u,b,p&&!o,n),a._verifyCachedData(h,u,b,l,n)}}))}},t.prototype._createAndEvalScript=function(t,n,r,i,o){var s=t.getRecorder();s.record(31,r.filename);var a=new this._vm.Script(n,r),l=a.runInThisContext(r),u=t.getGlobalAMDDefineFunc(),c=!1,d=function(){return c=!0,u.apply(null,arguments)};return d.amd=u.amd,l.call(e.global,t.getGlobalAMDRequireFunc(),d,r.filename,this._path.dirname(r.filename)),s.record(32,r.filename),c?i():o(new Error("Didn't receive define call in "+r.filename+"!")),a},t.prototype._getElectronRendererScriptPathOrUri=function(e){if(!this._env.isElectronRenderer)return e;var t=e.match(/^([a-z])\:(.*)/i);return t?"file:///"+(t[1].toUpperCase()+":"+t[2]).replace(/\\/g,"/"):"file://"+e},t.prototype._getCachedDataPath=function(e,t){var n=this._crypto.createHash("md5").update(t,"utf8").update(e.seed,"utf8").update(process.arch,"").digest("hex"),r=this._path.basename(t).replace(/\.js$/,"");return this._path.join(e.path,r+"-"+n+".code")},t.prototype._handleCachedData=function(e,t,n,r,i){var o=this;e.cachedDataRejected?this._fs.unlink(n,(function(r){i.getRecorder().record(62,n),o._createAndWriteCachedData(e,t,n,i),r&&i.getConfig().onError(r)})):r&&this._createAndWriteCachedData(e,t,n,i)},t.prototype._createAndWriteCachedData=function(e,t,n,r){var i=this,o=Math.ceil(r.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),s=-1,a=0,l=void 0,u=function(){setTimeout((function(){l||(l=i._crypto.createHash("md5").update(t,"utf8").digest());var o=e.createCachedData();if(!(0===o.length||o.length===s||a>=5)){if(o.length<s)return void u();s=o.length,i._fs.writeFile(n,Buffer.concat([l,o]),(function(e){e&&r.getConfig().onError(e),r.getRecorder().record(63,n),u()}))}}),o*Math.pow(4,a++))};u()},t.prototype._readSourceAndCachedData=function(e,t,n,r){if(t){var i=void 0,o=void 0,s=void 0,a=2,l=function(e){e?r(e):0==--a&&r(void 0,i,o,s)};this._fs.readFile(e,{encoding:"utf8"},(function(e,t){i=t,l(e)})),this._fs.readFile(t,(function(e,r){!e&&r&&r.length>0?(s=r.slice(0,16),o=r.slice(16),n.record(60,t)):n.record(61,t),l()}))}else this._fs.readFile(e,{encoding:"utf8"},r)},t.prototype._verifyCachedData=function(e,t,n,r,i){var o=this;!r||e.cachedDataRejected||setTimeout((function(){var e=o._crypto.createHash("md5").update(t,"utf8").digest();r.equals(e)||(i.getConfig().onError(new Error("FAILED TO VERIFY CACHED DATA, deleting stale '"+n+"' now, but a RESTART IS REQUIRED")),o._fs.unlink(n,(function(e){e&&i.getConfig().onError(e)})))}),Math.ceil(5e3*(1+Math.random())))},t._BOM=65279,t._PREFIX="(function (require, define, __filename, __dirname) { ",t._SUFFIX="\n});",t}();function o(e,t){if(t.__$__isRecorded)return t;var n=function(n){e.record(33,n);try{return t(n)}finally{e.record(34,n)}};return n.__$__isRecorded=!0,n}e.ensureRecordedNodeRequire=o,e.createScriptLoader=function(e){return new t(e)}}(r||(r={})),function(e){var t=function(){function t(e){var t=e.lastIndexOf("/");this.fromModulePath=-1!==t?e.substr(0,t+1):""}return t._normalizeModuleId=function(e){var t,n=e;for(t=/\/\.\//;t.test(n);)n=n.replace(t,"/");for(n=n.replace(/^\.\//g,""),t=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;t.test(n);)n=n.replace(t,"/");return n.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,"")},t.prototype.resolveModule=function(n){var r=n;return e.Utilities.isAbsolutePath(r)||(e.Utilities.startsWith(r,"./")||e.Utilities.startsWith(r,"../"))&&(r=t._normalizeModuleId(this.fromModulePath+r)),r},t.ROOT=new t(""),t}();e.ModuleIdResolver=t;var n=function(){function t(e,t,n,r,i,o){this.id=e,this.strId=t,this.dependencies=n,this._callback=r,this._errorback=i,this.moduleIdResolver=o,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}return t._safeInvokeFunction=function(t,n){try{return{returnedValue:t.apply(e.global,n),producedError:null}}catch(e){return{returnedValue:null,producedError:e}}},t._invokeFactory=function(t,n,r,i){return t.shouldInvokeFactory(n)?t.shouldCatchError()?this._safeInvokeFunction(r,i):{returnedValue:r.apply(e.global,i),producedError:null}:{returnedValue:null,producedError:null}},t.prototype.complete=function(n,r,i,o){this._isComplete=!0;var s=null;if(this._callback)if("function"==typeof this._callback){n.record(21,this.strId);var a=t._invokeFactory(r,this.strId,this._callback,i);s=a.producedError,n.record(22,this.strId),!s&&typeof a.returnedValue<"u"&&(!this.exportsPassedIn||e.Utilities.isEmpty(this.exports))&&(this.exports=a.returnedValue)}else this.exports=this._callback;if(s){var l=e.ensureError(s);l.phase="factory",l.moduleId=this.strId,l.neededBy=o(this.id),this.error=l,r.onError(l)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null},t.prototype.onDependencyError=function(e){return this._isComplete=!0,this.error=e,!!this._errorback&&(this._errorback(e),!0)},t.prototype.isComplete=function(){return this._isComplete},t}();e.Module=n;var r=function(){function e(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}return e.prototype.getMaxModuleId=function(){return this._nextId},e.prototype.getModuleId=function(e){var t=this._strModuleIdToIntModuleId.get(e);return typeof t>"u"&&(t=this._nextId++,this._strModuleIdToIntModuleId.set(e,t),this._intModuleIdToStrModuleId[t]=e),t},e.prototype.getStrModuleId=function(e){return this._intModuleIdToStrModuleId[e]},e}(),i=function(){function e(e){this.id=e}return e.EXPORTS=new e(0),e.MODULE=new e(1),e.REQUIRE=new e(2),e}();e.RegularDependency=i;var o=function(e,t,n){this.id=e,this.pluginId=t,this.pluginParam=n};e.PluginDependency=o;var s=function(){function s(t,n,i,o,s){void 0===s&&(s=0),this._env=t,this._scriptLoader=n,this._loaderAvailableTimestamp=s,this._defineFunc=i,this._requireFunc=o,this._moduleIdProvider=new r,this._config=new e.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}return s.prototype.reset=function(){return new s(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)},s.prototype.getGlobalAMDDefineFunc=function(){return this._defineFunc},s.prototype.getGlobalAMDRequireFunc=function(){return this._requireFunc},s._findRelevantLocationInStack=function(e,t){for(var n=function(e){return e.replace(/\\/g,"/")},r=n(e),i=t.split(/\n/),o=0;o<i.length;o++){var s=i[o].match(/(.*):(\d+):(\d+)\)?$/);if(s){var a=s[1],l=s[2],u=s[3],c=Math.max(a.lastIndexOf(" ")+1,a.lastIndexOf("(")+1);if((a=n(a=a.substr(c)))===r){var d={line:parseInt(l,10),col:parseInt(u,10)};return 1===d.line&&(d.col-=53),d}}}throw new Error("Could not correlate define call site for needle "+e)},s.prototype.getBuildInfo=function(){if(!this._config.isBuild())return null;for(var e=[],t=0,n=0,r=this._modules2.length;n<r;n++){var i=this._modules2[n];if(i){var o=this._buildInfoPath[i.id]||null,a=this._buildInfoDefineStack[i.id]||null,l=this._buildInfoDependencies[i.id];e[t++]={id:i.strId,path:o,defineLocation:o&&a?s._findRelevantLocationInStack(o,a):null,dependencies:l,shim:null,exports:i.exports}}}return e},s.prototype.getRecorder=function(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new e.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=e.NullLoaderEventRecorder.INSTANCE),this._recorder},s.prototype.getLoaderEvents=function(){return this.getRecorder().getEvents()},s.prototype.enqueueDefineAnonymousModule=function(e,t){if(null!==this._currentAnonymousDefineCall)throw new Error("Can only have one anonymous define call per script file");var n=null;this._config.isBuild()&&(n=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:n,dependencies:e,callback:t}},s.prototype.defineModule=function(e,r,i,o,s,a){var l=this;void 0===a&&(a=new t(e));var u=this._moduleIdProvider.getModuleId(e);if(this._modules2[u])this._config.isDuplicateMessageIgnoredFor(e)||console.warn("Duplicate definition of module '"+e+"'");else{var c=new n(u,e,this._normalizeDependencies(r,a),i,o,a);this._modules2[u]=c,this._config.isBuild()&&(this._buildInfoDefineStack[u]=s,this._buildInfoDependencies[u]=(c.dependencies||[]).map((function(e){return l._moduleIdProvider.getStrModuleId(e.id)}))),this._resolve(c)}},s.prototype._normalizeDependency=function(e,t){if("exports"===e)return i.EXPORTS;if("module"===e)return i.MODULE;if("require"===e)return i.REQUIRE;var n=e.indexOf("!");if(n>=0){var r=t.resolveModule(e.substr(0,n)),s=t.resolveModule(e.substr(n+1)),a=this._moduleIdProvider.getModuleId(r+"!"+s),l=this._moduleIdProvider.getModuleId(r);return new o(a,l,s)}return new i(this._moduleIdProvider.getModuleId(t.resolveModule(e)))},s.prototype._normalizeDependencies=function(e,t){for(var n=[],r=0,i=0,o=e.length;i<o;i++)n[r++]=this._normalizeDependency(e[i],t);return n},s.prototype._relativeRequire=function(t,n,r,i){if("string"==typeof n)return this.synchronousRequire(n,t);this.defineModule(e.Utilities.generateAnonymousModule(),n,r,i,null,t)},s.prototype.synchronousRequire=function(e,n){void 0===n&&(n=new t(e));var r=this._normalizeDependency(e,n),i=this._modules2[r.id];if(!i)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+e+"'. This is the first mention of this module!");if(!i.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+e+"'. This module has not been resolved completely yet.");if(i.error)throw i.error;return i.exports},s.prototype.configure=function(t,n){var r=this._config.shouldRecordStats();this._config=n?new e.Configuration(this._env,t):this._config.cloneAndMerge(t),this._config.shouldRecordStats()&&!r&&(this._recorder=null)},s.prototype.getConfig=function(){return this._config},s.prototype._onLoad=function(e){if(null!==this._currentAnonymousDefineCall){var t=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(e),t.dependencies,t.callback,null,t.stack)}},s.prototype._createLoadError=function(t,n){var r=this,i=this._moduleIdProvider.getStrModuleId(t),o=(this._inverseDependencies2[t]||[]).map((function(e){return r._moduleIdProvider.getStrModuleId(e)})),s=e.ensureError(n);return s.phase="loading",s.moduleId=i,s.neededBy=o,s},s.prototype._onLoadError=function(e,t){var r=this._createLoadError(e,t);this._modules2[e]||(this._modules2[e]=new n(e,this._moduleIdProvider.getStrModuleId(e),[],(function(){}),null,null));for(var i=[],o=0,s=this._moduleIdProvider.getMaxModuleId();o<s;o++)i[o]=!1;var a=!1,l=[];for(l.push(e),i[e]=!0;l.length>0;){var u=l.shift(),c=this._modules2[u];c&&(a=c.onDependencyError(r)||a);var d=this._inverseDependencies2[u];if(d)for(o=0,s=d.length;o<s;o++){var h=d[o];i[h]||(l.push(h),i[h]=!0)}}a||this._config.onError(r)},s.prototype._hasDependencyPath=function(e,t){var n=this._modules2[e];if(!n)return!1;for(var r=[],i=0,o=this._moduleIdProvider.getMaxModuleId();i<o;i++)r[i]=!1;var s=[];for(s.push(n),r[e]=!0;s.length>0;){var a=s.shift().dependencies;if(a)for(i=0,o=a.length;i<o;i++){var l=a[i];if(l.id===t)return!0;var u=this._modules2[l.id];u&&!r[l.id]&&(r[l.id]=!0,s.push(u))}}return!1},s.prototype._findCyclePath=function(e,t,n){if(e===t||50===n)return[e];var r=this._modules2[e];if(!r)return null;var i=r.dependencies;if(i)for(var o=0,s=i.length;o<s;o++){var a=this._findCyclePath(i[o].id,t,n+1);if(null!==a)return a.push(e),a}return null},s.prototype._createRequire=function(t){var n=this,r=function(e,r,i){return n._relativeRequire(t,e,r,i)};return r.toUrl=function(e){return n._config.requireToUrl(t.resolveModule(e))},r.getStats=function(){return n.getLoaderEvents()},r.hasDependencyCycle=function(){return n._hasDependencyCycle},r.config=function(e,t){void 0===t&&(t=!1),n.configure(e,t)},r.__$__nodeRequire=e.global.nodeRequire,r},s.prototype._loadModule=function(e){var t=this;if(!this._modules2[e]&&!this._knownModules2[e]){this._knownModules2[e]=!0;var n=this._moduleIdProvider.getStrModuleId(e),r=this._config.moduleIdToPaths(n);this._env.isNode&&(-1===n.indexOf("/")||/^@[^\/]+\/[^\/]+$/.test(n))&&r.push("node|"+n);var i=-1,o=function(n){if(++i>=r.length)t._onLoadError(e,n);else{var s=r[i],a=t.getRecorder();if(t._config.isBuild()&&"empty:"===s)return t._buildInfoPath[e]=s,t.defineModule(t._moduleIdProvider.getStrModuleId(e),[],null,null,null),void t._onLoad(e);a.record(10,s),t._scriptLoader.load(t,s,(function(){t._config.isBuild()&&(t._buildInfoPath[e]=s),a.record(11,s),t._onLoad(e)}),(function(e){a.record(12,s),o(e)}))}};o(null)}},s.prototype._loadPluginDependency=function(e,n){var r=this;if(!this._modules2[n.id]&&!this._knownModules2[n.id]){this._knownModules2[n.id]=!0;var i=function(e){r.defineModule(r._moduleIdProvider.getStrModuleId(n.id),[],e,null,null)};i.error=function(e){r._config.onError(r._createLoadError(n.id,e))},e.load(n.pluginParam,this._createRequire(t.ROOT),i,this._config.getOptionsLiteral())}},s.prototype._resolve=function(e){var t=this,n=e.dependencies;if(n)for(var r=0,s=n.length;r<s;r++){var a=n[r];if(a!==i.EXPORTS)if(a!==i.MODULE)if(a!==i.REQUIRE){var l=this._modules2[a.id];if(l&&l.isComplete()){if(l.error)return void e.onDependencyError(l.error);e.unresolvedDependenciesCount--}else if(this._hasDependencyPath(a.id,e.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(a.id)+"' and '"+this._moduleIdProvider.getStrModuleId(e.id)+"'. The cyclic path follows:");var u=this._findCyclePath(a.id,e.id,0)||[];u.reverse(),u.push(a.id),console.warn(u.map((function(e){return t._moduleIdProvider.getStrModuleId(e)})).join(" => \n")),e.unresolvedDependenciesCount--}else if(this._inverseDependencies2[a.id]=this._inverseDependencies2[a.id]||[],this._inverseDependencies2[a.id].push(e.id),a instanceof o){var c=this._modules2[a.pluginId];if(c&&c.isComplete()){this._loadPluginDependency(c.exports,a);continue}var d=this._inversePluginDependencies2.get(a.pluginId);d||(d=[],this._inversePluginDependencies2.set(a.pluginId,d)),d.push(a),this._loadModule(a.pluginId)}else this._loadModule(a.id)}else e.unresolvedDependenciesCount--;else e.unresolvedDependenciesCount--;else e.exportsPassedIn=!0,e.unresolvedDependenciesCount--}0===e.unresolvedDependenciesCount&&this._onModuleComplete(e)},s.prototype._onModuleComplete=function(e){var t=this,n=this.getRecorder();if(!e.isComplete()){var r=e.dependencies,o=[];if(r)for(var s=0,a=r.length;s<a;s++){var l=r[s];if(l!==i.EXPORTS)if(l!==i.MODULE)if(l!==i.REQUIRE){var u=this._modules2[l.id];o[s]=u?u.exports:null}else o[s]=this._createRequire(e.moduleIdResolver);else o[s]={id:e.strId,config:function(){return t._config.getConfigForModule(e.strId)}};else o[s]=e.exports}e.complete(n,this._config,o,(function(e){return(t._inverseDependencies2[e]||[]).map((function(e){return t._moduleIdProvider.getStrModuleId(e)}))}));var c=this._inverseDependencies2[e.id];if(this._inverseDependencies2[e.id]=null,c)for(s=0,a=c.length;s<a;s++){var d=c[s],h=this._modules2[d];h.unresolvedDependenciesCount--,0===h.unresolvedDependenciesCount&&this._onModuleComplete(h)}var f=this._inversePluginDependencies2.get(e.id);if(f)for(this._inversePluginDependencies2.delete(e.id),s=0,a=f.length;s<a;s++)this._loadPluginDependency(e.exports,f[s])}},s}();e.ModuleManager=s}(r||(r={})),function(e){var t=new e.Environment,r=null,i=function(e,t,n){"string"!=typeof e&&(n=t,t=e,e=null),("object"!=typeof t||!Array.isArray(t))&&(n=t,t=null),t||(t=["require","exports","module"]),e?r.defineModule(e,t,n,null,null):r.enqueueDefineAnonymousModule(t,n)};i.amd={jQuery:!0};var o=function(e,t){void 0===t&&(t=!1),r.configure(e,t)},s=function(){if(1===arguments.length){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0]))return void o(arguments[0]);if("string"==typeof arguments[0])return r.synchronousRequire(arguments[0])}if(2!==arguments.length&&3!==arguments.length||!Array.isArray(arguments[0]))throw new Error("Unrecognized require call");r.defineModule(e.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null)};function a(){if(typeof e.global.require<"u"||typeof require<"u"){var n=e.global.require||require;if("function"==typeof n&&"function"==typeof n.resolve){var o=e.ensureRecordedNodeRequire(r.getRecorder(),n);e.global.nodeRequire=o,s.nodeRequire=o,s.__$__nodeRequire=o}}!t.isNode||t.isElectronRenderer||t.isElectronNodeIntegrationWebWorker?(t.isElectronRenderer||(e.global.define=i),e.global.require=s):module.exports=s}s.config=o,s.getConfig=function(){return r.getConfig().getOptionsLiteral()},s.reset=function(){r=r.reset()},s.getBuildInfo=function(){return r.getBuildInfo()},s.getStats=function(){return r.getLoaderEvents()},s.define=i,e.init=a,("function"!=typeof e.global.define||!e.global.define.amd)&&(r=new e.ModuleManager(t,e.createScriptLoader(t),i,s,e.Utilities.getHighPerformanceTimestamp()),typeof e.global.require<"u"&&"function"!=typeof e.global.require&&s.config(e.global.require),n=function(){return i.apply(null,arguments)},n.amd=i.amd,typeof doNotInitLoader>"u"&&a())}(r||(r={}));var l=this&&this.__awaiter||function(e,t,n,r){return new(n||(n=Promise))((function(i,o){function s(e){try{l(r.next(e))}catch(e){o(e)}}function a(e){try{l(r.throw(e))}catch(e){o(e)}}function l(e){e.done?i(e.value):function(e){return e instanceof n?e:new n((function(t){t(e)}))}(e.value).then(s,a)}l((r=r.apply(e,t||[])).next())}))};n(i[23],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let n=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function r(e,t){let r;return r=0===t.length?e:e.replace(/\{(\d+)\}/g,((e,n)=>{const r=n[0],i=t[r];let o=e;return"string"==typeof i?o=i:("number"==typeof i||"boolean"==typeof i||null==i)&&(o=String(i)),o})),n&&(r="［"+r.replace(/[aouei]/g,"$&$&")+"］"),r}function i(e){return"/"===e.charAt(e.length-1)?e:e+"/"}function o(e,t,n){return l(this,void 0,void 0,(function*(){const r=i(e)+i(t)+"vscode/"+i(n),o=yield fetch(r);if(o.ok)return yield o.json();throw new Error(`${o.status} - ${o.statusText}`)}))}function s(e){return function(t,n){const i=Array.prototype.slice.call(arguments,2);return r(e[t],i)}}function a(e,t,...n){return r(t,n)}t.localize=a,t.getConfiguredDefaultLocale=function(e){},t.setPseudoTranslation=function(e){n=e},t.create=function(e,t){var n;return{localize:s(t[e]),getConfiguredDefaultLocale:null!==(n=t.getConfiguredDefaultLocale)&&void 0!==n?n:e=>{}}},t.load=function(e,t,n,r){var i;const u=null!==(i=r["vs/nls"])&&void 0!==i?i:{};if(!e||0===e.length)return n({localize:a,getConfiguredDefaultLocale:()=>{var e;return null===(e=u.availableLanguages)||void 0===e?void 0:e["*"]}});const c=u.availableLanguages?function(e,t){let n=e[t];return n||(n=e["*"],n)?n:null}(u.availableLanguages,e):null,d=null===c||"i-default"===c;let h=".nls";d||(h=h+"."+c);const f=t=>{Array.isArray(t)?t.localize=s(t):t.localize=s(t[e]),t.getConfiguredDefaultLocale=()=>{var e;return null===(e=u.availableLanguages)||void 0===e?void 0:e["*"]},n(t)};"function"==typeof u.loadBundle?u.loadBundle(e,c,((n,r)=>{n?t([e+".nls"],f):f(r)})):u.translationServiceUrl&&!d?l(this,void 0,void 0,(function*(){var n;try{const t=yield o(u.translationServiceUrl,c,e);return f(t)}catch(r){if(!c.includes("-"))return console.error(r),t([e+".nls"],f);try{const t=c.split("-")[0],r=yield o(u.translationServiceUrl,t,e);return null!==(n=u.availableLanguages)&&void 0!==n||(u.availableLanguages={}),u.availableLanguages["*"]=t,f(r)}catch(n){return console.error(n),t([e+".nls"],f)}}})):t([e+h],f,(n=>{".nls"!==h?(console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,n),t([e+".nls"],f)):console.error("Failed trying to load default language strings",n)}))}})),function(){var e,t;const n=self.MonacoEnvironment,r=n&&n.baseUrl?n.baseUrl:"../../../",i="function"==typeof(null===(e=self.trustedTypes)||void 0===e?void 0:e.createPolicy)?null===(t=self.trustedTypes)||void 0===t?void 0:t.createPolicy("amdLoader",{createScriptURL:e=>e,createScript:(e,...t)=>`(function anonymous(${t.slice(0,-1).join(",")}) { ${t.pop().toString()}\n})`}):void 0;function o(){require.config({baseUrl:r,catchError:!0,trustedTypesPolicy:i,amdModulesPattern:/^vs\//})}"function"==typeof self.define&&self.define.amd&&o();let s=!0;const a=[];self.onmessage=e=>{s?(s=!1,function(e){new Promise(((e,t)=>{if("function"==typeof self.define&&self.define.amd)return e();const n=r+"vs/loader.js";/^((http:)|(https:)|(file:))/.test(n)&&n.substring(0,self.origin.length)!==self.origin||!function(){try{return(i?self.eval(i.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}()?(i?importScripts(i.createScriptURL(n)):importScripts(n),e()):fetch(n).then((e=>{if(200!==e.status)throw new Error(e.statusText);return e.text()})).then((t=>{t=`${t}\n//# sourceURL=${n}`,(i?self.eval(i.createScript("",t)):new Function(t)).call(self),e()})).then(void 0,t)})).then((()=>{o(),require([e],(function(e){setTimeout((function(){const t=e.create(((e,t)=>{self.postMessage(e,t)}),null);for(self.onmessage=e=>t.onmessage(e.data,e.ports);a.length>0;)self.onmessage(a.shift())}),0)}))}))}(e.data)):a.push(e)}}(),n(i[24],o([0,1]),(function(e,t){"use strict";function n(e,t){let n=0,r=e-1;for(;n<=r;){const e=(n+r)/2|0,i=t(e);if(i<0)n=e+1;else{if(!(i>0))return e;r=e-1}}return-(n+1)}function r(e,t){for(let n=e.length-1;n>=0;n--)if(t(e[n]))return n;return-1}function i(e,t,n){const r=o(e,t),i=e.length,s=n.length;e.length=i+s;for(let t=i-1;t>=r;t--)e[t+s]=e[t];for(let t=0;t<s;t++)e[t+r]=n[t]}function o(e,t){return t<0?Math.max(t+e.length,0):Math.min(t,e.length)}var s,a;function l(e,t){if(0===e.length)return;let n=e[0];for(let r=1;r<e.length;r++){const i=e[r];t(i,n)>0&&(n=i)}return n}Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.asArray=t.pushMany=t.pushToEnd=t.pushToStart=t.arrayInsert=t.range=t.firstOrDefault=t.lastIndex=t.findLast=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.coalesceInPlace=t.coalesce=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call");return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,n=(e,t)=>e===t){if(e===t)return!0;if(!e||!t||e.length!==t.length)return!1;for(let r=0,i=e.length;r<i;r++)if(!n(e[r],t[r]))return!1;return!0},t.removeFastWithoutKeepingOrder=function(e,t){const n=e.length-1;t<n&&(e[t]=e[n]),e.pop()},t.binarySearch=function(e,t,r){return n(e.length,(n=>r(e[n],t)))},t.binarySearch2=n,t.findFirstInSorted=function(e,t){let n=0,r=e.length;if(0===r)return 0;for(;n<r;){const i=Math.floor((n+r)/2);t(e[i])?r=i:n=i+1}return n},t.quickSelect=function e(t,n,r){if((t|=0)>=n.length)throw new TypeError("invalid index");const i=n[Math.floor(n.length*Math.random())],o=[],s=[],a=[];for(const e of n){const t=r(e,i);t<0?o.push(e):t>0?s.push(e):a.push(e)}return t<o.length?e(t,o,r):t<o.length+a.length?a[0]:e(t-(o.length+a.length),s,r)},t.groupBy=function(e,t){const n=[];let r;for(const i of e.slice(0).sort(t))r&&0===t(r[0],i)?r.push(i):(r=[i],n.push(r));return n},t.coalesce=function(e){return e.filter((e=>!!e))},t.coalesceInPlace=function(e){let t=0;for(let n=0;n<e.length;n++)e[n]&&(e[t]=e[n],t+=1);e.length=t},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){return Array.isArray(e)&&e.length>0},t.distinct=function(e,t=e=>e){const n=new Set;return e.filter((e=>{const r=t(e);return!n.has(r)&&(n.add(r),!0)}))},t.findLast=function(e,t){const n=r(e,t);if(-1!==n)return e[n]},t.lastIndex=r,t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.range=function(e,t){let n="number"==typeof t?e:0;"number"==typeof t?n=e:(n=0,t=e);const r=[];if(n<=t)for(let e=n;e<t;e++)r.push(e);else for(let e=n;e>t;e--)r.push(e);return r},t.arrayInsert=function(e,t,n){const r=e.slice(0,t),i=e.slice(t);return r.concat(n,i)},t.pushToStart=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.unshift(t))},t.pushToEnd=function(e,t){const n=e.indexOf(t);n>-1&&(e.splice(n,1),e.push(t))},t.pushMany=function(e,t){for(const n of t)e.push(n)},t.asArray=function(e){return Array.isArray(e)?e:[e]},t.insertInto=i,t.splice=function(e,t,n,r){const s=o(e,t),a=e.splice(s,n);return i(e,s,r),a},(a=s=t.CompareResult||(t.CompareResult={})).isLessThan=function(e){return e<0},a.isGreaterThan=function(e){return e>0},a.isNeitherLessOrGreaterThan=function(e){return 0===e},a.greaterThan=1,a.lessThan=-1,a.neitherLessOrGreaterThan=0,t.compareBy=function(e,t){return(n,r)=>t(e(n),e(r))},t.numberComparator=(e,t)=>e-t,t.findMaxBy=l,t.findLastMaxBy=function(e,t){if(0===e.length)return;let n=e[0];for(let r=1;r<e.length;r++){const i=e[r];t(i,n)>=0&&(n=i)}return n},t.findMinBy=function(e,t){return l(e,((e,n)=>-t(e,n)))},t.ArrayQueue=class{constructor(e){this.f=e,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(e){let t=this.c;for(;t<this.f.length&&e(this.f[t]);)t++;const n=t===this.c?null:this.f.slice(this.c,t);return this.c=t,n}takeFromEndWhile(e){let t=this.d;for(;t>=0&&e(this.f[t]);)t--;const n=t===this.d?null:this.f.slice(t+1,this.d+1);return this.d=t,n}peek(){if(0!==this.length)return this.f[this.c]}dequeue(){const e=this.f[this.c];return this.c++,e}takeCount(e){const t=this.f.slice(this.c,this.c+e);return this.c+=e,t}};class u{constructor(e){this.iterate=e}toArray(){const e=[];return this.iterate((t=>(e.push(t),!0))),e}filter(e){return new u((t=>this.iterate((n=>!e(n)||t(n)))))}map(e){return new u((t=>this.iterate((n=>t(e(n))))))}findLast(e){let t;return this.iterate((n=>(e(n)&&(t=n),!0))),t}findLastMaxBy(e){let t,n=!0;return this.iterate((r=>((n||s.isGreaterThan(e(r,t)))&&(n=!1,t=r),!0))),t}}u.empty=new u((e=>{})),t.CallbackIterable=u})),n(i[25],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=void 0,t.LRUCachedFunction=class{constructor(e){this.c=e,this.a=void 0,this.b=void 0}get(e){const t=JSON.stringify(e);return this.b!==t&&(this.b=t,this.a=this.c(e)),this.a}},t.CachedFunction=class{get cachedValues(){return this.a}constructor(e){this.b=e,this.a=new Map}get(e){if(this.a.has(e))return this.a.get(e);const t=this.b(e);return this.a.set(e,t),t}}})),n(i[26],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0,t.DiffChange=class{constructor(e,t,n,r){this.originalStart=e,this.originalLength=t,this.modifiedStart=n,this.modifiedLength=r}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}})),n(i[8],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.NotSupportedError=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.errorHandler=t.ErrorHandler=void 0;class n{constructor(){this.b=[],this.a=function(e){setTimeout((()=>{throw e.stack?a.isErrorNoTelemetry(e)?new a(e.message+"\n\n"+e.stack):new Error(e.message+"\n\n"+e.stack):e}),0)}}c(e){this.b.forEach((t=>{t(e)}))}onUnexpectedError(e){this.a(e),this.c(e)}onUnexpectedExternalError(e){this.a(e)}}t.ErrorHandler=n,t.errorHandler=new n,t.onUnexpectedError=function(e){i(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){i(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){const{name:t,message:n}=e;return{$isError:!0,name:t,message:n,stack:e.stacktrace||e.stack,noTelemetry:a.isErrorNoTelemetry(e)}}return e};const r="Canceled";function i(e){return e instanceof o||e instanceof Error&&e.name===r&&e.message===r}t.isCancellationError=i;class o extends Error{constructor(){super(r),this.name=this.message}}t.CancellationError=o,t.canceled=function(){const e=new Error(r);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")};class s extends Error{constructor(e){super("NotSupported"),e&&(this.message=e)}}t.NotSupportedError=s;class a extends Error{constructor(e){super(e),this.name="CodeExpectedError"}static fromError(e){if(e instanceof a)return e;const t=new a;return t.message=e.message,t.stack=e.stack,t}static isErrorNoTelemetry(e){return"CodeExpectedError"===e.name}}t.ErrorNoTelemetry=a;class l extends Error{constructor(e){super(e||"An unexpected bug occurred."),Object.setPrototypeOf(this,l.prototype)}}t.BugIndicatingError=l})),n(i[9],o([0,1,8]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assertNever=t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")},t.assertNever=function(e,t="Unreachable"){throw new Error(t)},t.assertFn=function(e){e()||(e(),(0,n.onUnexpectedError)(new n.BugIndicatingError("Assertion Failed")))},t.checkAdjacentItems=function(e,t){let n=0;for(;n<e.length-1;){if(!t(e[n],e[n+1]))return!1;n++}return!0}})),n(i[13],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let n,r=!1;return function(){return r||(r=!0,n=e.apply(t,arguments)),n}}})),n(i[14],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){function t(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]}e.is=t;const n=Object.freeze([]);function*r(e){yield e}e.empty=function(){return n},e.single=r,e.wrap=function(e){return t(e)?e:r(e)},e.from=function(e){return e||n},e.isEmpty=function(e){return!e||!0===e[Symbol.iterator]().next().done},e.first=function(e){return e[Symbol.iterator]().next().value},e.some=function(e,t){for(const n of e)if(t(n))return!0;return!1},e.find=function(e,t){for(const n of e)if(t(n))return n},e.filter=function*(e,t){for(const n of e)t(n)&&(yield n)},e.map=function*(e,t){let n=0;for(const r of e)yield t(r,n++)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},e.reduce=function(e,t,n){let r=n;for(const n of e)r=t(r,n);return r},e.slice=function*(e,t,n=e.length){for(t<0&&(t+=e.length),n<0?n+=e.length:n>e.length&&(n=e.length);t<n;t++)yield e[t]},e.consume=function(t,n=Number.POSITIVE_INFINITY){const r=[];if(0===n)return[r,t];const i=t[Symbol.iterator]();for(let t=0;t<n;t++){const t=i.next();if(t.done)return[r,e.empty()];r.push(t.value)}return[r,{[Symbol.iterator]:()=>i}]}}(t.Iterable||(t.Iterable={}))})),n(i[27],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=void 0;class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(e,t){this._keyCodeToStr[e]=t,this._strToKeyCode[t.toLowerCase()]=e}keyCodeToStr(e){return this._keyCodeToStr[e]}strToKeyCode(e){return this._strToKeyCode[e.toLowerCase()]||0}}const r=new n,i=new n,o=new n;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const s=[],a=Object.create(null),l=Object.create(null);t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;var u;!function(){const e="",n=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],u=[],c=[];for(const e of n){const[n,d,h,f,g,m,p,b,y,C]=e;if(c[h]||(c[h]=!0,s[h]=f,a[f]=h,l[f.toLowerCase()]=h,d&&(t.IMMUTABLE_CODE_TO_KEY_CODE[h]=g,0!==g&&3!==g&&5!==g&&4!==g&&6!==g&&57!==g&&(t.IMMUTABLE_KEY_CODE_TO_CODE[g]=h))),!u[g]){if(u[g]=!0,!m)throw new Error(`String representation missing for key code ${g} around scan code ${f}`);r.define(g,m),i.define(g,y||m),o.define(g,C||y||m)}p&&(t.EVENT_KEY_CODE_MAP[p]=g),b&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[b]=g)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46}(),(u=t.KeyCodeUtils||(t.KeyCodeUtils={})).toString=function(e){return r.keyCodeToStr(e)},u.fromString=function(e){return r.strToKeyCode(e)},u.toUserSettingsUS=function(e){return i.keyCodeToStr(e)},u.toUserSettingsGeneral=function(e){return o.keyCodeToStr(e)},u.fromUserSettings=function(e){return i.strToKeyCode(e)||o.strToKeyCode(e)},u.toElectronAccelerator=function(e){if(e>=93&&e<=108)return null;switch(e){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return r.keyCodeToStr(e)},t.KeyChord=function(e,t){return(e|(65535&t)<<16>>>0)>>>0}})),n(i[28],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0,t.Lazy=class{constructor(e){this.d=e,this.a=!1}get value(){if(!this.a)try{this.b=this.d()}catch(e){this.c=e}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}})),n(i[10],o([0,1,13,14]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.ImmortalReference=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;let i=null;function o(e){return i?.trackDisposable(e),e}function s(e){i?.markAsDisposed(e)}function a(e,t){i?.setParent(e,t)}function l(e){if(r.Iterable.is(e)){const t=[];for(const n of e)if(n)try{n.dispose()}catch(e){t.push(e)}if(1===t.length)throw t[0];if(t.length>1)throw new AggregateError(t,"Encountered errors while disposing of store");return Array.isArray(e)?[]:e}if(e)return e.dispose(),e}function u(e){const t=o({dispose:(0,n.once)((()=>{s(t),e()}))});return t}t.setDisposableTracker=function(e){i=e},t.markAsSingleton=function(e){return i?.markAsSingleton(e),e},t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=l,t.combinedDisposable=function(...e){const t=u((()=>l(e)));return function(e,t){if(i)for(const n of e)i.setParent(n,t)}(e,t),t},t.toDisposable=u;class c{constructor(){this.a=new Set,this.b=!1,o(this)}dispose(){this.b||(s(this),this.b=!0,this.clear())}get isDisposed(){return this.b}clear(){if(0!==this.a.size)try{l(this.a)}finally{this.a.clear()}}add(e){if(!e)return e;if(e===this)throw new Error("Cannot register a disposable on itself!");return a(e,this),this.b?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.a.add(e),e}}c.DISABLE_DISPOSED_WARNING=!1,t.DisposableStore=c;class d{constructor(){this.f=new c,o(this),a(this.f,this)}dispose(){s(this),this.f.dispose()}q(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this.f.add(e)}}d.None=Object.freeze({dispose(){}}),t.Disposable=d,t.MutableDisposable=class{constructor(){this.b=!1,o(this)}get value(){return this.b?void 0:this.a}set value(e){var t;this.b||e===this.a||(null===(t=this.a)||void 0===t||t.dispose(),e&&a(e,this),this.a=e)}clear(){this.value=void 0}dispose(){var e;this.b=!0,s(this),null===(e=this.a)||void 0===e||e.dispose(),this.a=void 0}clearAndLeak(){const e=this.a;return this.a=void 0,e&&a(e,null),e}},t.RefCountedDisposable=class{constructor(e){this.b=e,this.a=1}acquire(){return this.a++,this}release(){return 0==--this.a&&this.b.dispose(),this}},t.SafeDisposable=class{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,o(this)}set(e){let t=e;return this.unset=()=>t=void 0,this.isset=()=>void 0!==t,this.dispose=()=>{t&&(t(),t=void 0,s(this))},this}},t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}};class h{constructor(){this.a=new Map,this.b=!1,o(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}get(e){return this.a.get(e)}set(e,t,n=!1){var r;this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),n||null===(r=this.a.get(e))||void 0===r||r.dispose(),this.a.set(e,t)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=h})),n(i[15],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class n{constructor(e){this.element=e,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let e=this.a;for(;e!==n.Undefined;){const t=e.next;e.prev=n.Undefined,e.next=n.Undefined,e=t}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(e){return this.d(e,!1)}push(e){return this.d(e,!0)}d(e,t){const r=new n(e);if(this.a===n.Undefined)this.a=r,this.b=r;else if(t){const e=this.b;this.b=r,r.prev=e,e.next=r}else{const e=this.a;this.a=r,r.next=e,e.prev=r}this.c+=1;let i=!1;return()=>{i||(i=!0,this.e(r))}}shift(){if(this.a!==n.Undefined){const e=this.a.element;return this.e(this.a),e}}pop(){if(this.b!==n.Undefined){const e=this.b.element;return this.e(this.b),e}}e(e){if(e.prev!==n.Undefined&&e.next!==n.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===n.Undefined&&e.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):e.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):e.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let e=this.a;for(;e!==n.Undefined;)yield e.element,e=e.next}}t.LinkedList=r})),n(i[4],o([0,1,25,28]),(function(e,t,n,r){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.singleLetterHash=t.containsUppercaseCharacter=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.format=t.isFalsyOrWhitespace=void 0,t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length};const o=/{(\d+)}/g;function s(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(e,t){if(!e||!t)return e;const n=t.length;if(0===n||0===e.length)return e;let r=0;for(;e.indexOf(t,r)===r;)r+=n;return e.substring(r)}function l(e,t){if(!e||!t)return e;const n=t.length,r=e.length;if(0===n||0===r)return e;let i=r,o=-1;for(;o=e.lastIndexOf(t,i-1),-1!==o&&o+n===i;){if(0===o)return"";i=o}return e.substring(0,i)}function u(e,t,n=0,r=e.length,i=0,o=t.length){for(;n<r&&i<o;n++,i++){const r=e.charCodeAt(n),o=t.charCodeAt(i);if(r<o)return-1;if(r>o)return 1}const s=r-n,a=o-i;return s<a?-1:s>a?1:0}function c(e,t,n=0,r=e.length,i=0,o=t.length){for(;n<r&&i<o;n++,i++){let s=e.charCodeAt(n),a=t.charCodeAt(i);if(s===a)continue;if(s>=128||a>=128)return u(e.toLowerCase(),t.toLowerCase(),n,r,i,o);d(s)&&(s-=32),d(a)&&(a-=32);const l=s-a;if(0!==l)return l}const s=r-n,a=o-i;return s<a?-1:s>a?1:0}function d(e){return e>=97&&e<=122}function h(e){return 55296<=e&&e<=56319}function f(e){return 56320<=e&&e<=57343}function g(e,t){return t-56320+(e-55296<<10)+65536}function m(e,t,n){const r=e.charCodeAt(n);if(h(r)&&n+1<t){const t=e.charCodeAt(n+1);if(f(t))return g(r,t)}return r}t.format=function(e,...t){return 0===t.length?e:e.replace(o,(function(e,n){const r=parseInt(n,10);return isNaN(r)||r<0||r>=t.length?e:t[r]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=s,t.trim=function(e,t=" "){return l(a(e,t),t)},t.ltrim=a,t.rtrim=l,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.createRegExp=function(e,t,n={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=s(e)),n.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let r="";return n.global&&(r+="g"),n.matchCase||(r+="i"),n.multiline&&(r+="m"),n.unicode&&(r+="u"),new RegExp(e,r)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.splitLines=function(e){return e.split(/\r\n|\r|\n/)},t.firstNonWhitespaceIndex=function(e){for(let t=0,n=e.length;t<n;t++){const n=e.charCodeAt(t);if(32!==n&&9!==n)return t}return-1},t.getLeadingWhitespace=function(e,t=0,n=e.length){for(let r=t;r<n;r++){const n=e.charCodeAt(r);if(32!==n&&9!==n)return e.substring(t,r)}return e.substring(t,n)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){for(let n=t;n>=0;n--){const t=e.charCodeAt(n);if(32!==t&&9!==t)return n}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=u,t.compareIgnoreCase=function(e,t){return c(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=c,t.isAsciiDigit=function(e){return e>=48&&e<=57},t.isLowerAsciiLetter=d,t.isUpperAsciiLetter=function(e){return e>=65&&e<=90},t.equalsIgnoreCase=function(e,t){return e.length===t.length&&0===c(e,t)},t.startsWithIgnoreCase=function(e,t){const n=t.length;return!(t.length>e.length)&&0===c(e,t,0,n)},t.commonPrefixLength=function(e,t){const n=Math.min(e.length,t.length);let r;for(r=0;r<n;r++)if(e.charCodeAt(r)!==t.charCodeAt(r))return r;return n},t.commonSuffixLength=function(e,t){const n=Math.min(e.length,t.length);let r;const i=e.length-1,o=t.length-1;for(r=0;r<n;r++)if(e.charCodeAt(i-r)!==t.charCodeAt(o-r))return r;return n},t.isHighSurrogate=h,t.isLowSurrogate=f,t.computeCodePoint=g,t.getNextCodePoint=m;class p{get offset(){return this.e}constructor(e,t=0){this.c=e,this.d=e.length,this.e=t}setOffset(e){this.e=e}prevCodePoint(){const e=function(e,t){const n=e.charCodeAt(t-1);if(f(n)&&t>1){const r=e.charCodeAt(t-2);if(h(r))return g(r,n)}return n}(this.c,this.e);return this.e-=e>=65536?2:1,e}nextCodePoint(){const e=m(this.c,this.d,this.e);return this.e+=e>=65536?2:1,e}eol(){return this.e>=this.d}}t.CodePointIterator=p;class b{get offset(){return this.c.offset}constructor(e,t=0){this.c=new p(e,t)}nextGraphemeLength(){const e=_.getInstance(),t=this.c,n=t.offset;let r=e.getGraphemeBreakType(t.nextCodePoint());for(;!t.eol();){const n=t.offset,i=e.getGraphemeBreakType(t.nextCodePoint());if(S(r,i)){t.setOffset(n);break}r=i}return t.offset-n}prevGraphemeLength(){const e=_.getInstance(),t=this.c,n=t.offset;let r=e.getGraphemeBreakType(t.prevCodePoint());for(;t.offset>0;){const n=t.offset,i=e.getGraphemeBreakType(t.prevCodePoint());if(S(i,r)){t.setOffset(n);break}r=i}return n-t.offset}eol(){return this.c.eol()}}function y(e,t){return new b(e,t).nextGraphemeLength()}function C(e,t){return new b(e,t).prevGraphemeLength()}let v;t.GraphemeIterator=b,t.nextCharLength=y,t.prevCharLength=C,t.getCharContainingOffset=function(e,t){t>0&&f(e.charCodeAt(t))&&t--;const n=t+y(e,t);return[n-C(e,n),n]},t.containsRTL=function(e){return v||(v=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/),v.test(e)};const E=/^[\t\n\r\x20-\x7E]*$/;function L(e){return e>=127462&&e<=127487||8986===e||8987===e||9200===e||9203===e||e>=9728&&e<=10175||11088===e||11093===e||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129008||e>=129280&&e<=129535||e>=129648&&e<=129782}function S(e,t){return 0===e?5!==t&&7!==t:!(2===e&&3===t||4!==e&&2!==e&&3!==e&&4!==t&&2!==t&&3!==t&&(8===e&&(8===t||9===t||11===t||12===t)||(11===e||9===e)&&(9===t||10===t)||(12===e||10===e)&&10===t||5===t||13===t||7===t||1===e||13===e&&14===t||6===e&&6===t))}t.isBasicASCII=function(e){return E.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.isFullWidthCharacter=function(e){return e>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374},t.isEmojiImprecise=L,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=function(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))},t.containsUppercaseCharacter=function(e,t=!1){return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)};class _{static getInstance(){return _.c||(_.c=new _),_.c}constructor(){this.d=JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this.d,n=t.length/3;let r=1;for(;r<=n;)if(e<t[3*r])r*=2;else{if(!(e>t[3*r+1]))return t[3*r+2];r=2*r+1}return 0}}function w(e){return 127995<=e&&e<=127999}_.c=null,t.getLeftDeleteOffset=function(e,t){if(0===e)return 0;const n=function(e,t){const n=new p(t,e);let r=n.prevCodePoint();for(;w(r)||65039===r||8419===r;){if(0===n.offset)return;r=n.prevCodePoint()}if(!L(r))return;let i=n.offset;return i>0&&8205===n.prevCodePoint()&&(i=n.offset),i}(e,t);if(void 0!==n)return n;const r=new p(t,e);return r.prevCodePoint(),r.offset},t.noBreakWhitespace=" ";class A{static getInstance(e){return A.d.get(Array.from(e))}static getLocales(){return A.e.value}constructor(e){this.f=e}isAmbiguous(e){return this.f.has(e)}getPrimaryConfusable(e){return this.f.get(e)}getConfusableCodePoints(){return new Set(this.f.keys())}}i=A,A.c=new r.Lazy((()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))),A.d=new n.LRUCachedFunction((e=>{function t(e){const t=new Map;for(let n=0;n<e.length;n+=2)t.set(e[n],e[n+1]);return t}function n(e,t){if(!e)return t;const n=new Map;for(const[r,i]of e)t.has(r)&&n.set(r,i);return n}const r=i.c.value;let o,s=e.filter((e=>!e.startsWith("_")&&e in r));0===s.length&&(s=["_default"]);for(const e of s)o=n(o,t(r[e]));const a=function(e,t){const n=new Map(e);for(const[e,r]of t)n.set(e,r);return n}(t(r._common),o);return new A(a)})),A.e=new r.Lazy((()=>Object.keys(A.c.value).filter((e=>!e.startsWith("_"))))),t.AmbiguousCharacters=A;class N{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(N.c())),this.d}static isInvisibleCharacter(e){return N.e().has(e)}static get codePoints(){return N.e()}}N.d=void 0,t.InvisibleCharacters=N})),n(i[29],o([0,1,4]),(function(e,t,n){"use strict";function r(e,t){switch(typeof e){case"object":return null===e?i(349,t):Array.isArray(e)?function(e,t){return t=i(104579,t),e.reduce(((e,t)=>r(t,e)),t)}(e,t):function(e,t){return t=i(181387,t),Object.keys(e).sort().reduce(((t,n)=>(t=o(n,t),r(e[n],t))),t)}(e,t);case"string":return o(e,t);case"boolean":return function(e,t){return i(e?433:863,t)}(e,t);case"number":return i(e,t);case"undefined":return i(937,t);default:return i(617,t)}}function i(e,t){return(t<<5)-t+e|0}function o(e,t){t=i(149417,t);for(let n=0,r=e.length;n<r;n++)t=i(e.charCodeAt(n),t);return t}function s(e,t,n=32){const r=n-t;return(e<<t|(~((1<<r)-1)&e)>>>r)>>>0}function a(e,t=0,n=e.byteLength,r=0){for(let i=0;i<n;i++)e[t+i]=r}function l(e,t=32){return e instanceof ArrayBuffer?Array.from(new Uint8Array(e)).map((e=>e.toString(16).padStart(2,"0"))).join(""):function(e,t,n="0"){for(;e.length<t;)e=n+e;return e}((e>>>0).toString(16),t/4)}Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.stringHash=t.numberHash=t.doHash=t.hash=void 0,t.hash=function(e){return r(e,0)},t.doHash=r,t.numberHash=i,t.stringHash=o,t.toHexString=l;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(e){const t=e.length;if(0===t)return;const r=this.p;let i,o,s=this.r,a=this.u;for(0!==a?(i=a,o=-1,a=0):(i=e.charCodeAt(0),o=0);;){let l=i;if(n.isHighSurrogate(i)){if(!(o+1<t)){a=i;break}{const t=e.charCodeAt(o+1);n.isLowSurrogate(t)?(o++,l=n.computeCodePoint(i,t)):l=65533}}else n.isLowSurrogate(i)&&(l=65533);if(s=this.w(r,s,l),o++,!(o<t))break;i=e.charCodeAt(o)}this.r=s,this.u=a}w(e,t,n){return n<128?e[t++]=n:n<2048?(e[t++]=192|(1984&n)>>>6,e[t++]=128|(63&n)>>>0):n<65536?(e[t++]=224|(61440&n)>>>12,e[t++]=128|(4032&n)>>>6,e[t++]=128|(63&n)>>>0):(e[t++]=240|(1835008&n)>>>18,e[t++]=128|(258048&n)>>>12,e[t++]=128|(4032&n)>>>6,e[t++]=128|(63&n)>>>0),t>=64&&(this.y(),t-=64,this.t+=64,e[0]=e[64],e[1]=e[65],e[2]=e[66]),t}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const e=8*this.t;this.q.setUint32(56,Math.floor(e/4294967296),!1),this.q.setUint32(60,e%4294967296,!1),this.y()}y(){const e=u.g,t=this.q;for(let n=0;n<64;n+=4)e.setUint32(n,t.getUint32(n,!1),!1);for(let t=64;t<320;t+=4)e.setUint32(t,s(e.getUint32(t-12,!1)^e.getUint32(t-32,!1)^e.getUint32(t-56,!1)^e.getUint32(t-64,!1),1),!1);let n,r,i,o=this.h,a=this.l,l=this.m,c=this.n,d=this.o;for(let t=0;t<80;t++)t<20?(n=a&l|~a&c,r=1518500249):t<40?(n=a^l^c,r=1859775393):t<60?(n=a&l|a&c|l&c,r=2400959708):(n=a^l^c,r=3395469782),i=s(o,5)+n+d+r+e.getUint32(4*t,!1)&4294967295,d=c,c=l,l=s(a,30),a=o,o=i;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+l&4294967295,this.n=this.n+c&4294967295,this.o=this.o+d&4294967295}}u.g=new DataView(new ArrayBuffer(320)),t.StringSHA1=u})),n(i[16],o([0,1,26,29]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(e){this.a=e}getElements(){const e=this.a,t=new Int32Array(e.length);for(let n=0,r=e.length;n<r;n++)t[n]=e.charCodeAt(n);return t}}t.StringDiffSequence=i,t.stringDiff=function(e,t,n){return new l(new i(e),new i(t)).ComputeDiff(n).changes};class o{static Assert(e,t){if(!e)throw new Error(t)}}class s{static Copy(e,t,n,r,i){for(let o=0;o<i;o++)n[r+o]=e[t+o]}static Copy2(e,t,n,r,i){for(let o=0;o<i;o++)n[r+o]=e[t+o]}}class a{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new n.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(e,t){this.b=Math.min(this.b,e),this.c=Math.min(this.c,t),this.d++}AddModifiedElement(e,t){this.b=Math.min(this.b,e),this.c=Math.min(this.c,t),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class l{constructor(e,t,n=null){this.a=n,this.b=e,this.c=t;const[r,i,o]=l.o(e),[s,a,u]=l.o(t);this.d=o&&u,this.e=r,this.f=i,this.g=s,this.h=a,this.k=[],this.m=[]}static n(e){return e.length>0&&"string"==typeof e[0]}static o(e){const t=e.getElements();if(l.n(t)){const e=new Int32Array(t.length);for(let n=0,i=t.length;n<i;n++)e[n]=(0,r.stringHash)(t[n],0);return[t,e,!0]}return t instanceof Int32Array?[[],t,!1]:[[],new Int32Array(t),!1]}p(e,t){return this.f[e]===this.h[t]&&(!this.d||this.e[e]===this.g[t])}q(e,t){return!!this.p(e,t)&&l.r(this.b,e)===l.r(this.c,t)}static r(e,t){return"function"==typeof e.getStrictElement?e.getStrictElement(t):null}s(e,t){return this.f[e]===this.f[t]&&(!this.d||this.e[e]===this.e[t])}u(e,t){return this.h[e]===this.h[t]&&(!this.d||this.g[e]===this.g[t])}ComputeDiff(e){return this.v(0,this.f.length-1,0,this.h.length-1,e)}v(e,t,n,r,i){const o=[!1];let s=this.w(e,t,n,r,o);return i&&(s=this.z(s)),{quitEarly:o[0],changes:s}}w(e,t,r,i,s){for(s[0]=!1;e<=t&&r<=i&&this.p(e,r);)e++,r++;for(;t>=e&&i>=r&&this.p(t,i);)t--,i--;if(e>t||r>i){let s;return r<=i?(o.Assert(e===t+1,"originalStart should only be one more than originalEnd"),s=[new n.DiffChange(e,0,r,i-r+1)]):e<=t?(o.Assert(r===i+1,"modifiedStart should only be one more than modifiedEnd"),s=[new n.DiffChange(e,t-e+1,r,0)]):(o.Assert(e===t+1,"originalStart should only be one more than originalEnd"),o.Assert(r===i+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const a=[0],l=[0],u=this.y(e,t,r,i,a,l,s),c=a[0],d=l[0];if(null!==u)return u;if(!s[0]){const o=this.w(e,c,r,d,s);let a=[];return a=s[0]?[new n.DiffChange(c+1,t-(c+1)+1,d+1,i-(d+1)+1)]:this.w(c+1,t,d+1,i,s),this.H(o,a)}return[new n.DiffChange(e,t-e+1,r,i-r+1)]}x(e,t,r,i,o,s,l,u,c,d,h,f,g,m,p,b,y,C){let v=null,E=null,L=new a,S=t,_=r,w=g[0]-b[0]-i,A=-1073741824,N=this.k.length-1;do{const t=w+e;t===S||t<_&&c[t-1]<c[t+1]?(m=(h=c[t+1])-w-i,h<A&&L.MarkNextChange(),A=h,L.AddModifiedElement(h+1,m),w=t+1-e):(m=(h=c[t-1]+1)-w-i,h<A&&L.MarkNextChange(),A=h-1,L.AddOriginalElement(h,m+1),w=t-1-e),N>=0&&(e=(c=this.k[N])[0],S=1,_=c.length-1)}while(--N>=-1);if(v=L.getReverseChanges(),C[0]){let e=g[0]+1,t=b[0]+1;if(null!==v&&v.length>0){const n=v[v.length-1];e=Math.max(e,n.getOriginalEnd()),t=Math.max(t,n.getModifiedEnd())}E=[new n.DiffChange(e,f-e+1,t,p-t+1)]}else{L=new a,S=s,_=l,w=g[0]-b[0]-u,A=1073741824,N=y?this.m.length-1:this.m.length-2;do{const e=w+o;e===S||e<_&&d[e-1]>=d[e+1]?(m=(h=d[e+1]-1)-w-u,h>A&&L.MarkNextChange(),A=h+1,L.AddOriginalElement(h+1,m+1),w=e+1-o):(m=(h=d[e-1])-w-u,h>A&&L.MarkNextChange(),A=h,L.AddModifiedElement(h+1,m+1),w=e-1-o),N>=0&&(o=(d=this.m[N])[0],S=1,_=d.length-1)}while(--N>=-1);E=L.getChanges()}return this.H(v,E)}y(e,t,r,i,o,a,l){let u=0,c=0,d=0,h=0,f=0,g=0;e--,r--,o[0]=0,a[0]=0,this.k=[],this.m=[];const m=t-e+(i-r),p=m+1,b=new Int32Array(p),y=new Int32Array(p),C=i-r,v=t-e,E=e-r,L=t-i,S=(v-C)%2==0;b[C]=e,y[v]=t,l[0]=!1;for(let _=1;_<=m/2+1;_++){let m=0,w=0;d=this.J(C-_,_,C,p),h=this.J(C+_,_,C,p);for(let e=d;e<=h;e+=2){u=e===d||e<h&&b[e-1]<b[e+1]?b[e+1]:b[e-1]+1,c=u-(e-C)-E;const n=u;for(;u<t&&c<i&&this.p(u+1,c+1);)u++,c++;if(b[e]=u,u+c>m+w&&(m=u,w=c),!S&&Math.abs(e-v)<=_-1&&u>=y[e])return o[0]=u,a[0]=c,n<=y[e]&&_<=1448?this.x(C,d,h,E,v,f,g,L,b,y,u,t,o,c,i,a,S,l):null}const A=(m-e+(w-r)-_)/2;if(null!==this.a&&!this.a(m,A))return l[0]=!0,o[0]=m,a[0]=w,A>0&&_<=1448?this.x(C,d,h,E,v,f,g,L,b,y,u,t,o,c,i,a,S,l):(e++,r++,[new n.DiffChange(e,t-e+1,r,i-r+1)]);f=this.J(v-_,_,v,p),g=this.J(v+_,_,v,p);for(let n=f;n<=g;n+=2){u=n===f||n<g&&y[n-1]>=y[n+1]?y[n+1]-1:y[n-1],c=u-(n-v)-L;const s=u;for(;u>e&&c>r&&this.p(u,c);)u--,c--;if(y[n]=u,S&&Math.abs(n-C)<=_&&u<=b[n])return o[0]=u,a[0]=c,s>=b[n]&&_<=1448?this.x(C,d,h,E,v,f,g,L,b,y,u,t,o,c,i,a,S,l):null}if(_<=1447){let e=new Int32Array(h-d+2);e[0]=C-d+1,s.Copy2(b,d,e,1,h-d+1),this.k.push(e),e=new Int32Array(g-f+2),e[0]=v-f+1,s.Copy2(y,f,e,1,g-f+1),this.m.push(e)}}return this.x(C,d,h,E,v,f,g,L,b,y,u,t,o,c,i,a,S,l)}z(e){for(let t=0;t<e.length;t++){const n=e[t],r=t<e.length-1?e[t+1].originalStart:this.f.length,i=t<e.length-1?e[t+1].modifiedStart:this.h.length,o=n.originalLength>0,s=n.modifiedLength>0;for(;n.originalStart+n.originalLength<r&&n.modifiedStart+n.modifiedLength<i&&(!o||this.s(n.originalStart,n.originalStart+n.originalLength))&&(!s||this.u(n.modifiedStart,n.modifiedStart+n.modifiedLength));){const e=this.q(n.originalStart,n.modifiedStart);if(this.q(n.originalStart+n.originalLength,n.modifiedStart+n.modifiedLength)&&!e)break;n.originalStart++,n.modifiedStart++}const a=[null];t<e.length-1&&this.I(e[t],e[t+1],a)&&(e[t]=a[0],e.splice(t+1,1),t--)}for(let t=e.length-1;t>=0;t--){const n=e[t];let r=0,i=0;if(t>0){const n=e[t-1];r=n.originalStart+n.originalLength,i=n.modifiedStart+n.modifiedLength}const o=n.originalLength>0,s=n.modifiedLength>0;let a=0,l=this.G(n.originalStart,n.originalLength,n.modifiedStart,n.modifiedLength);for(let e=1;;e++){const t=n.originalStart-e,u=n.modifiedStart-e;if(t<r||u<i||o&&!this.s(t,t+n.originalLength)||s&&!this.u(u,u+n.modifiedLength))break;const c=(t===r&&u===i?5:0)+this.G(t,n.originalLength,u,n.modifiedLength);c>l&&(l=c,a=e)}n.originalStart-=a,n.modifiedStart-=a;const u=[null];t>0&&this.I(e[t-1],e[t],u)&&(e[t-1]=u[0],e.splice(t,1),t++)}if(this.d)for(let t=1,n=e.length;t<n;t++){const n=e[t-1],r=e[t],i=r.originalStart-n.originalStart-n.originalLength,o=n.originalStart,s=r.originalStart+r.originalLength,a=s-o,l=n.modifiedStart,u=r.modifiedStart+r.modifiedLength,c=u-l;if(i<5&&a<20&&c<20){const e=this.A(o,a,l,c,i);if(e){const[t,o]=e;(t!==n.originalStart+n.originalLength||o!==n.modifiedStart+n.modifiedLength)&&(n.originalLength=t-n.originalStart,n.modifiedLength=o-n.modifiedStart,r.originalStart=t+i,r.modifiedStart=o+i,r.originalLength=s-r.originalStart,r.modifiedLength=u-r.modifiedStart)}}}return e}A(e,t,n,r,i){if(t<i||r<i)return null;const o=e+t-i+1,s=n+r-i+1;let a=0,l=0,u=0;for(let t=e;t<o;t++)for(let e=n;e<s;e++){const n=this.B(t,e,i);n>0&&n>a&&(a=n,l=t,u=e)}return a>0?[l,u]:null}B(e,t,n){let r=0;for(let i=0;i<n;i++){if(!this.p(e+i,t+i))return 0;r+=this.e[e+i].length}return r}C(e){return e<=0||e>=this.f.length-1||this.d&&/^\s*$/.test(this.e[e])}D(e,t){if(this.C(e)||this.C(e-1))return!0;if(t>0){const n=e+t;if(this.C(n-1)||this.C(n))return!0}return!1}E(e){return e<=0||e>=this.h.length-1||this.d&&/^\s*$/.test(this.g[e])}F(e,t){if(this.E(e)||this.E(e-1))return!0;if(t>0){const n=e+t;if(this.E(n-1)||this.E(n))return!0}return!1}G(e,t,n,r){return(this.D(e,t)?1:0)+(this.F(n,r)?1:0)}H(e,t){const n=[];if(0===e.length||0===t.length)return t.length>0?t:e;if(this.I(e[e.length-1],t[0],n)){const r=new Array(e.length+t.length-1);return s.Copy(e,0,r,0,e.length-1),r[e.length-1]=n[0],s.Copy(t,1,r,e.length,t.length-1),r}{const n=new Array(e.length+t.length);return s.Copy(e,0,n,0,e.length),s.Copy(t,0,n,e.length,t.length),n}}I(e,t,r){if(o.Assert(e.originalStart<=t.originalStart,"Left change is not less than or equal to right change"),o.Assert(e.modifiedStart<=t.modifiedStart,"Left change is not less than or equal to right change"),e.originalStart+e.originalLength>=t.originalStart||e.modifiedStart+e.modifiedLength>=t.modifiedStart){const i=e.originalStart;let o=e.originalLength;const s=e.modifiedStart;let a=e.modifiedLength;return e.originalStart+e.originalLength>=t.originalStart&&(o=t.originalStart+t.originalLength-e.originalStart),e.modifiedStart+e.modifiedLength>=t.modifiedStart&&(a=t.modifiedStart+t.modifiedLength-e.modifiedStart),r[0]=new n.DiffChange(i,o,s,a),!0}return r[0]=null,!1}J(e,t,n,r){if(e>=0&&e<r)return e;const i=t%2==0;return e<0?i===(n%2==0)?0:1:i===((r-n-1)%2==0)?r-1:r-2}}t.LcsDiff=l})),n(i[17],o([0,1]),(function(e,t){"use strict";function n(e){return"string"==typeof e}function r(e){return typeof e>"u"}function i(e){return r(e)||null===e}function o(e){return"function"==typeof e}function s(e,t){if(n(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(e instanceof t)return}catch{}if(!i(e)&&e.constructor===t||1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}Object.defineProperty(t,"__esModule",{value:!0}),t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.isFunction=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isString=void 0,t.isString=n,t.isObject=function(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)},t.isTypedArray=function(e){const t=Object.getPrototypeOf(Uint8Array);return"object"==typeof e&&e instanceof t},t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isIterable=function(e){return!!e&&"function"==typeof e[Symbol.iterator]},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=r,t.isDefined=function(e){return!i(e)},t.isUndefinedOrNull=i,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(i(e))throw new Error("Assertion Failed: argument is undefined or null");return e},t.isFunction=o,t.validateConstraints=function(e,t){const n=Math.min(e.length,t.length);for(let r=0;r<n;r++)s(e[r],t[r])},t.validateConstraint=s,t.withNullAsUndefined=function(e){return null===e?void 0:e}})),n(i[30],o([0,1,17]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getCodiconFontCharacters=void 0;const r=Object.create(null);function i(e,t){if((0,n.isString)(t)){const n=r[t];if(void 0===n)throw new Error(`${e} references an unknown codicon: ${t}`);t=n}return r[e]=t,{id:e}}t.getCodiconFontCharacters=function(){return r},t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}})),n(i[11],o([0,1,17]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){if(!t||"object"!=typeof t||t instanceof RegExp)return t;const n=Array.isArray(t)?[]:{};return Object.entries(t).forEach((([t,r])=>{n[t]=r&&"object"==typeof r?e(r):r})),n},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const i in e)if(r.call(e,i)){const r=e[i];"object"==typeof r&&!Object.isFrozen(r)&&!(0,n.isTypedArray)(r)&&t.push(r)}}return e};const r=Object.prototype.hasOwnProperty;function i(e,t,o){if((0,n.isUndefinedOrNull)(e))return e;const s=t(e);if(typeof s<"u")return s;if(Array.isArray(e)){const n=[];for(const r of e)n.push(i(r,t,o));return n}if((0,n.isObject)(e)){if(o.has(e))throw new Error("Cannot clone recursive data-structure");o.add(e);const n={};for(const s in e)r.call(e,s)&&(n[s]=i(e[s],t,o));return o.delete(e),n}return e}function o(e){let t=[],n=Object.getPrototypeOf(e);for(;Object.prototype!==n;)t=t.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return t}t.cloneAndChange=function(e,t){return i(e,t,new Set)},t.mixin=function e(t,r,i=!0){return(0,n.isObject)(t)?((0,n.isObject)(r)&&Object.keys(r).forEach((o=>{o in t?i&&((0,n.isObject)(t[o])&&(0,n.isObject)(r[o])?e(t[o],r[o],i):t[o]=r[o]):t[o]=r[o]})),t):r},t.equals=function e(t,n){if(t===n)return!0;if(null==t||null==n||typeof t!=typeof n||"object"!=typeof t||Array.isArray(t)!==Array.isArray(n))return!1;let r,i;if(Array.isArray(t)){if(t.length!==n.length)return!1;for(r=0;r<t.length;r++)if(!e(t[r],n[r]))return!1}else{const o=[];for(i in t)o.push(i);o.sort();const s=[];for(i in n)s.push(i);if(s.sort(),!e(o,s))return!1;for(r=0;r<o.length;r++)if(!e(t[o[r]],n[o[r]]))return!1}return!0},t.getAllPropertyNames=o,t.getAllMethodNames=function(e){const t=[];for(const n of o(e))"function"==typeof e[n]&&t.push(n);return t},t.createProxyObject=function(e,t){const n=e=>function(){const n=Array.prototype.slice.call(arguments,0);return t(e,n)},r={};for(const t of e)r[t]=n(t);return r}})),n(i[18],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=void 0,t.toUint8=function(e){return e<0?0:e>255?255:0|e},t.toUint32=function(e){return e<0?0:e>4294967295?4294967295:0|e}})),n(i[19],o([0,1,18]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class r{constructor(e){const t=(0,n.toUint8)(e);this.c=t,this.a=r.d(t),this.b=new Map}static d(e){const t=new Uint8Array(256);return t.fill(e),t}set(e,t){const r=(0,n.toUint8)(t);e>=0&&e<256?this.a[e]=r:this.b.set(e,r)}get(e){return e>=0&&e<256?this.a[e]:this.b.get(e)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.CharacterClassifier=r,t.CharacterSet=class{constructor(){this.a=new r(0)}add(e){this.a.set(e,1)}has(e){return 1===this.a.get(e)}clear(){return this.a.clear()}}})),n(i[3],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class n{constructor(e,t){this.lineNumber=e,this.column=t}with(e=this.lineNumber,t=this.column){return e===this.lineNumber&&t===this.column?this:new n(e,t)}delta(e=0,t=0){return this.with(this.lineNumber+e,this.column+t)}equals(e){return n.equals(this,e)}static equals(e,t){return!e&&!t||!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column}isBefore(e){return n.isBefore(this,e)}static isBefore(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<t.column}isBeforeOrEqual(e){return n.isBeforeOrEqual(this,e)}static isBeforeOrEqual(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<=t.column}static compare(e,t){const n=0|e.lineNumber,r=0|t.lineNumber;return n===r?(0|e.column)-(0|t.column):n-r}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(e){return new n(e.lineNumber,e.column)}static isIPosition(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column}}t.Position=n})),n(i[2],o([0,1,3]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;class r{constructor(e,t,n,r){e>n||e===n&&t>r?(this.startLineNumber=n,this.startColumn=r,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=n,this.endColumn=r)}isEmpty(){return r.isEmpty(this)}static isEmpty(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn}containsPosition(e){return r.containsPosition(this,e)}static containsPosition(e,t){return!(t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber||t.lineNumber===e.startLineNumber&&t.column<e.startColumn||t.lineNumber===e.endLineNumber&&t.column>e.endColumn)}static strictContainsPosition(e,t){return!(t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber||t.lineNumber===e.startLineNumber&&t.column<=e.startColumn||t.lineNumber===e.endLineNumber&&t.column>=e.endColumn)}containsRange(e){return r.containsRange(this,e)}static containsRange(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber||t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber||t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn||t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)}strictContainsRange(e){return r.strictContainsRange(this,e)}static strictContainsRange(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber||t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber||t.startLineNumber===e.startLineNumber&&t.startColumn<=e.startColumn||t.endLineNumber===e.endLineNumber&&t.endColumn>=e.endColumn)}plusRange(e){return r.plusRange(this,e)}static plusRange(e,t){let n,i,o,s;return t.startLineNumber<e.startLineNumber?(n=t.startLineNumber,i=t.startColumn):t.startLineNumber===e.startLineNumber?(n=t.startLineNumber,i=Math.min(t.startColumn,e.startColumn)):(n=e.startLineNumber,i=e.startColumn),t.endLineNumber>e.endLineNumber?(o=t.endLineNumber,s=t.endColumn):t.endLineNumber===e.endLineNumber?(o=t.endLineNumber,s=Math.max(t.endColumn,e.endColumn)):(o=e.endLineNumber,s=e.endColumn),new r(n,i,o,s)}intersectRanges(e){return r.intersectRanges(this,e)}static intersectRanges(e,t){let n=e.startLineNumber,i=e.startColumn,o=e.endLineNumber,s=e.endColumn;const a=t.startLineNumber,l=t.startColumn,u=t.endLineNumber,c=t.endColumn;return n<a?(n=a,i=l):n===a&&(i=Math.max(i,l)),o>u?(o=u,s=c):o===u&&(s=Math.min(s,c)),n>o||n===o&&i>s?null:new r(n,i,o,s)}equalsRange(e){return r.equalsRange(this,e)}static equalsRange(e,t){return!e&&!t||!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(e){return new n.Position(e.endLineNumber,e.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(e){return new n.Position(e.startLineNumber,e.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(e,t){return new r(this.startLineNumber,this.startColumn,e,t)}setStartPosition(e,t){return new r(e,t,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(e){return new r(e.startLineNumber,e.startColumn,e.startLineNumber,e.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(e){return new r(e.endLineNumber,e.endColumn,e.endLineNumber,e.endColumn)}delta(e){return new r(this.startLineNumber+e,this.startColumn,this.endLineNumber+e,this.endColumn)}static fromPositions(e,t=e){return new r(e.lineNumber,e.column,t.lineNumber,t.column)}static lift(e){return e?new r(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null}static isIRange(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn}static areIntersectingOrTouching(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn||t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)}static areIntersecting(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<=t.startColumn||t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<=e.startColumn)}static compareRangesUsingStarts(e,t){if(e&&t){const n=0|e.startLineNumber,r=0|t.startLineNumber;if(n===r){const n=0|e.startColumn,r=0|t.startColumn;if(n===r){const n=0|e.endLineNumber,r=0|t.endLineNumber;return n===r?(0|e.endColumn)-(0|t.endColumn):n-r}return n-r}return n-r}return(e?1:0)-(t?1:0)}static compareRangesUsingEnds(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber}static spansMultipleLines(e){return e.endLineNumber>e.startLineNumber}toJSON(){return this}}t.Range=r})),n(i[31],o([0,1,3,2]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=void 0;class i extends r.Range{constructor(e,t,n,r){super(e,t,n,r),this.selectionStartLineNumber=e,this.selectionStartColumn=t,this.positionLineNumber=n,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(e){return i.selectionsEqual(this,e)}static selectionsEqual(e,t){return e.selectionStartLineNumber===t.selectionStartLineNumber&&e.selectionStartColumn===t.selectionStartColumn&&e.positionLineNumber===t.positionLineNumber&&e.positionColumn===t.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(e,t){return 0===this.getDirection()?new i(this.startLineNumber,this.startColumn,e,t):new i(e,t,this.startLineNumber,this.startColumn)}getPosition(){return new n.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new n.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(e,t){return 0===this.getDirection()?new i(e,t,this.endLineNumber,this.endColumn):new i(this.endLineNumber,this.endColumn,e,t)}static fromPositions(e,t=e){return new i(e.lineNumber,e.column,t.lineNumber,t.column)}static fromRange(e,t){return 0===t?new i(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):new i(e.endLineNumber,e.endColumn,e.startLineNumber,e.startColumn)}static liftSelection(e){return new i(e.selectionStartLineNumber,e.selectionStartColumn,e.positionLineNumber,e.positionColumn)}static selectionsArrEqual(e,t){if(e&&!t||!e&&t)return!1;if(!e&&!t)return!0;if(e.length!==t.length)return!1;for(let n=0,r=e.length;n<r;n++)if(!this.selectionsEqual(e[n],t[n]))return!1;return!0}static isISelection(e){return e&&"number"==typeof e.selectionStartLineNumber&&"number"==typeof e.selectionStartColumn&&"number"==typeof e.positionLineNumber&&"number"==typeof e.positionColumn}static createWithDirection(e,t,n,r,o){return 0===o?new i(e,t,n,r):new i(n,r,e,t)}}t.Selection=i})),n(i[32],o([0,1,19]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMapForWordSeparators=t.WordCharacterClassifier=void 0;class r extends n.CharacterClassifier{constructor(e){super(0);for(let t=0,n=e.length;t<n;t++)this.set(e.charCodeAt(t),2);this.set(32,1),this.set(9,1)}}t.WordCharacterClassifier=r,t.getMapForWordSeparators=function(){const e={};return t=>(e.hasOwnProperty(t)||(e[t]=(e=>new r(e))(t)),e[t])}()})),n(i[20],o([0,1,14,15]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",t.DEFAULT_WORD_REGEXP=function(e=""){let n="(-?\\d*\\.\\d\\w*)|([^";for(const r of t.USUAL_WORD_SEPARATORS)e.indexOf(r)>=0||(n+="\\"+r);return n+="\\s]+)",new RegExp(n,"g")}(),t.ensureValidWordDefinition=function(e){let n=t.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)n=e;else{let t="g";e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),n=new RegExp(e.source,t)}return n.lastIndex=0,n};const i=new r.LinkedList;function o(e,t,n,r){let i;for(;i=e.exec(t);){const t=i.index||0;if(t<=n&&e.lastIndex>=n)return i;if(r>0&&t>r)return null}return null}i.unshift({maxLen:1e3,windowSize:15,timeBudget:150}),t.getWordAtText=function e(t,r,s,a,l){if(l||(l=n.Iterable.first(i)),s.length>l.maxLen){let n=t-l.maxLen/2;return n<0?n=0:a+=n,e(t,r,s=s.substring(n,t+l.maxLen/2),a,l)}const u=Date.now(),c=t-1-a;let d=-1,h=null;for(let e=1;!(Date.now()-u>=l.timeBudget);e++){const t=c-l.windowSize*e;r.lastIndex=Math.max(0,t);const n=o(r,s,c,d);if(!n&&h||(h=n,t<=0))break;d=t}if(h){const e={word:h[0],startColumn:a+1+h.index,endColumn:a+1+h.index+h[0].length};return r.lastIndex=0,e}return null}})),n(i[6],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OffsetRange=t.SequenceDiff=void 0;class n{constructor(e,t){this.seq1Range=e,this.seq2Range=t}reverse(){return new n(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}}t.SequenceDiff=n;class r{constructor(e,t){this.start=e,this.endExclusive=t}get isEmpty(){return this.start===this.endExclusive}delta(e){return new r(this.start+e,this.endExclusive+e)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}join(e){return new r(Math.min(this.start,e.start),Math.max(this.endExclusive,e.endExclusive))}}t.OffsetRange=r})),n(i[33],o([0,1,6]),(function(e,t,n){"use strict";function r(e,t,r){const i=[];r.length>0&&i.push(r[0]);for(let e=1;e<r.length;e++){const o=i[i.length-1],s=r[e];if(s.seq1Range.isEmpty){let e=!0;const r=s.seq1Range.start-o.seq1Range.endExclusive;for(let n=1;n<=r;n++)if(t.getElement(s.seq2Range.start-n)!==t.getElement(s.seq2Range.endExclusive-n)){e=!1;break}if(e){i[i.length-1]=new n.SequenceDiff(o.seq1Range,new n.OffsetRange(o.seq2Range.start,s.seq2Range.endExclusive-r));continue}}i.push(s)}return i}function i(e,t,n){if(!e.getBoundaryScore||!t.getBoundaryScore)return n;for(let r=0;r<n.length;r++){const i=n[r];if(i.seq1Range.isEmpty){const s=r>0?n[r-1].seq2Range.endExclusive:-1,a=r+1<n.length?n[r+1].seq2Range.start:t.length;n[r]=o(i,e,t,a,s)}else if(i.seq2Range.isEmpty){const s=r>0?n[r-1].seq1Range.endExclusive:-1,a=r+1<n.length?n[r+1].seq1Range.start:e.length;n[r]=o(i.reverse(),t,e,a,s).reverse()}}return n}function o(e,t,r,i,o){let s=1;for(;e.seq2Range.start-s>o&&r.getElement(e.seq2Range.start-s)===r.getElement(e.seq2Range.endExclusive-s)&&s<20;)s++;s--;let a=0;for(;e.seq2Range.start+a<i&&r.getElement(e.seq2Range.start+a)===r.getElement(e.seq2Range.endExclusive+a)&&a<20;)a++;if(0===s&&0===a)return e;let l=0,u=-1;for(let n=-s;n<=a;n++){const i=e.seq2Range.start+n,o=e.seq2Range.endExclusive+n,s=e.seq1Range.start+n,a=t.getBoundaryScore(s)+r.getBoundaryScore(i)+r.getBoundaryScore(o);a>u&&(u=a,l=n)}return 0!==l?new n.SequenceDiff(e.seq1Range.delta(l),e.seq2Range.delta(l)):e}Object.defineProperty(t,"__esModule",{value:!0}),t.shiftSequenceDiffs=t.joinSequenceDiffs=t.smoothenSequenceDiffs=t.optimizeSequenceDiffs=void 0,t.optimizeSequenceDiffs=function(e,t,n){let o=n;return o=r(0,t,o),o=i(e,t,o),o},t.smoothenSequenceDiffs=function(e,t,r){const i=[];for(const e of r){const t=i[i.length-1];t&&(e.seq1Range.start-t.seq1Range.endExclusive<=2||e.seq2Range.start-t.seq2Range.endExclusive<=2)?i[i.length-1]=new n.SequenceDiff(t.seq1Range.join(e.seq1Range),t.seq2Range.join(e.seq2Range)):i.push(e)}return i},t.joinSequenceDiffs=r,t.shiftSequenceDiffs=i})),n(i[34],o([0,1,6]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MyersDiffAlgorithm=void 0,t.MyersDiffAlgorithm=class{compute(e,t){if(0===e.length)return[new n.SequenceDiff(new n.OffsetRange(0,0),new n.OffsetRange(0,t.length))];if(0===t.length)return[new n.SequenceDiff(new n.OffsetRange(0,e.length),new n.OffsetRange(0,0))];function s(n,r){for(;n<e.length&&r<t.length&&e.getElement(n)===t.getElement(r);)n++,r++;return n}let a=0;const l=new i;l.set(0,s(0,0));const u=new o;u.set(0,0===l.get(0)?null:new r(null,0,0,l.get(0)));let c=0;e:for(;;)for(a++,c=-a;c<=a;c+=2){const n=c===a?-1:l.get(c+1),i=c===-a?-1:l.get(c-1)+1,o=Math.min(Math.max(n,i),e.length),d=o-c,h=s(o,d);l.set(c,h);const f=o===n?u.get(c+1):u.get(c-1);if(u.set(c,h!==o?new r(f,o,d,h-o):f),l.get(c)===e.length&&l.get(c)-c===t.length)break e}let d=u.get(c);const h=[];let f=e.length,g=t.length;for(;;){const e=d?d.x+d.length:0,t=d?d.y+d.length:0;if((e!==f||t!==g)&&h.push(new n.SequenceDiff(new n.OffsetRange(e,f),new n.OffsetRange(t,g))),!d)break;f=d.x,g=d.y,d=d.prev}return h.reverse(),h}};class r{constructor(e,t,n,r){this.prev=e,this.x=t,this.y=n,this.length=r}}class i{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(e){return e<0?(e=-e-1,this.b[e]):this.a[e]}set(e,t){if(e<0){if((e=-e-1)>=this.b.length){const e=this.b;this.b=new Int32Array(2*e.length),this.b.set(e)}this.b[e]=t}else{if(e>=this.a.length){const e=this.a;this.a=new Int32Array(2*e.length),this.a.set(e)}this.a[e]=t}}}class o{constructor(){this.a=[],this.b=[]}get(e){return e<0?(e=-e-1,this.b[e]):this.a[e]}set(e,t){e<0?(e=-e-1,this.b[e]=t):this.a[e]=t}}})),n(i[35],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Array2D=void 0,t.Array2D=class{constructor(e,t){this.width=e,this.height=t,this.a=[],this.a=new Array(e*t)}get(e,t){return this.a[e+t*this.width]}set(e,t,n){this.a[e+t*this.width]=n}}})),n(i[36],o([0,1,6,35]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DynamicProgrammingDiffing=void 0,t.DynamicProgrammingDiffing=class{compute(e,t,i){const o=new r.Array2D(e.length,t.length),s=new r.Array2D(e.length,t.length),a=new r.Array2D(e.length,t.length);for(let n=0;n<e.length;n++)for(let r=0;r<t.length;r++){const l=0===n?0:o.get(n-1,r),u=0===r?0:o.get(n,r-1);let c;e.getElement(n)===t.getElement(r)?(c=0===n||0===r?0:o.get(n-1,r-1),n>0&&r>0&&3===s.get(n-1,r-1)&&(c+=a.get(n-1,r-1)),c+=i?i(n,r):1):c=-1;const d=Math.max(l,u,c);if(d===c){const e=n>0&&r>0?a.get(n-1,r-1):0;a.set(n,r,e+1),s.set(n,r,3)}else d===l?(a.set(n,r,0),s.set(n,r,1)):d===u&&(a.set(n,r,0),s.set(n,r,2));o.set(n,r,d)}const l=[];let u=e.length,c=t.length;function d(e,t){(e+1!==u||t+1!==c)&&l.push(new n.SequenceDiff(new n.OffsetRange(e+1,u),new n.OffsetRange(t+1,c))),u=e,c=t}let h=e.length-1,f=t.length-1;for(;h>=0&&f>=0;)3===s.get(h,f)?(d(h,f),h--,f--):1===s.get(h,f)?h--:f--;return d(-1,-1),l.reverse(),l}}})),n(i[21],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineRange=t.RangeMapping=t.LineRangeMapping=void 0,t.LineRangeMapping=class{constructor(e,t,n){this.originalRange=e,this.modifiedRange=t,this.innerChanges=n}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}},t.RangeMapping=class{constructor(e,t){this.originalRange=e,this.modifiedRange=t}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}};class n{constructor(e,t){this.startLineNumber=e,this.endLineNumberExclusive=t}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(e){return new n(this.startLineNumber+e,this.endLineNumberExclusive+e)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(e){return new n(Math.min(this.startLineNumber,e.startLineNumber),Math.max(this.endLineNumberExclusive,e.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}}t.LineRange=n})),n(i[37],o([0,1,16,21,4,2,9]),(function(e,t,n,r,i,o,s){"use strict";function a(e,t,r,i){return new n.LcsDiff(e,t,r).ComputeDiff(i)}Object.defineProperty(t,"__esModule",{value:!0}),t.DiffComputer=t.SmartLinesDiffComputer=void 0,t.SmartLinesDiffComputer=class{computeDiff(e,t,n){var i;const a=new h(e,t,{maxComputationTime:n.maxComputationTimeMs,shouldIgnoreTrimWhitespace:n.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),l=[];let u=null;for(const e of a.changes){let t,n;t=0===e.originalEndLineNumber?new r.LineRange(e.originalStartLineNumber+1,e.originalStartLineNumber+1):new r.LineRange(e.originalStartLineNumber,e.originalEndLineNumber+1),n=0===e.modifiedEndLineNumber?new r.LineRange(e.modifiedStartLineNumber+1,e.modifiedStartLineNumber+1):new r.LineRange(e.modifiedStartLineNumber,e.modifiedEndLineNumber+1);let s=new r.LineRangeMapping(t,n,null===(i=e.charChanges)||void 0===i?void 0:i.map((e=>new r.RangeMapping(new o.Range(e.originalStartLineNumber,e.originalStartColumn,e.originalEndLineNumber,e.originalEndColumn),new o.Range(e.modifiedStartLineNumber,e.modifiedStartColumn,e.modifiedEndLineNumber,e.modifiedEndColumn)))));u&&(u.modifiedRange.endLineNumberExclusive===s.modifiedRange.startLineNumber||u.originalRange.endLineNumberExclusive===s.originalRange.startLineNumber)&&(s=new r.LineRangeMapping(u.originalRange.join(s.originalRange),u.modifiedRange.join(s.modifiedRange),u.innerChanges&&s.innerChanges?u.innerChanges.concat(s.innerChanges):void 0),l.pop()),l.push(s),u=s}return(0,s.assertFn)((()=>(0,s.checkAdjacentItems)(l,((e,t)=>t.originalRange.startLineNumber-e.originalRange.endLineNumberExclusive==t.modifiedRange.startLineNumber-e.modifiedRange.endLineNumberExclusive&&e.originalRange.endLineNumberExclusive<t.originalRange.startLineNumber&&e.modifiedRange.endLineNumberExclusive<t.modifiedRange.startLineNumber)))),{quitEarly:a.quitEarly,changes:l}}};class l{constructor(e){const t=[],n=[];for(let r=0,i=e.length;r<i;r++)t[r]=f(e[r],1),n[r]=g(e[r],1);this.lines=e,this.a=t,this.b=n}getElements(){const e=[];for(let t=0,n=this.lines.length;t<n;t++)e[t]=this.lines[t].substring(this.a[t]-1,this.b[t]-1);return e}getStrictElement(e){return this.lines[e]}getStartLineNumber(e){return e+1}getEndLineNumber(e){return e+1}createCharSequence(e,t,n){const r=[],i=[],o=[];let s=0;for(let a=t;a<=n;a++){const t=this.lines[a],l=e?this.a[a]:1,u=e?this.b[a]:t.length+1;for(let e=l;e<u;e++)r[s]=t.charCodeAt(e-1),i[s]=a+1,o[s]=e,s++;!e&&a<n&&(r[s]=10,i[s]=a+1,o[s]=t.length+1,s++)}return new u(r,i,o)}}class u{constructor(e,t,n){this.a=e,this.b=t,this.d=n}toString(){return"["+this.a.map(((e,t)=>(10===e?"\\n":String.fromCharCode(e))+`-(${this.b[t]},${this.d[t]})`)).join(", ")+"]"}e(e,t){if(e<0||e>=t.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(e){return e>0&&e===this.b.length?this.getEndLineNumber(e-1):(this.e(e,this.b),this.b[e])}getEndLineNumber(e){return-1===e?this.getStartLineNumber(e+1):(this.e(e,this.b),10===this.a[e]?this.b[e]+1:this.b[e])}getStartColumn(e){return e>0&&e===this.d.length?this.getEndColumn(e-1):(this.e(e,this.d),this.d[e])}getEndColumn(e){return-1===e?this.getStartColumn(e+1):(this.e(e,this.d),10===this.a[e]?1:this.d[e]+1)}}class c{constructor(e,t,n,r,i,o,s,a){this.originalStartLineNumber=e,this.originalStartColumn=t,this.originalEndLineNumber=n,this.originalEndColumn=r,this.modifiedStartLineNumber=i,this.modifiedStartColumn=o,this.modifiedEndLineNumber=s,this.modifiedEndColumn=a}static createFromDiffChange(e,t,n){const r=t.getStartLineNumber(e.originalStart),i=t.getStartColumn(e.originalStart),o=t.getEndLineNumber(e.originalStart+e.originalLength-1),s=t.getEndColumn(e.originalStart+e.originalLength-1),a=n.getStartLineNumber(e.modifiedStart),l=n.getStartColumn(e.modifiedStart),u=n.getEndLineNumber(e.modifiedStart+e.modifiedLength-1),d=n.getEndColumn(e.modifiedStart+e.modifiedLength-1);return new c(r,i,o,s,a,l,u,d)}}class d{constructor(e,t,n,r,i){this.originalStartLineNumber=e,this.originalEndLineNumber=t,this.modifiedStartLineNumber=n,this.modifiedEndLineNumber=r,this.charChanges=i}static createFromDiffResult(e,t,n,r,i,o,s){let l,u,h,f,g;if(0===t.originalLength?(l=n.getStartLineNumber(t.originalStart)-1,u=0):(l=n.getStartLineNumber(t.originalStart),u=n.getEndLineNumber(t.originalStart+t.originalLength-1)),0===t.modifiedLength?(h=r.getStartLineNumber(t.modifiedStart)-1,f=0):(h=r.getStartLineNumber(t.modifiedStart),f=r.getEndLineNumber(t.modifiedStart+t.modifiedLength-1)),o&&t.originalLength>0&&t.originalLength<20&&t.modifiedLength>0&&t.modifiedLength<20&&i()){const o=n.createCharSequence(e,t.originalStart,t.originalStart+t.originalLength-1),l=r.createCharSequence(e,t.modifiedStart,t.modifiedStart+t.modifiedLength-1);if(o.getElements().length>0&&l.getElements().length>0){let e=a(o,l,i,!0).changes;s&&(e=function(e){if(e.length<=1)return e;const t=[e[0]];let n=t[0];for(let r=1,i=e.length;r<i;r++){const i=e[r],o=i.originalStart-(n.originalStart+n.originalLength),s=i.modifiedStart-(n.modifiedStart+n.modifiedLength);Math.min(o,s)<3?(n.originalLength=i.originalStart+i.originalLength-n.originalStart,n.modifiedLength=i.modifiedStart+i.modifiedLength-n.modifiedStart):(t.push(i),n=i)}return t}(e)),g=[];for(let t=0,n=e.length;t<n;t++)g.push(c.createFromDiffChange(e[t],o,l))}}return new d(l,u,h,f,g)}}class h{constructor(e,t,n){this.a=n.shouldComputeCharChanges,this.b=n.shouldPostProcessCharChanges,this.d=n.shouldIgnoreTrimWhitespace,this.e=n.shouldMakePrettyDiff,this.f=e,this.g=t,this.h=new l(e),this.j=new l(t),this.k=m(n.maxComputationTime),this.l=m(0===n.maxComputationTime?0:Math.min(n.maxComputationTime,5e3))}computeDiff(){if(1===this.h.lines.length&&0===this.h.lines[0].length)return 1===this.j.lines.length&&0===this.j.lines[0].length?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(1===this.j.lines.length&&0===this.j.lines[0].length)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const e=a(this.h,this.j,this.k,this.e),t=e.changes,n=e.quitEarly;if(this.d){const e=[];for(let n=0,r=t.length;n<r;n++)e.push(d.createFromDiffResult(this.d,t[n],this.h,this.j,this.l,this.a,this.b));return{quitEarly:n,changes:e}}const r=[];let i=0,o=0;for(let e=-1,n=t.length;e<n;e++){const s=e+1<n?t[e+1]:null,a=s?s.originalStart:this.f.length,l=s?s.modifiedStart:this.g.length;for(;i<a&&o<l;){const e=this.f[i],t=this.g[o];if(e!==t){{let n=f(e,1),s=f(t,1);for(;n>1&&s>1&&e.charCodeAt(n-2)===t.charCodeAt(s-2);)n--,s--;(n>1||s>1)&&this.m(r,i+1,1,n,o+1,1,s)}{let n=g(e,1),s=g(t,1);const a=e.length+1,l=t.length+1;for(;n<a&&s<l&&e.charCodeAt(n-1)===e.charCodeAt(s-1);)n++,s++;(n<a||s<l)&&this.m(r,i+1,n,a,o+1,s,l)}}i++,o++}s&&(r.push(d.createFromDiffResult(this.d,s,this.h,this.j,this.l,this.a,this.b)),i+=s.originalLength,o+=s.modifiedLength)}return{quitEarly:n,changes:r}}m(e,t,n,r,i,o,s){if(this.n(e,t,n,r,i,o,s))return;let a;this.a&&(a=[new c(t,n,t,r,i,o,i,s)]),e.push(new d(t,t,i,i,a))}n(e,t,n,r,i,o,s){const a=e.length;if(0===a)return!1;const l=e[a-1];return 0!==l.originalEndLineNumber&&0!==l.modifiedEndLineNumber&&(l.originalEndLineNumber===t&&l.modifiedEndLineNumber===i?(this.a&&l.charChanges&&l.charChanges.push(new c(t,n,t,r,i,o,i,s)),!0):l.originalEndLineNumber+1===t&&l.modifiedEndLineNumber+1===i&&(l.originalEndLineNumber=t,l.modifiedEndLineNumber=i,this.a&&l.charChanges&&l.charChanges.push(new c(t,n,t,r,i,o,i,s)),!0))}}function f(e,t){const n=i.firstNonWhitespaceIndex(e);return-1===n?t:n+1}function g(e,t){const n=i.lastNonWhitespaceIndex(e);return-1===n?t:n+2}function m(e){if(0===e)return()=>!0;const t=Date.now();return()=>Date.now()-t<e}t.DiffComputer=h})),n(i[38],o([0,1,9,3,2,6,36,33,34,21]),(function(e,t,n,r,i,o,s,a,l,u){"use strict";function c(e){const t=[];for(const n of function*(e,t){let n,r;for(const i of e)void 0!==r&&t(r,i)?n.push(i):(n&&(yield n),n=[i]),r=i;n&&(yield n)}(e,((e,t)=>t.originalRange.startLineNumber-(e.originalRange.endLineNumber-(e.originalRange.endColumn>1?0:1))<=1||t.modifiedRange.startLineNumber-(e.modifiedRange.endLineNumber-(e.modifiedRange.endColumn>1?0:1))<=1))){const e=n[0],r=n[n.length-1];t.push(new u.LineRangeMapping(new u.LineRange(e.originalRange.startLineNumber,r.originalRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),new u.LineRange(e.modifiedRange.startLineNumber,r.modifiedRange.endLineNumber+(r.originalRange.endColumn>1||r.modifiedRange.endColumn>1?1:0)),n))}return(0,n.assertFn)((()=>(0,n.checkAdjacentItems)(t,((e,t)=>t.originalRange.startLineNumber-e.originalRange.endLineNumberExclusive==t.modifiedRange.startLineNumber-e.modifiedRange.endLineNumberExclusive&&e.originalRange.endLineNumberExclusive<t.originalRange.startLineNumber&&e.modifiedRange.endLineNumberExclusive<t.modifiedRange.startLineNumber)))),t}Object.defineProperty(t,"__esModule",{value:!0}),t.LineSequence=t.lineRangeMappingFromRangeMappings=t.StandardLinesDiffComputer=void 0,t.StandardLinesDiffComputer=class{constructor(){this.b=new s.DynamicProgrammingDiffing,this.c=new l.MyersDiffAlgorithm}computeDiff(e,t,r){const i=new Map;function s(e){let t=i.get(e);return void 0===t&&(t=i.size,i.set(e,t)),t}const l=e.map((e=>s(e.trim()))),u=t.map((e=>s(e.trim()))),h=new d(l,e),f=new d(u,t);let g=(()=>h.length+f.length<1500?this.b.compute(h,f,((n,r)=>e[n]===t[r]?0===t[r].length?.1:1+Math.log(1+t[r].length):.99)):this.c.compute(h,f))();g=(0,a.optimizeSequenceDiffs)(h,f,g);const m=[],p=n=>{for(let r=0;r<n;r++){const n=b+r,i=y+r;if(e[n]!==t[i]){const r=this.e(e,t,new o.SequenceDiff(new o.OffsetRange(n,n+1),new o.OffsetRange(i,i+1)));for(const e of r)m.push(e)}}};let b=0,y=0;for(const r of g){(0,n.assertFn)((()=>r.seq1Range.start-b==r.seq2Range.start-y)),p(r.seq1Range.start-b),b=r.seq1Range.endExclusive,y=r.seq2Range.endExclusive;const i=this.e(e,t,r);for(const e of i)m.push(e)}return p(e.length-b),{quitEarly:!1,changes:c(m)}}e(e,t,n){const r=new f(e,n.seq1Range),i=new f(t,n.seq2Range),o=r.length+i.length<500?this.b.compute(r,i):this.c.compute(r,i);let s=(0,a.optimizeSequenceDiffs)(r,i,o);return s=(0,a.smoothenSequenceDiffs)(r,i,s),s.map((e=>new u.RangeMapping(r.translateRange(e.seq1Range).delta(n.seq1Range.start),i.translateRange(e.seq2Range).delta(n.seq2Range.start))))}},t.lineRangeMappingFromRangeMappings=c;class d{constructor(e,t){this.b=e,this.c=t}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){return 1e3-((0===e?0:h(this.c[e-1]))+(e===this.c.length?0:h(this.c[e])))}}function h(e){let t=0;for(;t<e.length&&(32===e.charCodeAt(t)||9===e.charCodeAt(t));)t++;return t}t.LineSequence=d;class f{constructor(e,t){this.lines=e,this.lineRange=t;let n=0;this.c=new Int32Array(t.length);for(let r=t.start;r<t.endExclusive;r++)n+=e[r].length,this.c[r-t.start]=n+1,n++;this.b=new Int32Array(n);let r=0;for(let n=t.start;n<t.endExclusive;n++){const t=e[n];for(let e=0;e<t.length;e++)this.b[r+e]=t.charCodeAt(e);r+=t.length,n<e.length-1&&(this.b[r]="\n".charCodeAt(0),r+=1)}}getElement(e){return this.b[e]}get length(){return this.b.length}getBoundaryScore(e){const t=p(e>0?this.b[e-1]:-1),n=p(e<this.b.length?this.b[e]:-1);if(6===t&&7===n)return 0;let r=0;return t!==n&&(r+=10,1===n&&(r+=1)),r+=m(t),r+=m(n),r}translateOffset(e){let t=0,n=this.c.length;for(;t<n;){const r=Math.floor((t+n)/2);this.c[r]>e?n=r:t=r+1}const i=0===t?0:this.c[t-1];return new r.Position(t+1,e-i+1)}translateRange(e){return i.Range.fromPositions(this.translateOffset(e.start),this.translateOffset(e.endExclusive))}}const g={0:0,1:0,2:0,3:10,4:2,5:3,6:10,7:10};function m(e){return g[e]}function p(e){return 10===e?7:13===e?6:function(e){return 32===e||9===e}(e)?5:e>=97&&e<=122?0:e>=65&&e<=90?1:e>=48&&e<=57?2:-1===e?3:4}})),n(i[39],o([0,1,37,38]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.linesDiffComputers=void 0,t.linesDiffComputers={smart:new n.SmartLinesDiffComputer,experimental:new r.StandardLinesDiffComputer}})),n(i[40],o([0,1,19]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=void 0;class r{constructor(e,t,n){const r=new Uint8Array(e*t);for(let i=0,o=e*t;i<o;i++)r[i]=n;this.a=r,this.rows=e,this.cols=t}get(e,t){return this.a[e*this.cols+t]}set(e,t,n){this.a[e*this.cols+t]=n}}class i{constructor(e){let t=0,n=0;for(let r=0,i=e.length;r<i;r++){const[i,o,s]=e[r];o>t&&(t=o),i>n&&(n=i),s>n&&(n=s)}t++,n++;const i=new r(n,t,0);for(let t=0,n=e.length;t<n;t++){const[n,r,o]=e[t];i.set(n,r,o)}this.a=i,this.b=t}nextState(e,t){return t<0||t>=this.b?0:this.a.get(e,t)}}t.StateMachine=i;let o=null,s=null;class a{static a(e,t,n,r,i){let o=i-1;do{const n=t.charCodeAt(o);if(2!==e.get(n))break;o--}while(o>r);if(r>0){const e=t.charCodeAt(r-1),n=t.charCodeAt(o);(40===e&&41===n||91===e&&93===n||123===e&&125===n)&&o--}return{range:{startLineNumber:n,startColumn:r+1,endLineNumber:n,endColumn:o+2},url:t.substring(r,o+1)}}static computeLinks(e,t=function(){return null===o&&(o=new i([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),o}()){const r=function(){if(null===s){s=new n.CharacterClassifier(0);const e=", \t<>'\"、。｡､，．：；‘〈「『〔（［｛｢｣｝］）〕』」〉’｀～…";for(let t=0;t<e.length;t++)s.set(e.charCodeAt(t),1);const t=".;:";for(let e=0;e<t.length;e++)s.set(t.charCodeAt(e),2)}return s}(),l=[];for(let n=1,i=e.getLineCount();n<=i;n++){const i=e.getLineContent(n),o=i.length;let s=0,u=0,c=0,d=1,h=!1,f=!1,g=!1,m=!1;for(;s<o;){let e=!1;const o=i.charCodeAt(s);if(13===d){let t;switch(o){case 40:h=!0,t=0;break;case 41:t=h?0:1;break;case 91:g=!0,f=!0,t=0;break;case 93:g=!1,t=f?0:1;break;case 123:m=!0,t=0;break;case 125:t=m?0:1;break;case 39:case 34:case 96:t=c===o?1:39===c||34===c||96===c?0:1;break;case 42:t=42===c?1:0;break;case 124:t=124===c?1:0;break;case 32:t=g?0:1;break;default:t=r.get(o)}1===t&&(l.push(a.a(r,i,n,u,s)),e=!0)}else if(12===d){let t;91===o?(f=!0,t=0):t=r.get(o),1===t?e=!0:d=13}else d=t.nextState(d,o),0===d&&(e=!0);e&&(d=1,h=!1,f=!1,m=!1,u=s+1,c=o),s++}13===d&&l.push(a.a(r,i,n,u,o))}return l}}t.LinkComputer=a,t.computeLinks=function(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?a.computeLinks(e):[]}})),n(i[41],o([0,1]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BasicInplaceReplace=void 0;class n{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(e,t,n,r,i){if(e&&t){const n=this.a(t,i);if(n)return{range:e,value:n}}if(n&&r){const e=this.a(r,i);if(e)return{range:n,value:e}}return null}a(e,t){const n=this.b(e,t);return null!==n?n:this.d(e,t)}b(e,t){const n=Math.pow(10,e.length-(e.lastIndexOf(".")+1));let r=Number(e);const i=parseFloat(e);return isNaN(r)||isNaN(i)||r!==i?null:0!==r||t?(r=Math.floor(r*n),r+=t?n:-n,String(r/n)):null}d(e,t){return this.e(this.c,e,t)}e(e,t,n){let r=null;for(let i=0,o=e.length;null===r&&i<o;i++)r=this.f(e[i],t,n);return r}f(e,t,n){let r=e.indexOf(t);return r>=0?(r+=n?1:-1,r<0?r=e.length-1:r%=e.length,e[r]):null}}n.INSTANCE=new n,t.BasicInplaceReplace=n})),n(i[42],o([0,1,11]),(function(e,t,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.ApplyEditsResult=t.SearchData=t.ValidAnnotatedEditOperation=t.isITextSnapshot=t.FindMatch=t.TextModelResolvedOptions=t.InjectedTextCursorStops=t.MinimapPosition=t.OverviewRulerLane=void 0,(r=t.OverviewRulerLane||(t.OverviewRulerLane={}))[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full",function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"}(t.MinimapPosition||(t.MinimapPosition={})),function(e){e[e.Both=0]="Both",e[e.Right=1]="Right",e[e.Left=2]="Left",e[e.None=3]="None"}(t.InjectedTextCursorStops||(t.InjectedTextCursorStops={})),t.TextModelResolvedOptions=class{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(e){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,0|e.tabSize),"tabSize"===e.indentSize?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,0|e.indentSize),this.a=!1),this.insertSpaces=Boolean(e.insertSpaces),this.defaultEOL=0|e.defaultEOL,this.trimAutoWhitespace=Boolean(e.trimAutoWhitespace),this.bracketPairColorizationOptions=e.bracketPairColorizationOptions}equals(e){return this.tabSize===e.tabSize&&this.a===e.a&&this.indentSize===e.indentSize&&this.insertSpaces===e.insertSpaces&&this.defaultEOL===e.defaultEOL&&this.trimAutoWhitespace===e.trimAutoWhitespace&&(0,n.equals)(this.bracketPairColorizationOptions,e.bracketPairColorizationOptions)}createChangeEvent(e){return{tabSize:this.tabSize!==e.tabSize,indentSize:this.indentSize!==e.indentSize,insertSpaces:this.insertSpaces!==e.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==e.trimAutoWhitespace}}},t.FindMatch=class{constructor(e,t){this._findMatchBrand=void 0,this.range=e,this.matches=t}},t.isITextSnapshot=function(e){return e&&"function"==typeof e.read},t.ValidAnnotatedEditOperation=class{constructor(e,t,n,r,i,o){this.identifier=e,this.range=t,this.text=n,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=i,this._isTracked=o}},t.SearchData=class{constructor(e,t,n){this.regex=e,this.wordSeparators=t,this.simpleSearch=n}},t.ApplyEditsResult=class{constructor(e,t,n){this.reverseEdits=e,this.changes=t,this.trimAutoWhitespaceLineNumbers=n}},t.shouldSynchronizeModel=function(e){return!e.isTooLargeForSyncing()&&!e.isForSimpleWidget}})),n(i[43],o([0,1,24,18]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumIndexOfResult=t.ConstantTimePrefixSumComputer=t.PrefixSumComputer=void 0,t.PrefixSumComputer=class{constructor(e){this.a=e,this.b=new Uint32Array(e.length),this.c=new Int32Array(1),this.c[0]=-1}insertValues(e,t){e=(0,r.toUint32)(e);const n=this.a,i=this.b,o=t.length;return 0!==o&&(this.a=new Uint32Array(n.length+o),this.a.set(n.subarray(0,e),0),this.a.set(n.subarray(e),e+o),this.a.set(t,e),e-1<this.c[0]&&(this.c[0]=e-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(i.subarray(0,this.c[0]+1)),!0)}setValue(e,t){return e=(0,r.toUint32)(e),t=(0,r.toUint32)(t),this.a[e]!==t&&(this.a[e]=t,e-1<this.c[0]&&(this.c[0]=e-1),!0)}removeValues(e,t){e=(0,r.toUint32)(e),t=(0,r.toUint32)(t);const n=this.a,i=this.b;if(e>=n.length)return!1;const o=n.length-e;return t>=o&&(t=o),0!==t&&(this.a=new Uint32Array(n.length-t),this.a.set(n.subarray(0,e),0),this.a.set(n.subarray(e+t),e),this.b=new Uint32Array(this.a.length),e-1<this.c[0]&&(this.c[0]=e-1),this.c[0]>=0&&this.b.set(i.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return 0===this.a.length?0:this.d(this.a.length-1)}getPrefixSum(e){return e<0?0:(e=(0,r.toUint32)(e),this.d(e))}d(e){if(e<=this.c[0])return this.b[e];let t=this.c[0]+1;0===t&&(this.b[0]=this.a[0],t++),e>=this.a.length&&(e=this.a.length-1);for(let n=t;n<=e;n++)this.b[n]=this.b[n-1]+this.a[n];return this.c[0]=Math.max(this.c[0],e),this.b[e]}getIndexOf(e){e=Math.floor(e),this.getTotalSum();let t=0,n=this.a.length-1,r=0,o=0,s=0;for(;t<=n;)if(r=t+(n-t)/2|0,o=this.b[r],s=o-this.a[r],e<s)n=r-1;else{if(!(e>=o))break;t=r+1}return new i(r,e-s)}},t.ConstantTimePrefixSumComputer=class{constructor(e){this.a=e,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(e){return this.g(),0===e?0:this.d[e-1]}getIndexOf(e){this.g();const t=this.e[e],n=t>0?this.d[t-1]:0;return new i(t,e-n)}removeValues(e,t){this.a.splice(e,t),this.f(e)}insertValues(e,t){this.a=(0,n.arrayInsert)(this.a,e,t),this.f(e)}f(e){this.b=!1,this.c=Math.min(this.c,e-1)}g(){if(!this.b){for(let e=this.c+1,t=this.a.length;e<t;e++){const t=this.a[e],n=e>0?this.d[e-1]:0;this.d[e]=n+t;for(let r=0;r<t;r++)this.e[n+r]=e}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(e,t){this.a[e]!==t&&(this.a[e]=t,this.f(e))}};class i{constructor(e,t){this.index=e,this.remainder=t,this._prefixSumIndexOfResultBrand=void 0,this.index=e,this.remainder=t}}t.PrefixSumIndexOfResult=i})),n(i[44],o([0,1,4,3,43]),(function(e,t,n,r,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0,t.MirrorTextModel=class{constructor(e,t,n,r){this.c=e,this.d=t,this.f=n,this.g=r,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return null===this.j&&(this.j=this.d.join(this.f)),this.j}onEvents(e){e.eol&&e.eol!==this.f&&(this.f=e.eol,this.h=null);const t=e.changes;for(const e of t)this.n(e.range),this.o(new r.Position(e.range.startLineNumber,e.range.startColumn),e.text);this.g=e.versionId,this.j=null}k(){if(!this.h){const e=this.f.length,t=this.d.length,n=new Uint32Array(t);for(let r=0;r<t;r++)n[r]=this.d[r].length+e;this.h=new i.PrefixSumComputer(n)}}l(e,t){this.d[e]=t,this.h&&this.h.setValue(e,this.d[e].length+this.f.length)}n(e){if(e.startLineNumber!==e.endLineNumber)this.l(e.startLineNumber-1,this.d[e.startLineNumber-1].substring(0,e.startColumn-1)+this.d[e.endLineNumber-1].substring(e.endColumn-1)),this.d.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this.h&&this.h.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber);else{if(e.startColumn===e.endColumn)return;this.l(e.startLineNumber-1,this.d[e.startLineNumber-1].substring(0,e.startColumn-1)+this.d[e.startLineNumber-1].substring(e.endColumn-1))}}o(e,t){if(0===t.length)return;const r=(0,n.splitLines)(t);if(1===r.length)return void this.l(e.lineNumber-1,this.d[e.lineNumber-1].substring(0,e.column-1)+r[0]+this.d[e.lineNumber-1].substring(e.column-1));r[r.length-1]+=this.d[e.lineNumber-1].substring(e.column-1),this.l(e.lineNumber-1,this.d[e.lineNumber-1].substring(0,e.column-1)+r[0]);const i=new Uint32Array(r.length-1);for(let t=1;t<r.length;t++)this.d.splice(e.lineNumber+t-1,0,r[t]),i[t-1]=r[t].length+this.f.length;this.h&&this.h.insertValues(e.lineNumber,i)}}})),n(i[45],o([0,1,4,32,3,2,42]),(function(e,t,n,r,i,o,s){"use strict";function a(e){if(!e||0===e.length)return!1;for(let t=0,n=e.length;t<n;t++){const r=e.charCodeAt(t);if(10===r)return!0;if(92===r){if(t++,t>=n)break;const r=e.charCodeAt(t);if(110===r||114===r||87===r)return!0}}return!1}function l(e,t,n){if(!n)return new s.FindMatch(e,null);const r=[];for(let e=0,n=t.length;e<n;e++)r[e]=t[e];return new s.FindMatch(e,r)}Object.defineProperty(t,"__esModule",{value:!0}),t.Searcher=t.isValidMatch=t.TextModelSearch=t.createFindMatch=t.isMultilineRegexSource=t.SearchParams=void 0,t.SearchParams=class{constructor(e,t,n,r){this.searchString=e,this.isRegex=t,this.matchCase=n,this.wordSeparators=r}parseSearchRequest(){if(""===this.searchString)return null;let e;e=this.isRegex?a(this.searchString):this.searchString.indexOf("\n")>=0;let t=null;try{t=n.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:e,global:!0,unicode:!0})}catch{return null}if(!t)return null;let i=!this.isRegex&&!e;return i&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(i=this.matchCase),new s.SearchData(t,this.wordSeparators?(0,r.getMapForWordSeparators)(this.wordSeparators):null,i?this.searchString:null)}},t.isMultilineRegexSource=a,t.createFindMatch=l;class u{constructor(e){const t=[];let n=0;for(let r=0,i=e.length;r<i;r++)10===e.charCodeAt(r)&&(t[n++]=r);this.a=t}findLineFeedCountBeforeOffset(e){const t=this.a;let n=0,r=t.length-1;if(-1===r||e<=t[0])return 0;for(;n<r;){const i=n+((r-n)/2|0);t[i]>=e?r=i-1:t[i+1]>=e?(n=i,r=i):n=i+1}return n+1}}function c(e,t,n,r,i){return function(e,t,n,r,i){if(0===r)return!0;const o=t.charCodeAt(r-1);if(0!==e.get(o)||13===o||10===o)return!0;if(i>0){const n=t.charCodeAt(r);if(0!==e.get(n))return!0}return!1}(e,t,0,r,i)&&function(e,t,n,r,i){if(r+i===n)return!0;const o=t.charCodeAt(r+i);if(0!==e.get(o)||13===o||10===o)return!0;if(i>0){const n=t.charCodeAt(r+i-1);if(0!==e.get(n))return!0}return!1}(e,t,n,r,i)}t.TextModelSearch=class{static findMatches(e,t,n,r,i){const o=t.parseSearchRequest();return o?o.regex.multiline?this.b(e,n,new d(o.wordSeparators,o.regex),r,i):this.c(e,n,o,r,i):[]}static a(e,t,n,r,i,s){let a,l,u=0;if(r?(u=r.findLineFeedCountBeforeOffset(i),a=t+i+u):a=t+i,r){const e=r.findLineFeedCountBeforeOffset(i+s.length)-u;l=a+s.length+e}else l=a+s.length;const c=e.getPositionAt(a),d=e.getPositionAt(l);return new o.Range(c.lineNumber,c.column,d.lineNumber,d.column)}static b(e,t,n,r,i){const o=e.getOffsetAt(t.getStartPosition()),s=e.getValueInRange(t,1),a="\r\n"===e.getEOL()?new u(s):null,c=[];let d,h=0;for(n.reset(0);d=n.next(s);)if(c[h++]=l(this.a(e,o,s,a,d.index,d[0]),d,r),h>=i)return c;return c}static c(e,t,n,r,i){const o=[];let s=0;if(t.startLineNumber===t.endLineNumber){const a=e.getLineContent(t.startLineNumber).substring(t.startColumn-1,t.endColumn-1);return s=this.d(n,a,t.startLineNumber,t.startColumn-1,s,o,r,i),o}const a=e.getLineContent(t.startLineNumber).substring(t.startColumn-1);s=this.d(n,a,t.startLineNumber,t.startColumn-1,s,o,r,i);for(let a=t.startLineNumber+1;a<t.endLineNumber&&s<i;a++)s=this.d(n,e.getLineContent(a),a,0,s,o,r,i);if(s<i){const a=e.getLineContent(t.endLineNumber).substring(0,t.endColumn-1);s=this.d(n,a,t.endLineNumber,0,s,o,r,i)}return o}static d(e,t,n,r,i,a,u,h){const f=e.wordSeparators;if(!u&&e.simpleSearch){const l=e.simpleSearch,u=l.length,d=t.length;let g=-u;for(;-1!==(g=t.indexOf(l,g+u));)if((!f||c(f,t,d,g,u))&&(a[i++]=new s.FindMatch(new o.Range(n,g+1+r,n,g+1+u+r),null),i>=h))return i;return i}const g=new d(e.wordSeparators,e.regex);let m;g.reset(0);do{if(m=g.next(t),m&&(a[i++]=l(new o.Range(n,m.index+1+r,n,m.index+1+m[0].length+r),m,u),i>=h))return i}while(m);return i}static findNextMatch(e,t,n,r){const i=t.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.e(e,n,o,r):this.f(e,n,o,r)}static e(e,t,n,r){const s=new i.Position(t.lineNumber,1),a=e.getOffsetAt(s),c=e.getLineCount(),d=e.getValueInRange(new o.Range(s.lineNumber,s.column,c,e.getLineMaxColumn(c)),1),h="\r\n"===e.getEOL()?new u(d):null;n.reset(t.column-1);const f=n.next(d);return f?l(this.a(e,a,d,h,f.index,f[0]),f,r):1!==t.lineNumber||1!==t.column?this.e(e,new i.Position(1,1),n,r):null}static f(e,t,n,r){const i=e.getLineCount(),o=t.lineNumber,s=e.getLineContent(o),a=this.g(n,s,o,t.column,r);if(a)return a;for(let t=1;t<=i;t++){const s=(o+t-1)%i,a=e.getLineContent(s+1),l=this.g(n,a,s+1,1,r);if(l)return l}return null}static g(e,t,n,r,i){e.reset(r-1);const s=e.next(t);return s?l(new o.Range(n,s.index+1,n,s.index+1+s[0].length),s,i):null}static findPreviousMatch(e,t,n,r){const i=t.parseSearchRequest();if(!i)return null;const o=new d(i.wordSeparators,i.regex);return i.regex.multiline?this.h(e,n,o,r):this.j(e,n,o,r)}static h(e,t,n,r){const s=this.b(e,new o.Range(1,1,t.lineNumber,t.column),n,r,9990);if(s.length>0)return s[s.length-1];const a=e.getLineCount();return t.lineNumber!==a||t.column!==e.getLineMaxColumn(a)?this.h(e,new i.Position(a,e.getLineMaxColumn(a)),n,r):null}static j(e,t,n,r){const i=e.getLineCount(),o=t.lineNumber,s=e.getLineContent(o).substring(0,t.column-1),a=this.k(n,s,o,r);if(a)return a;for(let t=1;t<=i;t++){const s=(i+o-t-1)%i,a=e.getLineContent(s+1),l=this.k(n,a,s+1,r);if(l)return l}return null}static k(e,t,n,r){let i,s=null;for(e.reset(0);i=e.next(t);)s=l(new o.Range(n,i.index+1,n,i.index+1+i[0].length),i,r);return s}},t.isValidMatch=c;class d{constructor(e,t){this._wordSeparators=e,this.a=t,this.b=-1,this.c=0}reset(e){this.a.lastIndex=e,this.b=-1,this.c=0}next(e){const t=e.length;let r;do{if(this.b+this.c===t||(r=this.a.exec(e),!r))return null;const i=r.index,o=r[0].length;if(i===this.b&&o===this.c){if(0===o){n.getNextCodePoint(e,t,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=i,this.c=o,!this._wordSeparators||c(this._wordSeparators,e,t,i,o))return r}while(r);return null}}t.Searcher=d})),n(i[46],o([0,1,2,45,4,9,20]),(function(e,t,n,r,i,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeTextModelHighlighter=void 0,t.UnicodeTextModelHighlighter=class{static computeUnicodeHighlights(e,t,l){const u=l?l.startLineNumber:1,c=l?l.endLineNumber:e.getLineCount(),d=new a(t),h=d.getCandidateCodePoints();let f;var g;f="allNonBasicAscii"===h?new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):new RegExp((g=Array.from(h),`[${i.escapeRegExpCharacters(g.map((e=>String.fromCodePoint(e))).join(""))}]`),"g");const m=new r.Searcher(null,f),p=[];let b,y=!1,C=0,v=0,E=0;e:for(let t=u,r=c;t<=r;t++){const r=e.getLineContent(t),a=r.length;m.reset(0);do{if(b=m.next(r),b){let e=b.index,l=b.index+b[0].length;if(e>0){const t=r.charCodeAt(e-1);i.isHighSurrogate(t)&&e--}if(l+1<a){const e=r.charCodeAt(l-1);i.isHighSurrogate(e)&&l++}const u=r.substring(e,l);let c=(0,s.getWordAtText)(e+1,s.DEFAULT_WORD_REGEXP,r,0);c&&c.endColumn<=e+1&&(c=null);const h=d.shouldHighlightNonBasicASCII(u,c?c.word:null);if(0!==h){3===h?C++:2===h?v++:1===h?E++:(0,o.assertNever)(h);const r=1e3;if(p.length>=r){y=!0;break e}p.push(new n.Range(t,e+1,t,l+1))}}}while(b)}return{ranges:p,hasMore:y,ambiguousCharacterCount:C,invisibleCharacterCount:v,nonBasicAsciiCharacterCount:E}}static computeUnicodeHighlightReason(e,t){const n=new a(t);switch(n.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const r=e.codePointAt(0),o=n.ambiguousCharacters.getPrimaryConfusable(r),s=i.AmbiguousCharacters.getLocales().filter((e=>!i.AmbiguousCharacters.getInstance(new Set([...t.allowedLocales,e])).isAmbiguous(r)));return{kind:0,confusableWith:String.fromCodePoint(o),notAmbiguousInLocales:s}}case 1:return{kind:2}}}};class a{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.AmbiguousCharacters.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const t of i.InvisibleCharacters.codePoints)l(String.fromCodePoint(t))||e.add(t);if(this.b.ambiguousCharacters)for(const t of this.ambiguousCharacters.getConfusableCodePoints())e.add(t);for(const t of this.a)e.delete(t);return e}shouldHighlightNonBasicASCII(e,t){const n=e.codePointAt(0);if(this.a.has(n))return 0;if(this.b.nonBasicASCII)return 1;let r=!1,o=!1;if(t)for(const e of t){const t=e.codePointAt(0),n=i.isBasicASCII(e);r=r||n,!n&&!this.ambiguousCharacters.isAmbiguous(t)&&!i.InvisibleCharacters.isInvisibleCharacter(t)&&(o=!0)}return!r&&o?0:this.b.invisibleCharacters&&!l(e)&&i.InvisibleCharacters.isInvisibleCharacter(n)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(n)?3:0}}function l(e){return" "===e||"\n"===e||"\t"===e}})),n(i[47],o([0,1]),(function(e,t){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0,(n=t.AccessibilitySupport||(t.AccessibilitySupport={}))[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled",function(e){e[e.Invoke=1]="Invoke",e[e.Auto=2]="Auto"}(t.CodeActionTriggerType||(t.CodeActionTriggerType={})),function(e){e[e.None=0]="None",e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={})),function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"}(t.CompletionItemKind||(t.CompletionItemKind={})),function(e){e[e.Deprecated=1]="Deprecated"}(t.CompletionItemTag||(t.CompletionItemTag={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e[e.EXACT=0]="EXACT",e[e.ABOVE=1]="ABOVE",e[e.BELOW=2]="BELOW"}(t.ContentWidgetPositionPreference||(t.ContentWidgetPositionPreference={})),function(e){e[e.NotSet=0]="NotSet",e[e.ContentFlush=1]="ContentFlush",e[e.RecoverFromMarkers=2]="RecoverFromMarkers",e[e.Explicit=3]="Explicit",e[e.Paste=4]="Paste",e[e.Undo=5]="Undo",e[e.Redo=6]="Redo"}(t.CursorChangeReason||(t.CursorChangeReason={})),function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.DefaultEndOfLine||(t.DefaultEndOfLine={})),function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={})),function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"}(t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={})),function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingDelete=6]="autoClosingDelete",e[e.autoClosingOvertype=7]="autoClosingOvertype",e[e.autoClosingQuotes=8]="autoClosingQuotes",e[e.autoIndent=9]="autoIndent",e[e.automaticLayout=10]="automaticLayout",e[e.autoSurround=11]="autoSurround",e[e.bracketPairColorization=12]="bracketPairColorization",e[e.guides=13]="guides",e[e.codeLens=14]="codeLens",e[e.codeLensFontFamily=15]="codeLensFontFamily",e[e.codeLensFontSize=16]="codeLensFontSize",e[e.colorDecorators=17]="colorDecorators",e[e.colorDecoratorsLimit=18]="colorDecoratorsLimit",e[e.columnSelection=19]="columnSelection",e[e.comments=20]="comments",e[e.contextmenu=21]="contextmenu",e[e.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",e[e.cursorBlinking=23]="cursorBlinking",e[e.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",e[e.cursorStyle=25]="cursorStyle",e[e.cursorSurroundingLines=26]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",e[e.cursorWidth=28]="cursorWidth",e[e.disableLayerHinting=29]="disableLayerHinting",e[e.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",e[e.domReadOnly=31]="domReadOnly",e[e.dragAndDrop=32]="dragAndDrop",e[e.dropIntoEditor=33]="dropIntoEditor",e[e.emptySelectionClipboard=34]="emptySelectionClipboard",e[e.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",e[e.extraEditorClassName=36]="extraEditorClassName",e[e.fastScrollSensitivity=37]="fastScrollSensitivity",e[e.find=38]="find",e[e.fixedOverflowWidgets=39]="fixedOverflowWidgets",e[e.folding=40]="folding",e[e.foldingStrategy=41]="foldingStrategy",e[e.foldingHighlight=42]="foldingHighlight",e[e.foldingImportsByDefault=43]="foldingImportsByDefault",e[e.foldingMaximumRegions=44]="foldingMaximumRegions",e[e.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=46]="fontFamily",e[e.fontInfo=47]="fontInfo",e[e.fontLigatures=48]="fontLigatures",e[e.fontSize=49]="fontSize",e[e.fontWeight=50]="fontWeight",e[e.fontVariations=51]="fontVariations",e[e.formatOnPaste=52]="formatOnPaste",e[e.formatOnType=53]="formatOnType",e[e.glyphMargin=54]="glyphMargin",e[e.gotoLocation=55]="gotoLocation",e[e.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",e[e.hover=57]="hover",e[e.inDiffEditor=58]="inDiffEditor",e[e.inlineSuggest=59]="inlineSuggest",e[e.letterSpacing=60]="letterSpacing",e[e.lightbulb=61]="lightbulb",e[e.lineDecorationsWidth=62]="lineDecorationsWidth",e[e.lineHeight=63]="lineHeight",e[e.lineNumbers=64]="lineNumbers",e[e.lineNumbersMinChars=65]="lineNumbersMinChars",e[e.linkedEditing=66]="linkedEditing",e[e.links=67]="links",e[e.matchBrackets=68]="matchBrackets",e[e.minimap=69]="minimap",e[e.mouseStyle=70]="mouseStyle",e[e.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=72]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",e[e.multiCursorModifier=74]="multiCursorModifier",e[e.multiCursorPaste=75]="multiCursorPaste",e[e.multiCursorLimit=76]="multiCursorLimit",e[e.occurrencesHighlight=77]="occurrencesHighlight",e[e.overviewRulerBorder=78]="overviewRulerBorder",e[e.overviewRulerLanes=79]="overviewRulerLanes",e[e.padding=80]="padding",e[e.parameterHints=81]="parameterHints",e[e.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",e[e.quickSuggestions=84]="quickSuggestions",e[e.quickSuggestionsDelay=85]="quickSuggestionsDelay",e[e.readOnly=86]="readOnly",e[e.renameOnType=87]="renameOnType",e[e.renderControlCharacters=88]="renderControlCharacters",e[e.renderFinalNewline=89]="renderFinalNewline",e[e.renderLineHighlight=90]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=92]="renderValidationDecorations",e[e.renderWhitespace=93]="renderWhitespace",e[e.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",e[e.roundedSelection=95]="roundedSelection",e[e.rulers=96]="rulers",e[e.scrollbar=97]="scrollbar",e[e.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=99]="scrollBeyondLastLine",e[e.scrollPredominantAxis=100]="scrollPredominantAxis",e[e.selectionClipboard=101]="selectionClipboard",e[e.selectionHighlight=102]="selectionHighlight",e[e.selectOnLineNumbers=103]="selectOnLineNumbers",e[e.showFoldingControls=104]="showFoldingControls",e[e.showUnused=105]="showUnused",e[e.snippetSuggestions=106]="snippetSuggestions",e[e.smartSelect=107]="smartSelect",e[e.smoothScrolling=108]="smoothScrolling",e[e.stickyScroll=109]="stickyScroll",e[e.stickyTabStops=110]="stickyTabStops",e[e.stopRenderingLineAfter=111]="stopRenderingLineAfter",e[e.suggest=112]="suggest",e[e.suggestFontSize=113]="suggestFontSize",e[e.suggestLineHeight=114]="suggestLineHeight",e[e.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",e[e.suggestSelection=116]="suggestSelection",e[e.tabCompletion=117]="tabCompletion",e[e.tabIndex=118]="tabIndex",e[e.unicodeHighlighting=119]="unicodeHighlighting",e[e.unusualLineTerminators=120]="unusualLineTerminators",e[e.useShadowDOM=121]="useShadowDOM",e[e.useTabStops=122]="useTabStops",e[e.wordBreak=123]="wordBreak",e[e.wordSeparators=124]="wordSeparators",e[e.wordWrap=125]="wordWrap",e[e.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=128]="wordWrapColumn",e[e.wordWrapOverride1=129]="wordWrapOverride1",e[e.wordWrapOverride2=130]="wordWrapOverride2",e[e.wrappingIndent=131]="wrappingIndent",e[e.wrappingStrategy=132]="wrappingStrategy",e[e.showDeprecated=133]="showDeprecated",e[e.inlayHints=134]="inlayHints",e[e.editorClassName=135]="editorClassName",e[e.pixelRatio=136]="pixelRatio",e[e.tabFocusMode=137]="tabFocusMode",e[e.layoutInfo=138]="layoutInfo",e[e.wrappingInfo=139]="wrappingInfo"}(t.EditorOption||(t.EditorOption={})),function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLinePreference||(t.EndOfLinePreference={})),function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(t.EndOfLineSequence||(t.EndOfLineSequence={})),function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(t.IndentAction||(t.IndentAction={})),function(e){e[e.Both=0]="Both",e[e.Right=1]="Right",e[e.Left=2]="Left",e[e.None=3]="None"}(t.InjectedTextCursorStops||(t.InjectedTextCursorStops={})),function(e){e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"}(t.InlayHintKind||(t.InlayHintKind={})),function(e){e[e.Automatic=0]="Automatic",e[e.Explicit=1]="Explicit"}(t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={})),function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"}(t.KeyCode||(t.KeyCode={})),function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"}(t.MarkerSeverity||(t.MarkerSeverity={})),function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"}(t.MarkerTag||(t.MarkerTag={})),function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"}(t.MinimapPosition||(t.MinimapPosition={})),function(e){e[e.UNKNOWN=0]="UNKNOWN",e[e.TEXTAREA=1]="TEXTAREA",e[e.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",e[e.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",e[e.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",e[e.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",e[e.CONTENT_TEXT=6]="CONTENT_TEXT",e[e.CONTENT_EMPTY=7]="CONTENT_EMPTY",e[e.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",e[e.CONTENT_WIDGET=9]="CONTENT_WIDGET",e[e.OVERVIEW_RULER=10]="OVERVIEW_RULER",e[e.SCROLLBAR=11]="SCROLLBAR",e[e.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",e[e.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"}(t.MouseTargetType||(t.MouseTargetType={})),function(e){e[e.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",e[e.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",e[e.TOP_CENTER=2]="TOP_CENTER"}(t.OverlayWidgetPositionPreference||(t.OverlayWidgetPositionPreference={})),function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"}(t.OverviewRulerLane||(t.OverviewRulerLane={})),function(e){e[e.Left=0]="Left",e[e.Right=1]="Right",e[e.None=2]="None",e[e.LeftOfInjectedText=3]="LeftOfInjectedText",e[e.RightOfInjectedText=4]="RightOfInjectedText"}(t.PositionAffinity||(t.PositionAffinity={})),function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"}(t.RenderLineNumbersType||(t.RenderLineNumbersType={})),function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"}(t.RenderMinimap||(t.RenderMinimap={})),function(e){e[e.Smooth=0]="Smooth",e[e.Immediate=1]="Immediate"}(t.ScrollType||(t.ScrollType={})),function(e){e[e.Auto=1]="Auto",e[e.Hidden=2]="Hidden",e[e.Visible=3]="Visible"}(t.ScrollbarVisibility||(t.ScrollbarVisibility={})),function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(t.SelectionDirection||(t.SelectionDirection={})),function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={})),function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(t.SymbolKind||(t.SymbolKind={})),function(e){e[e.Deprecated=1]="Deprecated"}(t.SymbolTag||(t.SymbolTag={})),function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"}(t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={})),function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(t.TextEditorCursorStyle||(t.TextEditorCursorStyle={})),function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(t.TrackedRangeStickiness||(t.TrackedRangeStickiness={})),function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"}(t.WrappingIndent||(t.WrappingIndent={}))})),n(i[48],o([23,55]),(function(e,t){return e.create("vs/base/common/platform",t)})),n(i[5],o([0,1,48]),(function(e,t,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.setTimeout0=t.setTimeout0IsFaster=t.language=t.userAgent=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let i,o,s,a,l=!1,u=!1,c=!1,d=!1,h=!1,f=!1,g=!1,m=!1,p=!1,b=!1,y=t.LANGUAGE_DEFAULT;t.globals="object"==typeof self?self:"object"==typeof global?global:{},typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?a=t.globals.vscode.process:typeof process<"u"&&(a=process);const C="string"==typeof(null===(r=a?.versions)||void 0===r?void 0:r.electron);if("object"!=typeof navigator||C&&"renderer"===a?.type)if("object"==typeof a){l="win32"===a.platform,u="darwin"===a.platform,c="linux"===a.platform,d=c&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,g=C,p=!!a.env.CI||!!a.env.BUILD_ARTIFACTSTAGINGDIRECTORY,i=t.LANGUAGE_DEFAULT,y=t.LANGUAGE_DEFAULT;const e=a.env.VSCODE_NLS_CONFIG;if(e)try{const n=JSON.parse(e),r=n.availableLanguages["*"];i=n.locale,y=r||t.LANGUAGE_DEFAULT,o=n._translationsConfigFile}catch{}h=!0}else console.error("Unable to resolve platform.");else s=navigator.userAgent,l=s.indexOf("Windows")>=0,u=s.indexOf("Macintosh")>=0,m=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,c=s.indexOf("Linux")>=0,b=s?.indexOf("Mobi")>=0,f=!0,i=n.getConfiguredDefaultLocale(n.localize(0,null))||t.LANGUAGE_DEFAULT,y=i;let v=0;u?v=1:l?v=3:c&&(v=2),t.isWindows=l,t.isMacintosh=u,t.isLinux=c,t.isNative=h,t.isWeb=f,t.isWebWorker=f&&"function"==typeof t.globals.importScripts,t.isIOS=m,t.isMobile=b,t.userAgent=s,t.language=y,t.setTimeout0IsFaster="function"==typeof t.globals.postMessage&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const e=[];t.globals.addEventListener("message",(t=>{if(t.data&&t.data.vscodeScheduleAsyncWork)for(let n=0,r=e.length;n<r;n++){const r=e[n];if(r.id===t.data.vscodeScheduleAsyncWork)return e.splice(n,1),void r.callback()}}));let n=0;return r=>{const i=++n;e.push({id:i,callback:r}),t.globals.postMessage({vscodeScheduleAsyncWork:i},"*")}}return e=>setTimeout(e)})(),t.OS=u||m?2:l?1:3;let E=!0,L=!1;t.isLittleEndian=function(){if(!L){L=!0;const e=new Uint8Array(2);e[0]=1,e[1]=2,E=513===new Uint16Array(e.buffer)[0]}return E},t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)})),n(i[49],o([0,1,5]),(function(e,t,n){"use strict";let r;if(Object.defineProperty(t,"__esModule",{value:!0}),t.platform=t.env=t.cwd=void 0,typeof n.globals.vscode<"u"&&typeof n.globals.vscode.process<"u"){const e=n.globals.vscode.process;r={get platform(){return e.platform},get arch(){return e.arch},get env(){return e.env},cwd:()=>e.cwd()}}else r=typeof process<"u"?{get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd:()=>process.env.VSCODE_CWD||process.cwd()}:{get platform(){return n.isWindows?"win32":n.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd:()=>"/"};t.cwd=r.cwd,t.env=r.env,t.platform=r.platform})),n(i[50],o([0,1,49]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sep=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.normalize=t.posix=t.win32=void 0;const r=46,i=47,o=92,s=58;class a extends Error{constructor(e,t,n){let r;"string"==typeof t&&0===t.indexOf("not ")?(r="must not be",t=t.replace(/^not /,"")):r="must be";const i=-1!==e.indexOf(".")?"property":"argument";let o=`The "${e}" ${i} ${r} of type ${t}`;o+=". Received type "+typeof n,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function l(e,t){if("string"!=typeof e)throw new a(t,"string",e)}const u="win32"===n.platform;function c(e){return e===i||e===o}function d(e){return e===i}function h(e){return e>=65&&e<=90||e>=97&&e<=122}function f(e,t,n,o){let s="",a=0,l=-1,u=0,c=0;for(let d=0;d<=e.length;++d){if(d<e.length)c=e.charCodeAt(d);else{if(o(c))break;c=i}if(o(c)){if(l!==d-1&&1!==u)if(2===u){if(s.length<2||2!==a||s.charCodeAt(s.length-1)!==r||s.charCodeAt(s.length-2)!==r){if(s.length>2){const e=s.lastIndexOf(n);-1===e?(s="",a=0):(s=s.slice(0,e),a=s.length-1-s.lastIndexOf(n)),l=d,u=0;continue}if(0!==s.length){s="",a=0,l=d,u=0;continue}}t&&(s+=s.length>0?`${n}..`:"..",a=2)}else s.length>0?s+=`${n}${e.slice(l+1,d)}`:s=e.slice(l+1,d),a=d-l-1;l=d,u=0}else c===r&&-1!==u?++u:u=-1}return s}function g(e,t){!function(e){if(null===e||"object"!=typeof e)throw new a("pathObject","Object",e)}(t);const n=t.dir||t.root,r=t.base||`${t.name||""}${t.ext||""}`;return n?n===t.root?`${n}${r}`:`${n}${e}${r}`:r}t.win32={resolve(...e){let t="",r="",i=!1;for(let a=e.length-1;a>=-1;a--){let u;if(a>=0){if(u=e[a],l(u,"path"),0===u.length)continue}else 0===t.length?u=n.cwd():(u=n.env[`=${t}`]||n.cwd(),(void 0===u||u.slice(0,2).toLowerCase()!==t.toLowerCase()&&u.charCodeAt(2)===o)&&(u=`${t}\\`));const d=u.length;let f=0,g="",m=!1;const p=u.charCodeAt(0);if(1===d)c(p)&&(f=1,m=!0);else if(c(p))if(m=!0,c(u.charCodeAt(1))){let e=2,t=e;for(;e<d&&!c(u.charCodeAt(e));)e++;if(e<d&&e!==t){const n=u.slice(t,e);for(t=e;e<d&&c(u.charCodeAt(e));)e++;if(e<d&&e!==t){for(t=e;e<d&&!c(u.charCodeAt(e));)e++;(e===d||e!==t)&&(g=`\\\\${n}\\${u.slice(t,e)}`,f=e)}}}else f=1;else h(p)&&u.charCodeAt(1)===s&&(g=u.slice(0,2),f=2,d>2&&c(u.charCodeAt(2))&&(m=!0,f=3));if(g.length>0)if(t.length>0){if(g.toLowerCase()!==t.toLowerCase())continue}else t=g;if(i){if(t.length>0)break}else if(r=`${u.slice(f)}\\${r}`,i=m,m&&t.length>0)break}return r=f(r,!i,"\\",c),i?`${t}\\${r}`:`${t}${r}`||"."},normalize(e){l(e,"path");const t=e.length;if(0===t)return".";let n,r=0,i=!1;const o=e.charCodeAt(0);if(1===t)return d(o)?"\\":e;if(c(o))if(i=!0,c(e.charCodeAt(1))){let i=2,o=i;for(;i<t&&!c(e.charCodeAt(i));)i++;if(i<t&&i!==o){const s=e.slice(o,i);for(o=i;i<t&&c(e.charCodeAt(i));)i++;if(i<t&&i!==o){for(o=i;i<t&&!c(e.charCodeAt(i));)i++;if(i===t)return`\\\\${s}\\${e.slice(o)}\\`;i!==o&&(n=`\\\\${s}\\${e.slice(o,i)}`,r=i)}}}else r=1;else h(o)&&e.charCodeAt(1)===s&&(n=e.slice(0,2),r=2,t>2&&c(e.charCodeAt(2))&&(i=!0,r=3));let a=r<t?f(e.slice(r),!i,"\\",c):"";return 0===a.length&&!i&&(a="."),a.length>0&&c(e.charCodeAt(t-1))&&(a+="\\"),void 0===n?i?`\\${a}`:a:i?`${n}\\${a}`:`${n}${a}`},isAbsolute(e){l(e,"path");const t=e.length;if(0===t)return!1;const n=e.charCodeAt(0);return c(n)||t>2&&h(n)&&e.charCodeAt(1)===s&&c(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let n,r;for(let t=0;t<e.length;++t){const i=e[t];l(i,"path"),i.length>0&&(void 0===n?n=r=i:n+=`\\${i}`)}if(void 0===n)return".";let i=!0,o=0;if("string"==typeof r&&c(r.charCodeAt(0))){++o;const e=r.length;e>1&&c(r.charCodeAt(1))&&(++o,e>2&&(c(r.charCodeAt(2))?++o:i=!1))}if(i){for(;o<n.length&&c(n.charCodeAt(o));)o++;o>=2&&(n=`\\${n.slice(o)}`)}return t.win32.normalize(n)},relative(e,n){if(l(e,"from"),l(n,"to"),e===n)return"";const r=t.win32.resolve(e),i=t.win32.resolve(n);if(r===i||(e=r.toLowerCase())===(n=i.toLowerCase()))return"";let s=0;for(;s<e.length&&e.charCodeAt(s)===o;)s++;let a=e.length;for(;a-1>s&&e.charCodeAt(a-1)===o;)a--;const u=a-s;let c=0;for(;c<n.length&&n.charCodeAt(c)===o;)c++;let d=n.length;for(;d-1>c&&n.charCodeAt(d-1)===o;)d--;const h=d-c,f=u<h?u:h;let g=-1,m=0;for(;m<f;m++){const t=e.charCodeAt(s+m);if(t!==n.charCodeAt(c+m))break;t===o&&(g=m)}if(m!==f){if(-1===g)return i}else{if(h>f){if(n.charCodeAt(c+m)===o)return i.slice(c+m+1);if(2===m)return i.slice(c+m)}u>f&&(e.charCodeAt(s+m)===o?g=m:2===m&&(g=3)),-1===g&&(g=0)}let p="";for(m=s+g+1;m<=a;++m)(m===a||e.charCodeAt(m)===o)&&(p+=0===p.length?"..":"\\..");return c+=g,p.length>0?`${p}${i.slice(c,d)}`:(i.charCodeAt(c)===o&&++c,i.slice(c,d))},toNamespacedPath(e){if("string"!=typeof e||0===e.length)return e;const n=t.win32.resolve(e);if(n.length<=2)return e;if(n.charCodeAt(0)===o){if(n.charCodeAt(1)===o){const e=n.charCodeAt(2);if(63!==e&&e!==r)return`\\\\?\\UNC\\${n.slice(2)}`}}else if(h(n.charCodeAt(0))&&n.charCodeAt(1)===s&&n.charCodeAt(2)===o)return`\\\\?\\${n}`;return e},dirname(e){l(e,"path");const t=e.length;if(0===t)return".";let n=-1,r=0;const i=e.charCodeAt(0);if(1===t)return c(i)?e:".";if(c(i)){if(n=r=1,c(e.charCodeAt(1))){let i=2,o=i;for(;i<t&&!c(e.charCodeAt(i));)i++;if(i<t&&i!==o){for(o=i;i<t&&c(e.charCodeAt(i));)i++;if(i<t&&i!==o){for(o=i;i<t&&!c(e.charCodeAt(i));)i++;if(i===t)return e;i!==o&&(n=r=i+1)}}}}else h(i)&&e.charCodeAt(1)===s&&(n=t>2&&c(e.charCodeAt(2))?3:2,r=n);let o=-1,a=!0;for(let n=t-1;n>=r;--n)if(c(e.charCodeAt(n))){if(!a){o=n;break}}else a=!1;if(-1===o){if(-1===n)return".";o=n}return e.slice(0,o)},basename(e,t){void 0!==t&&l(t,"ext"),l(e,"path");let n,r=0,i=-1,o=!0;if(e.length>=2&&h(e.charCodeAt(0))&&e.charCodeAt(1)===s&&(r=2),void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let s=t.length-1,a=-1;for(n=e.length-1;n>=r;--n){const l=e.charCodeAt(n);if(c(l)){if(!o){r=n+1;break}}else-1===a&&(o=!1,a=n+1),s>=0&&(l===t.charCodeAt(s)?-1==--s&&(i=n):(s=-1,i=a))}return r===i?i=a:-1===i&&(i=e.length),e.slice(r,i)}for(n=e.length-1;n>=r;--n)if(c(e.charCodeAt(n))){if(!o){r=n+1;break}}else-1===i&&(o=!1,i=n+1);return-1===i?"":e.slice(r,i)},extname(e){l(e,"path");let t=0,n=-1,i=0,o=-1,a=!0,u=0;e.length>=2&&e.charCodeAt(1)===s&&h(e.charCodeAt(0))&&(t=i=2);for(let s=e.length-1;s>=t;--s){const t=e.charCodeAt(s);if(c(t)){if(!a){i=s+1;break}}else-1===o&&(a=!1,o=s+1),t===r?-1===n?n=s:1!==u&&(u=1):-1!==n&&(u=-1)}return-1===n||-1===o||0===u||1===u&&n===o-1&&n===i+1?"":e.slice(n,o)},format:g.bind(null,"\\"),parse(e){l(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.length;let i=0,o=e.charCodeAt(0);if(1===n)return c(o)?(t.root=t.dir=e,t):(t.base=t.name=e,t);if(c(o)){if(i=1,c(e.charCodeAt(1))){let t=2,r=t;for(;t<n&&!c(e.charCodeAt(t));)t++;if(t<n&&t!==r){for(r=t;t<n&&c(e.charCodeAt(t));)t++;if(t<n&&t!==r){for(r=t;t<n&&!c(e.charCodeAt(t));)t++;t===n?i=t:t!==r&&(i=t+1)}}}}else if(h(o)&&e.charCodeAt(1)===s){if(n<=2)return t.root=t.dir=e,t;if(i=2,c(e.charCodeAt(2))){if(3===n)return t.root=t.dir=e,t;i=3}}i>0&&(t.root=e.slice(0,i));let a=-1,u=i,d=-1,f=!0,g=e.length-1,m=0;for(;g>=i;--g)if(o=e.charCodeAt(g),c(o)){if(!f){u=g+1;break}}else-1===d&&(f=!1,d=g+1),o===r?-1===a?a=g:1!==m&&(m=1):-1!==a&&(m=-1);return-1!==d&&(-1===a||0===m||1===m&&a===d-1&&a===u+1?t.base=t.name=e.slice(u,d):(t.name=e.slice(u,a),t.base=e.slice(u,d),t.ext=e.slice(a,d))),t.dir=u>0&&u!==i?e.slice(0,u-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(u){const e=/\\/g;return()=>{const t=n.cwd().replace(e,"/");return t.slice(t.indexOf("/"))}}return()=>n.cwd()})();t.posix={resolve(...e){let t="",n=!1;for(let r=e.length-1;r>=-1&&!n;r--){const o=r>=0?e[r]:m();l(o,"path"),0!==o.length&&(t=`${o}/${t}`,n=o.charCodeAt(0)===i)}return t=f(t,!n,"/",d),n?`/${t}`:t.length>0?t:"."},normalize(e){if(l(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===i,n=e.charCodeAt(e.length-1)===i;return 0===(e=f(e,!t,"/",d)).length?t?"/":n?"./":".":(n&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(l(e,"path"),e.length>0&&e.charCodeAt(0)===i),join(...e){if(0===e.length)return".";let n;for(let t=0;t<e.length;++t){const r=e[t];l(r,"path"),r.length>0&&(void 0===n?n=r:n+=`/${r}`)}return void 0===n?".":t.posix.normalize(n)},relative(e,n){if(l(e,"from"),l(n,"to"),e===n||(e=t.posix.resolve(e))===(n=t.posix.resolve(n)))return"";const r=e.length,o=r-1,s=n.length-1,a=o<s?o:s;let u=-1,c=0;for(;c<a;c++){const t=e.charCodeAt(1+c);if(t!==n.charCodeAt(1+c))break;t===i&&(u=c)}if(c===a)if(s>a){if(n.charCodeAt(1+c)===i)return n.slice(1+c+1);if(0===c)return n.slice(1+c)}else o>a&&(e.charCodeAt(1+c)===i?u=c:0===c&&(u=0));let d="";for(c=1+u+1;c<=r;++c)(c===r||e.charCodeAt(c)===i)&&(d+=0===d.length?"..":"/..");return`${d}${n.slice(1+u)}`},toNamespacedPath:e=>e,dirname(e){if(l(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===i;let n=-1,r=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===i){if(!r){n=t;break}}else r=!1;return-1===n?t?"/":".":t&&1===n?"//":e.slice(0,n)},basename(e,t){void 0!==t&&l(t,"ext"),l(e,"path");let n,r=0,o=-1,s=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let a=t.length-1,l=-1;for(n=e.length-1;n>=0;--n){const u=e.charCodeAt(n);if(u===i){if(!s){r=n+1;break}}else-1===l&&(s=!1,l=n+1),a>=0&&(u===t.charCodeAt(a)?-1==--a&&(o=n):(a=-1,o=l))}return r===o?o=l:-1===o&&(o=e.length),e.slice(r,o)}for(n=e.length-1;n>=0;--n)if(e.charCodeAt(n)===i){if(!s){r=n+1;break}}else-1===o&&(s=!1,o=n+1);return-1===o?"":e.slice(r,o)},extname(e){l(e,"path");let t=-1,n=0,o=-1,s=!0,a=0;for(let l=e.length-1;l>=0;--l){const u=e.charCodeAt(l);if(u!==i)-1===o&&(s=!1,o=l+1),u===r?-1===t?t=l:1!==a&&(a=1):-1!==t&&(a=-1);else if(!s){n=l+1;break}}return-1===t||-1===o||0===a||1===a&&t===o-1&&t===n+1?"":e.slice(t,o)},format:g.bind(null,"/"),parse(e){l(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const n=e.charCodeAt(0)===i;let o;n?(t.root="/",o=1):o=0;let s=-1,a=0,u=-1,c=!0,d=e.length-1,h=0;for(;d>=o;--d){const t=e.charCodeAt(d);if(t!==i)-1===u&&(c=!1,u=d+1),t===r?-1===s?s=d:1!==h&&(h=1):-1!==s&&(h=-1);else if(!c){a=d+1;break}}if(-1!==u){const r=0===a&&n?1:a;-1===s||0===h||1===h&&s===u-1&&s===a+1?t.base=t.name=e.slice(r,u):(t.name=e.slice(r,s),t.base=e.slice(r,u),t.ext=e.slice(s,u))}return a>0?t.dir=e.slice(0,a-1):n&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=u?t.win32.normalize:t.posix.normalize,t.resolve=u?t.win32.resolve:t.posix.resolve,t.relative=u?t.win32.relative:t.posix.relative,t.dirname=u?t.win32.dirname:t.posix.dirname,t.basename=u?t.win32.basename:t.posix.basename,t.extname=u?t.win32.extname:t.posix.extname,t.sep=u?t.win32.sep:t.posix.sep})),n(i[22],o([0,1,5]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const r=n.globals.performance&&"function"==typeof n.globals.performance.now;class i{static create(e=!0){return new i(e)}constructor(e){this.a=r&&e,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}elapsed(){return-1!==this.c?this.c-this.b:this.d()-this.b}d(){return this.a?n.globals.performance.now():Date.now()}}t.StopWatch=i})),n(i[7],o([0,1,8,13,10,15,22]),(function(e,t,n,r,i,o,s){"use strict";var a;Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.EventDeliveryQueue=t.Emitter=t.EventProfiling=t.Event=void 0,function(e){function t(e){return(t,n=null,r)=>{let i,o=!1;return i=e((e=>{if(!o)return i?i.dispose():o=!0,t.call(n,e)}),null,r),o&&i.dispose(),i}}function n(e,t,n){return a(((n,r=null,i)=>e((e=>n.call(r,t(e))),null,i)),n)}function r(e,t,n){return a(((n,r=null,i)=>e((e=>{t(e),n.call(r,e)}),null,i)),n)}function o(e,t,n){return a(((n,r=null,i)=>e((e=>t(e)&&n.call(r,e)),null,i)),n)}function s(e,t,r,i){let o=r;return n(e,(e=>(o=t(o,e),o)),i)}function a(e,t){let n;const r=new h({onWillAddFirstListener(){n=e(r.fire,r)},onDidRemoveLastListener(){n?.dispose()}});return t?.add(r),r.event}function l(e,t,n=100,r=!1,i,o){let s,a,l,u=0;const c=new h({leakWarningThreshold:i,onWillAddFirstListener(){s=e((e=>{u++,a=t(a,e),r&&!l&&(c.fire(a),a=void 0);const i=()=>{const e=a;a=void 0,l=void 0,(!r||u>1)&&c.fire(e),u=0};"number"==typeof n?(clearTimeout(l),l=setTimeout(i,n)):void 0===l&&(l=0,queueMicrotask(i))}))},onDidRemoveLastListener(){s.dispose()}});return o?.add(c),c.event}function u(e,t=(e,t)=>e===t,n){let r,i=!0;return o(e,(e=>{const n=i||!t(e,r);return i=!1,r=e,n}),n)}e.None=()=>i.Disposable.None,e.defer=function(e,t){return l(e,(()=>{}),0,void 0,void 0,t)},e.once=t,e.map=n,e.forEach=r,e.filter=o,e.signal=function(e){return e},e.any=function(...e){return(t,n=null,r)=>(0,i.combinedDisposable)(...e.map((e=>e((e=>t.call(n,e)),null,r))))},e.reduce=s,e.debounce=l,e.accumulate=function(t,n=0,r){return e.debounce(t,((e,t)=>e?(e.push(t),e):[t]),n,void 0,void 0,r)},e.latch=u,e.split=function(t,n,r){return[e.filter(t,n,r),e.filter(t,(e=>!n(e)),r)]},e.buffer=function(e,t=!1,n=[]){let r=n.slice(),i=e((e=>{r?r.push(e):s.fire(e)}));const o=()=>{r?.forEach((e=>s.fire(e))),r=null},s=new h({onWillAddFirstListener(){i||(i=e((e=>s.fire(e))))},onDidAddFirstListener(){r&&(t?setTimeout(o):o())},onDidRemoveLastListener(){i&&i.dispose(),i=null}});return s.event};class c{constructor(e){this.event=e,this.c=new i.DisposableStore}map(e){return new c(n(this.event,e,this.c))}forEach(e){return new c(r(this.event,e,this.c))}filter(e){return new c(o(this.event,e,this.c))}reduce(e,t){return new c(s(this.event,e,t,this.c))}latch(){return new c(u(this.event,void 0,this.c))}debounce(e,t=100,n=!1,r){return new c(l(this.event,e,t,n,r,this.c))}on(e,t,n){return this.event(e,t,n)}once(e,n,r){return t(this.event)(e,n,r)}dispose(){this.c.dispose()}}e.chain=function(e){return new c(e)},e.fromNodeEventEmitter=function(e,t,n=e=>e){const r=(...e)=>i.fire(n(...e)),i=new h({onWillAddFirstListener:()=>e.on(t,r),onDidRemoveLastListener:()=>e.removeListener(t,r)});return i.event},e.fromDOMEventEmitter=function(e,t,n=e=>e){const r=(...e)=>i.fire(n(...e)),i=new h({onWillAddFirstListener:()=>e.addEventListener(t,r),onDidRemoveLastListener:()=>e.removeEventListener(t,r)});return i.event},e.toPromise=function(e){return new Promise((n=>t(e)(n)))},e.runAndSubscribe=function(e,t){return t(void 0),e((e=>t(e)))},e.runAndSubscribeWithStore=function(e,t){let n=null;function r(e){n?.dispose(),n=new i.DisposableStore,t(e,n)}r(void 0);const o=e((e=>r(e)));return(0,i.toDisposable)((()=>{o.dispose(),n?.dispose()}))};class d{constructor(e,t){this.obs=e,this.c=0,this.d=!1;const n={onWillAddFirstListener:()=>{e.addObserver(this)},onDidRemoveLastListener:()=>{e.removeObserver(this)}};this.emitter=new h(n),t&&t.add(this.emitter)}beginUpdate(e){this.c++}handleChange(e,t){this.d=!0}endUpdate(e){0==--this.c&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}e.fromObservable=function(e,t){return new d(e,t).emitter.event}}(a=t.Event||(t.Event={}));class l{constructor(e){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${e}_${l.c++}`,l.all.add(this)}start(e){this.d=new s.StopWatch(!0),this.listenerCount=e}stop(){if(this.d){const e=this.d.elapsed();this.durations.push(e),this.elapsedOverall+=e,this.invocationCount+=1,this.d=void 0}}}l.all=new Set,l.c=0,t.EventProfiling=l;class u{constructor(e,t=Math.random().toString(18).slice(2,5)){this.threshold=e,this.name=t,this.d=0}dispose(){var e;null===(e=this.c)||void 0===e||e.clear()}check(e,t){const n=this.threshold;if(n<=0||t<n)return;this.c||(this.c=new Map);const r=this.c.get(e.value)||0;if(this.c.set(e.value,r+1),this.d-=1,this.d<=0){this.d=.5*n;let e,r=0;for(const[t,n]of this.c)(!e||r<n)&&(e=t,r=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${r}):`),console.warn(e)}return()=>{const t=this.c.get(e.value)||0;this.c.set(e.value,t-1)}}}class c{static create(){var e;return new c(null!==(e=(new Error).stack)&&void 0!==e?e:"")}constructor(e){this.value=e}print(){console.warn(this.value.split("\n").slice(2).join("\n"))}}class d{constructor(e,t,n){this.callback=e,this.callbackThis=t,this.stack=n,this.subscription=new i.SafeDisposable}invoke(e){this.callback.call(this.callbackThis,e)}}class h{constructor(e){var t,n,r,i,o;this.j=!1,this.d=e,this.f=(null===(t=this.d)||void 0===t?void 0:t.leakWarningThreshold)?new u(null!==(r=null===(n=this.d)||void 0===n?void 0:n.leakWarningThreshold)&&void 0!==r?r:-1):void 0,this.g=null!==(i=this.d)&&void 0!==i&&i._profName?new l(this.d._profName):void 0,this.m=null===(o=this.d)||void 0===o?void 0:o.deliveryQueue}dispose(){var e,t,n,r;this.j||(this.j=!0,this.n&&this.n.clear(),null===(e=this.m)||void 0===e||e.clear(this),null===(n=null===(t=this.d)||void 0===t?void 0:t.onDidRemoveLastListener)||void 0===n||n.call(t),null===(r=this.f)||void 0===r||r.dispose())}get event(){return this.l||(this.l=(e,t,n)=>{var r,s,a;if(this.n||(this.n=new o.LinkedList),this.f&&this.n.size>3*this.f.threshold)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const l=this.n.isEmpty();let u,h;l&&(null===(r=this.d)||void 0===r?void 0:r.onWillAddFirstListener)&&this.d.onWillAddFirstListener(this),this.f&&this.n.size>=Math.ceil(.2*this.f.threshold)&&(h=c.create(),u=this.f.check(h,this.n.size+1));const f=new d(e,t,h),g=this.n.push(f);l&&(null===(s=this.d)||void 0===s?void 0:s.onDidAddFirstListener)&&this.d.onDidAddFirstListener(this),null!==(a=this.d)&&void 0!==a&&a.onDidAddListener&&this.d.onDidAddListener(this,e,t);const m=f.subscription.set((()=>{u?.(),this.j||(g(),this.d&&this.d.onDidRemoveLastListener&&(this.n&&!this.n.isEmpty()||this.d.onDidRemoveLastListener(this)))}));return n instanceof i.DisposableStore?n.add(m):Array.isArray(n)&&n.push(m),m}),this.l}fire(e){var t,n;if(this.n){this.m||(this.m=new g);for(const t of this.n)this.m.push(this,t,e);null===(t=this.g)||void 0===t||t.start(this.m.size),this.m.deliver(),null===(n=this.g)||void 0===n||n.stop()}}hasListeners(){return!!this.n&&!this.n.isEmpty()}}t.Emitter=h;class f{constructor(){this.c=new o.LinkedList}get size(){return this.c.size}push(e,t,n){this.c.push(new m(e,t,n))}clear(e){const t=new o.LinkedList;for(const n of this.c)n.emitter!==e&&t.push(n);this.c=t}deliver(){for(;this.c.size>0;){const e=this.c.shift();try{e.listener.invoke(e.event)}catch(e){(0,n.onUnexpectedError)(e)}}}}t.EventDeliveryQueue=f;class g extends f{clear(e){this.c.clear()}}class m{constructor(e,t,n){this.emitter=e,this.listener=t,this.event=n}}class p extends h{constructor(e){super(e),this.c=0,this.h=new o.LinkedList,this.k=e?.merge}pause(){this.c++}resume(){if(0!==this.c&&0==--this.c)if(this.k){if(this.h.size>0){const e=Array.from(this.h);this.h.clear(),super.fire(this.k(e))}}else for(;!this.c&&0!==this.h.size;)super.fire(this.h.shift())}fire(e){this.n&&(0!==this.c?this.h.push(e):super.fire(e))}}t.PauseableEmitter=p,t.DebounceEmitter=class extends p{constructor(e){var t;super(e),this.o=null!==(t=e.delay)&&void 0!==t?t:100}fire(e){this.p||(this.pause(),this.p=setTimeout((()=>{this.p=void 0,this.resume()}),this.o)),super.fire(e)}},t.MicrotaskEmitter=class extends h{constructor(e){super(e),this.c=[],this.h=e?.merge}fire(e){!this.hasListeners()||(this.c.push(e),1===this.c.length&&queueMicrotask((()=>{this.h?super.fire(this.h(this.c)):this.c.forEach((e=>super.fire(e))),this.c=[]})))}},t.EventMultiplexer=class{constructor(){this.d=!1,this.f=[],this.c=new h({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(e){const t={event:e,listener:null};return this.f.push(t),this.d&&this.j(t),(0,i.toDisposable)((0,r.once)((()=>{this.d&&this.k(t);const e=this.f.indexOf(t);this.f.splice(e,1)})))}g(){this.d=!0,this.f.forEach((e=>this.j(e)))}h(){this.d=!1,this.f.forEach((e=>this.k(e)))}j(e){e.listener=e.event((e=>this.c.fire(e)))}k(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.c.dispose()}},t.EventBufferer=class{constructor(){this.c=[]}wrapEvent(e){return(t,n,r)=>e((e=>{const r=this.c[this.c.length-1];r?r.push((()=>t.call(n,e))):t.call(n,e)}),void 0,r)}bufferEvents(e){const t=[];this.c.push(t);const n=e();return this.c.pop(),t.forEach((e=>e())),n}},t.Relay=class{constructor(){this.c=!1,this.d=a.None,this.f=i.Disposable.None,this.g=new h({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(e){this.d=e,this.c&&(this.f.dispose(),this.f=e(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}})),n(i[51],o([0,1,7]),(function(e,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const r=Object.freeze((function(e,t){const n=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(n)}}}));var i,o;(o=i=t.CancellationToken||(t.CancellationToken={})).isCancellationToken=function(e){return e===o.None||e===o.Cancelled||e instanceof s||!(!e||"object"!=typeof e)&&"boolean"==typeof e.isCancellationRequested&&"function"==typeof e.onCancellationRequested},o.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),o.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r});class s{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}t.CancellationTokenSource=class{constructor(e){this.a=void 0,this.b=void 0,this.b=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new s),this.a}cancel(){this.a?this.a instanceof s&&this.a.cancel():this.a=i.Cancelled}dispose(e=!1){var t;e&&this.cancel(),null===(t=this.b)||void 0===t||t.dispose(),this.a?this.a instanceof s&&this.a.dispose():this.a=i.None}}})),n(i[12],o([0,1,50,5]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,o=/^\//,s=/^\/\//;function a(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);if(e.scheme&&!i.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!o.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(s.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}const l="",u="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(e){return e instanceof d||!!e&&"string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"string"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString}constructor(e,t,n,r,i,o=!1){"object"==typeof e?(this.scheme=e.scheme||l,this.authority=e.authority||l,this.path=e.path||l,this.query=e.query||l,this.fragment=e.fragment||l):(this.scheme=function(e,t){return e||t?e:"file"}(e,o),this.authority=t||l,this.path=function(e,t){switch(e){case"https":case"http":case"file":t?t[0]!==u&&(t=u+t):t=u}return t}(this.scheme,n||l),this.query=r||l,this.fragment=i||l,a(this,o))}get fsPath(){return b(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:n,path:r,query:i,fragment:o}=e;return void 0===t?t=this.scheme:null===t&&(t=l),void 0===n?n=this.authority:null===n&&(n=l),void 0===r?r=this.path:null===r&&(r=l),void 0===i?i=this.query:null===i&&(i=l),void 0===o?o=this.fragment:null===o&&(o=l),t===this.scheme&&n===this.authority&&r===this.path&&i===this.query&&o===this.fragment?this:new f(t,n,r,i,o)}static parse(e,t=!1){const n=c.exec(e);return n?new f(n[2]||l,E(n[4]||l),E(n[5]||l),E(n[7]||l),E(n[9]||l),t):new f(l,l,l,l,l)}static file(e){let t=l;if(r.isWindows&&(e=e.replace(/\\/g,u)),e[0]===u&&e[1]===u){const n=e.indexOf(u,2);-1===n?(t=e.substring(2),e=u):(t=e.substring(2,n),e=e.substring(n)||u)}return new f("file",t,e,l,l)}static from(e){const t=new f(e.scheme,e.authority,e.path,e.query,e.fragment);return a(t,!0),t}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let i;return i=r.isWindows&&"file"===e.scheme?d.file(n.win32.join(b(e,!0),...t)).path:n.posix.join(e.path,...t),e.with({path:i})}toString(e=!1){return y(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof d)return e;{const t=new f(e);return t._formatted=e.external,t._fsPath=e._sep===h?e.fsPath:null,t}}return e}}t.URI=d;const h=r.isWindows?1:void 0;class f extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(e=!1){return e?y(this,!0):(this._formatted||(this._formatted=y(this,!1)),this._formatted)}toJSON(){const e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=h),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const g={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function m(e,t,n){let r,i=-1;for(let o=0;o<e.length;o++){const s=e.charCodeAt(o);if(s>=97&&s<=122||s>=65&&s<=90||s>=48&&s<=57||45===s||46===s||95===s||126===s||t&&47===s||n&&91===s||n&&93===s||n&&58===s)-1!==i&&(r+=encodeURIComponent(e.substring(i,o)),i=-1),void 0!==r&&(r+=e.charAt(o));else{void 0===r&&(r=e.substr(0,o));const t=g[s];void 0!==t?(-1!==i&&(r+=encodeURIComponent(e.substring(i,o)),i=-1),r+=t):-1===i&&(i=o)}}return-1!==i&&(r+=encodeURIComponent(e.substring(i))),void 0!==r?r:e}function p(e){let t;for(let n=0;n<e.length;n++){const r=e.charCodeAt(n);35===r||63===r?(void 0===t&&(t=e.substr(0,n)),t+=g[r]):void 0!==t&&(t+=e[n])}return void 0!==t?t:e}function b(e,t){let n;return n=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,r.isWindows&&(n=n.replace(/\//g,"\\")),n}function y(e,t){const n=t?p:m;let r="",{scheme:i,authority:o,path:s,query:a,fragment:l}=e;if(i&&(r+=i,r+=":"),(o||"file"===i)&&(r+=u,r+=u),o){let e=o.indexOf("@");if(-1!==e){const t=o.substr(0,e);o=o.substr(e+1),e=t.lastIndexOf(":"),-1===e?r+=n(t,!1,!1):(r+=n(t.substr(0,e),!1,!1),r+=":",r+=n(t.substr(e+1),!1,!0)),r+="@"}o=o.toLowerCase(),e=o.lastIndexOf(":"),-1===e?r+=n(o,!1,!0):(r+=n(o.substr(0,e),!1,!0),r+=o.substr(e))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){const e=s.charCodeAt(1);e>=65&&e<=90&&(s=`/${String.fromCharCode(e+32)}:${s.substr(3)}`)}else if(s.length>=2&&58===s.charCodeAt(1)){const e=s.charCodeAt(0);e>=65&&e<=90&&(s=`${String.fromCharCode(e+32)}:${s.substr(2)}`)}r+=n(s,!0,!1)}return a&&(r+="?",r+=n(a,!1,!1)),l&&(r+="#",r+=t?l:m(l,!1,!1)),r}function C(e){try{return decodeURIComponent(e)}catch{return e.length>3?e.substr(0,3)+C(e.substr(3)):e}}t.uriToFsPath=b;const v=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function E(e){return e.match(v)?e.replace(v,(e=>C(e))):e}})),n(i[56],o([0,1,8,7,10,11,5,4]),(function(e,t,n,r,i,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const l="$initialize";let u=!1;t.logOnceWebWorkerWarning=function(e){!s.isWeb||(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(e.message))};class c{constructor(e,t,n,r){this.vsWorker=e,this.req=t,this.method=n,this.args=r,this.type=0}}class d{constructor(e,t,n,r){this.vsWorker=e,this.seq=t,this.res=n,this.err=r,this.type=1}}class h{constructor(e,t,n,r){this.vsWorker=e,this.req=t,this.eventName=n,this.arg=r,this.type=2}}class f{constructor(e,t,n){this.vsWorker=e,this.req=t,this.event=n,this.type=3}}class g{constructor(e,t){this.vsWorker=e,this.req=t,this.type=4}}class m{constructor(e){this.a=-1,this.g=e,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(e){this.a=e}sendMessage(e,t){const n=String(++this.b);return new Promise(((r,i)=>{this.c[n]={resolve:r,reject:i},this.o(new c(this.a,n,e,t))}))}listen(e,t){let n=null;const i=new r.Emitter({onWillAddFirstListener:()=>{n=String(++this.b),this.d.set(n,i),this.o(new h(this.a,n,e,t))},onDidRemoveLastListener:()=>{this.d.delete(n),this.o(new g(this.a,n)),n=null}});return i.event}handleMessage(e){!e||!e.vsWorker||-1!==this.a&&e.vsWorker!==this.a||this.h(e)}h(e){switch(e.type){case 1:return this.j(e);case 0:return this.k(e);case 2:return this.l(e);case 3:return this.m(e);case 4:return this.n(e)}}j(e){if(!this.c[e.seq])return void console.warn("Got reply to unknown seq");const t=this.c[e.seq];if(delete this.c[e.seq],e.err){let n=e.err;return e.err.$isError&&(n=new Error,n.name=e.err.name,n.message=e.err.message,n.stack=e.err.stack),void t.reject(n)}t.resolve(e.res)}k(e){const t=e.req;this.g.handleMessage(e.method,e.args).then((e=>{this.o(new d(this.a,t,e,void 0))}),(e=>{e.detail instanceof Error&&(e.detail=(0,n.transformErrorForSerialization)(e.detail)),this.o(new d(this.a,t,void 0,(0,n.transformErrorForSerialization)(e)))}))}l(e){const t=e.req,n=this.g.handleEvent(e.eventName,e.arg)((e=>{this.o(new f(this.a,t,e))}));this.f.set(t,n)}m(e){this.d.has(e.req)?this.d.get(e.req).fire(e.event):console.warn("Got event for unknown req")}n(e){this.f.has(e.req)?(this.f.get(e.req).dispose(),this.f.delete(e.req)):console.warn("Got unsubscribe for unknown req")}o(e){const t=[];if(0===e.type)for(let n=0;n<e.args.length;n++)e.args[n]instanceof ArrayBuffer&&t.push(e.args[n]);else 1===e.type&&e.res instanceof ArrayBuffer&&t.push(e.res);this.g.sendMessage(e,t)}}class p extends i.Disposable{constructor(e,t,n){super();let r=null;this.a=this.q(e.create("vs/base/common/worker/simpleWorker",(e=>{this.c.handleMessage(e)}),(e=>{r?.(e)}))),this.c=new m({sendMessage:(e,t)=>{this.a.postMessage(e,t)},handleMessage:(e,t)=>{if("function"!=typeof n[e])return Promise.reject(new Error("Missing method "+e+" on main thread host."));try{return Promise.resolve(n[e].apply(n,t))}catch(e){return Promise.reject(e)}},handleEvent:(e,t)=>{if(y(e)){const r=n[e].call(n,t);if("function"!=typeof r)throw new Error(`Missing dynamic event ${e} on main thread host.`);return r}if(b(e)){const t=n[e];if("function"!=typeof t)throw new Error(`Missing event ${e} on main thread host.`);return t}throw new Error(`Malformed event name ${e}`)}}),this.c.setWorkerId(this.a.getId());let i=null;typeof s.globals.require<"u"&&"function"==typeof s.globals.require.getConfig?i=s.globals.require.getConfig():typeof s.globals.requirejs<"u"&&(i=s.globals.requirejs.s.contexts._.config);const a=(0,o.getAllMethodNames)(n);this.b=this.c.sendMessage(l,[this.a.getId(),JSON.parse(JSON.stringify(i)),t,a]);const u=(e,t)=>this.h(e,t),c=(e,t)=>this.c.listen(e,t);this.g=new Promise(((e,n)=>{r=n,this.b.then((t=>{e(C(t,u,c))}),(e=>{n(e),this.j("Worker failed to load "+t,e)}))}))}getProxyObject(){return this.g}h(e,t){return new Promise(((n,r)=>{this.b.then((()=>{this.c.sendMessage(e,t).then(n,r)}),r)}))}j(e,t){console.error(e),console.info(t)}}function b(e){return"o"===e[0]&&"n"===e[1]&&a.isUpperAsciiLetter(e.charCodeAt(2))}function y(e){return/^onDynamic/.test(e)&&a.isUpperAsciiLetter(e.charCodeAt(9))}function C(e,t,n){const r=e=>function(){const n=Array.prototype.slice.call(arguments,0);return t(e,n)},i=e=>function(t){return n(e,t)},o={};for(const t of e)y(t)?o[t]=i(t):b(t)?o[t]=n(t,void 0):o[t]=r(t);return o}t.SimpleWorkerClient=p;class v{constructor(e,t){this.a=t,this.b=null,this.c=new m({sendMessage:(t,n)=>{e(t,n)},handleMessage:(e,t)=>this.d(e,t),handleEvent:(e,t)=>this.f(e,t)})}onmessage(e){this.c.handleMessage(e)}d(e,t){if(e===l)return this.g(t[0],t[1],t[2],t[3]);if(!this.b||"function"!=typeof this.b[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this.b[e].apply(this.b,t))}catch(e){return Promise.reject(e)}}f(e,t){if(!this.b)throw new Error("Missing requestHandler");if(y(e)){const n=this.b[e].call(this.b,t);if("function"!=typeof n)throw new Error(`Missing dynamic event ${e} on request handler.`);return n}if(b(e)){const t=this.b[e];if("function"!=typeof t)throw new Error(`Missing event ${e} on request handler.`);return t}throw new Error(`Malformed event name ${e}`)}g(t,n,r,i){this.c.setWorkerId(t);const a=C(i,((e,t)=>this.c.sendMessage(e,t)),((e,t)=>this.c.listen(e,t)));return this.a?(this.b=this.a(a),Promise.resolve((0,o.getAllMethodNames)(this.b))):(n&&(typeof n.baseUrl<"u"&&delete n.baseUrl,typeof n.paths<"u"&&typeof n.paths.vs<"u"&&delete n.paths.vs,void 0!==typeof n.trustedTypesPolicy&&delete n.trustedTypesPolicy,n.catchError=!0,s.globals.require.config(n)),new Promise(((t,n)=>{(s.globals.require||e)([r],(e=>{this.b=e.create(a),this.b?t((0,o.getAllMethodNames)(this.b)):n(new Error("No RequestHandler!"))}),n)})))}}t.SimpleWorkerServer=v,t.create=function(e){return new v(e,null)}})),n(i[52],o([0,1,7,10]),(function(e,t,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=void 0,t.TokenizationRegistry=class{constructor(){this.a=new Map,this.b=new Map,this.c=new n.Emitter,this.onDidChange=this.c.event,this.d=null}fire(e){this.c.fire({changedLanguages:e,changedColorMap:!1})}register(e,t){return this.a.set(e,t),this.fire([e]),(0,r.toDisposable)((()=>{this.a.get(e)===t&&(this.a.delete(e),this.fire([e]))}))}registerFactory(e,t){var n;null===(n=this.b.get(e))||void 0===n||n.dispose();const o=new i(this,e,t);return this.b.set(e,o),(0,r.toDisposable)((()=>{const t=this.b.get(e);!t||t!==o||(this.b.delete(e),t.dispose())}))}getOrCreate(e){return l(this,void 0,void 0,(function*(){const t=this.get(e);if(t)return t;const n=this.b.get(e);return!n||n.isResolved?null:(yield n.resolve(),this.get(e))}))}get(e){return this.a.get(e)||null}isResolved(e){if(this.get(e))return!0;const t=this.b.get(e);return!(t&&!t.isResolved)}setColorMap(e){this.d=e,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}};class i extends r.Disposable{get isResolved(){return this.c}constructor(e,t,n){super(),this.g=e,this.h=t,this.i=n,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}resolve(){return l(this,void 0,void 0,(function*(){return this.b||(this.b=this.j()),this.b}))}j(){return l(this,void 0,void 0,(function*(){const e=yield Promise.resolve(this.i.createTokenizationSupport());this.c=!0,e&&!this.a&&this.q(this.g.register(this.h,e))}))}}})),n(i[53],o([0,1,30,12,2,52]),(function(e,t,n,r,i,o){"use strict";var s;Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistry=t.InlayHintKind=t.Command=t.FoldingRangeKind=t.SymbolKinds=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.InlineCompletionTriggerKind=t.CompletionItemKinds=t.EncodedTokenizationResult=t.TokenizationResult=t.Token=void 0,t.Token=class{constructor(e,t,n){this._tokenBrand=void 0,this.offset=e,this.type=t,this.language=n}toString(){return"("+this.offset+", "+this.type+")"}},t.TokenizationResult=class{constructor(e,t){this._tokenizationResultBrand=void 0,this.tokens=e,this.endState=t}},t.EncodedTokenizationResult=class{constructor(e,t){this._encodedTokenizationResultBrand=void 0,this.tokens=e,this.endState=t}},function(e){const t=new Map;t.set(0,n.Codicon.symbolMethod),t.set(1,n.Codicon.symbolFunction),t.set(2,n.Codicon.symbolConstructor),t.set(3,n.Codicon.symbolField),t.set(4,n.Codicon.symbolVariable),t.set(5,n.Codicon.symbolClass),t.set(6,n.Codicon.symbolStruct),t.set(7,n.Codicon.symbolInterface),t.set(8,n.Codicon.symbolModule),t.set(9,n.Codicon.symbolProperty),t.set(10,n.Codicon.symbolEvent),t.set(11,n.Codicon.symbolOperator),t.set(12,n.Codicon.symbolUnit),t.set(13,n.Codicon.symbolValue),t.set(15,n.Codicon.symbolEnum),t.set(14,n.Codicon.symbolConstant),t.set(15,n.Codicon.symbolEnum),t.set(16,n.Codicon.symbolEnumMember),t.set(17,n.Codicon.symbolKeyword),t.set(27,n.Codicon.symbolSnippet),t.set(18,n.Codicon.symbolText),t.set(19,n.Codicon.symbolColor),t.set(20,n.Codicon.symbolFile),t.set(21,n.Codicon.symbolReference),t.set(22,n.Codicon.symbolCustomColor),t.set(23,n.Codicon.symbolFolder),t.set(24,n.Codicon.symbolTypeParameter),t.set(25,n.Codicon.account),t.set(26,n.Codicon.issues),e.toIcon=function(e){let r=t.get(e);return r||(console.info("No codicon found for CompletionItemKind "+e),r=n.Codicon.symbolProperty),r};const r=new Map;r.set("method",0),r.set("function",1),r.set("constructor",2),r.set("field",3),r.set("variable",4),r.set("class",5),r.set("struct",6),r.set("interface",7),r.set("module",8),r.set("property",9),r.set("event",10),r.set("operator",11),r.set("unit",12),r.set("value",13),r.set("constant",14),r.set("enum",15),r.set("enum-member",16),r.set("enumMember",16),r.set("keyword",17),r.set("snippet",27),r.set("text",18),r.set("color",19),r.set("file",20),r.set("reference",21),r.set("customcolor",22),r.set("folder",23),r.set("type-parameter",24),r.set("typeParameter",24),r.set("account",25),r.set("issue",26),e.fromString=function(e,t){let n=r.get(e);return typeof n>"u"&&!t&&(n=9),n}}(t.CompletionItemKinds||(t.CompletionItemKinds={})),(s=t.InlineCompletionTriggerKind||(t.InlineCompletionTriggerKind={}))[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit",function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={})),function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={})),t.isLocationLink=function(e){return e&&r.URI.isUri(e.uri)&&i.Range.isIRange(e.range)&&(i.Range.isIRange(e.originSelectionRange)||i.Range.isIRange(e.targetSelectionRange))},function(e){const t=new Map;t.set(0,n.Codicon.symbolFile),t.set(1,n.Codicon.symbolModule),t.set(2,n.Codicon.symbolNamespace),t.set(3,n.Codicon.symbolPackage),t.set(4,n.Codicon.symbolClass),t.set(5,n.Codicon.symbolMethod),t.set(6,n.Codicon.symbolProperty),t.set(7,n.Codicon.symbolField),t.set(8,n.Codicon.symbolConstructor),t.set(9,n.Codicon.symbolEnum),t.set(10,n.Codicon.symbolInterface),t.set(11,n.Codicon.symbolFunction),t.set(12,n.Codicon.symbolVariable),t.set(13,n.Codicon.symbolConstant),t.set(14,n.Codicon.symbolString),t.set(15,n.Codicon.symbolNumber),t.set(16,n.Codicon.symbolBoolean),t.set(17,n.Codicon.symbolArray),t.set(18,n.Codicon.symbolObject),t.set(19,n.Codicon.symbolKey),t.set(20,n.Codicon.symbolNull),t.set(21,n.Codicon.symbolEnumMember),t.set(22,n.Codicon.symbolStruct),t.set(23,n.Codicon.symbolEvent),t.set(24,n.Codicon.symbolOperator),t.set(25,n.Codicon.symbolTypeParameter),e.toIcon=function(e){let r=t.get(e);return r||(console.info("No codicon found for SymbolKind "+e),r=n.Codicon.symbolProperty),r}}(t.SymbolKinds||(t.SymbolKinds={}));class a{constructor(e){this.value=e}}a.Comment=new a("comment"),a.Imports=new a("imports"),a.Region=new a("region"),t.FoldingRangeKind=a,function(e){e.is=function(e){return!(!e||"object"!=typeof e)&&"string"==typeof e.id&&"string"==typeof e.title}}(t.Command||(t.Command={})),function(e){e[e.Type=1]="Type",e[e.Parameter=2]="Parameter"}(t.InlayHintKind||(t.InlayHintKind={})),t.TokenizationRegistry=new o.TokenizationRegistry})),n(i[54],o([0,1,51,7,27,12,3,2,31,53,47]),(function(e,t,n,r,i,o,s,a,l,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createMonacoBaseAPI=t.KeyMod=void 0;class d{static chord(e,t){return(0,i.KeyChord)(e,t)}}d.CtrlCmd=2048,d.Shift=1024,d.Alt=512,d.WinCtrl=256,t.KeyMod=d,t.createMonacoBaseAPI=function(){return{editor:void 0,languages:void 0,CancellationTokenSource:n.CancellationTokenSource,Emitter:r.Emitter,KeyCode:c.KeyCode,KeyMod:d,Position:s.Position,Range:a.Range,Selection:l.Selection,SelectionDirection:c.SelectionDirection,MarkerSeverity:c.MarkerSeverity,MarkerTag:c.MarkerTag,Uri:o.URI,Token:u.Token}}})),n(i[57],o([0,1,16,5,12,3,2,44,20,40,41,54,22,46,39,11]),(function(e,t,n,r,i,o,s,a,u,c,d,h,f,g,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends a.MirrorTextModel{get uri(){return this.c}get eol(){return this.f}getValue(){return this.getText()}getLinesContent(){return this.d.slice(0)}getLineCount(){return this.d.length}getLineContent(e){return this.d[e-1]}getWordAtPosition(e,t){const n=(0,u.getWordAtText)(e.column,(0,u.ensureValidWordDefinition)(t),this.d[e.lineNumber-1],0);return n?new s.Range(e.lineNumber,n.startColumn,e.lineNumber,n.endColumn):null}words(e){const t=this.d,n=this.p.bind(this);let r=0,i="",o=0,s=[];return{*[Symbol.iterator](){for(;;)if(o<s.length){const e=i.substring(s[o].start,s[o].end);o+=1,yield e}else{if(!(r<t.length))break;i=t[r],s=n(i,e),o=0,r+=1}}}}getLineWords(e,t){const n=this.d[e-1],r=this.p(n,t),i=[];for(const e of r)i.push({word:n.substring(e.start,e.end),startColumn:e.start+1,endColumn:e.end+1});return i}p(e,t){const n=[];let r;for(t.lastIndex=0;(r=t.exec(e))&&0!==r[0].length;)n.push({start:r.index,end:r.index+r[0].length});return n}getValueInRange(e){if((e=this.q(e)).startLineNumber===e.endLineNumber)return this.d[e.startLineNumber-1].substring(e.startColumn-1,e.endColumn-1);const t=this.f,n=e.startLineNumber-1,r=e.endLineNumber-1,i=[];i.push(this.d[n].substring(e.startColumn-1));for(let e=n+1;e<r;e++)i.push(this.d[e]);return i.push(this.d[r].substring(0,e.endColumn-1)),i.join(t)}offsetAt(e){return e=this.r(e),this.k(),this.h.getPrefixSum(e.lineNumber-2)+(e.column-1)}positionAt(e){e=Math.floor(e),e=Math.max(0,e),this.k();const t=this.h.getIndexOf(e),n=this.d[t.index].length;return{lineNumber:1+t.index,column:1+Math.min(t.remainder,n)}}q(e){const t=this.r({lineNumber:e.startLineNumber,column:e.startColumn}),n=this.r({lineNumber:e.endLineNumber,column:e.endColumn});return t.lineNumber!==e.startLineNumber||t.column!==e.startColumn||n.lineNumber!==e.endLineNumber||n.column!==e.endColumn?{startLineNumber:t.lineNumber,startColumn:t.column,endLineNumber:n.lineNumber,endColumn:n.column}:e}r(e){if(!o.Position.isIPosition(e))throw new Error("bad position");let{lineNumber:t,column:n}=e,r=!1;if(t<1)t=1,n=1,r=!0;else if(t>this.d.length)t=this.d.length,n=this.d[t-1].length+1,r=!0;else{const e=this.d[t-1].length+1;n<1?(n=1,r=!0):n>e&&(n=e,r=!0)}return r?{lineNumber:t,column:n}:e}}class y{constructor(e,t){this.c=e,this.d=Object.create(null),this.f=t,this.g=null}dispose(){this.d=Object.create(null)}h(e){return this.d[e]}j(){const e=[];return Object.keys(this.d).forEach((t=>e.push(this.d[t]))),e}acceptNewModel(e){this.d[e.url]=new b(i.URI.parse(e.url),e.lines,e.EOL,e.versionId)}acceptModelChanged(e,t){this.d[e]&&this.d[e].onEvents(t)}acceptRemovedModel(e){!this.d[e]||delete this.d[e]}computeUnicodeHighlights(e,t,n){return l(this,void 0,void 0,(function*(){const r=this.h(e);return r?g.UnicodeTextModelHighlighter.computeUnicodeHighlights(r,t,n):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}))}computeDiff(e,t,n,r){return l(this,void 0,void 0,(function*(){const i=this.h(e),o=this.h(t);return i&&o?y.k(i,o,n,r):null}))}static k(e,t,n,r){const i="experimental"===r?m.linesDiffComputers.experimental:m.linesDiffComputers.smart,o=e.getLinesContent(),s=t.getLinesContent(),a=i.computeDiff(o,s,n);return{identical:!(a.changes.length>0)&&this.l(e,t),quitEarly:a.quitEarly,changes:a.changes.map((e=>{var t;return[e.originalRange.startLineNumber,e.originalRange.endLineNumberExclusive,e.modifiedRange.startLineNumber,e.modifiedRange.endLineNumberExclusive,null===(t=e.innerChanges)||void 0===t?void 0:t.map((e=>[e.originalRange.startLineNumber,e.originalRange.startColumn,e.originalRange.endLineNumber,e.originalRange.endColumn,e.modifiedRange.startLineNumber,e.modifiedRange.startColumn,e.modifiedRange.endLineNumber,e.modifiedRange.endColumn]))]}))}}static l(e,t){const n=e.getLineCount();if(n!==t.getLineCount())return!1;for(let r=1;r<=n;r++)if(e.getLineContent(r)!==t.getLineContent(r))return!1;return!0}computeMoreMinimalEdits(e,t){return l(this,void 0,void 0,(function*(){const r=this.h(e);if(!r)return t;const i=[];let o;t=t.slice(0).sort(((e,t)=>e.range&&t.range?s.Range.compareRangesUsingStarts(e.range,t.range):(e.range?0:1)-(t.range?0:1)));for(let{range:e,text:a,eol:l}of t){if("number"==typeof l&&(o=l),s.Range.isEmpty(e)&&!a)continue;const t=r.getValueInRange(e);if(a=a.replace(/\r\n|\n|\r/g,r.eol),t===a)continue;if(Math.max(a.length,t.length)>y.n){i.push({range:e,text:a});continue}const u=(0,n.stringDiff)(t,a,!1),c=r.offsetAt(s.Range.lift(e).getStartPosition());for(const e of u){const t=r.positionAt(c+e.originalStart),n=r.positionAt(c+e.originalStart+e.originalLength),o={text:a.substr(e.modifiedStart,e.modifiedLength),range:{startLineNumber:t.lineNumber,startColumn:t.column,endLineNumber:n.lineNumber,endColumn:n.column}};r.getValueInRange(o.range)!==o.text&&i.push(o)}}return"number"==typeof o&&i.push({eol:o,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),i}))}computeLinks(e){return l(this,void 0,void 0,(function*(){const t=this.h(e);return t?(0,c.computeLinks)(t):null}))}textualSuggest(e,t,n,r){return l(this,void 0,void 0,(function*(){const i=new f.StopWatch(!0),o=new RegExp(n,r),s=new Set;e:for(const n of e){const e=this.h(n);if(e)for(const n of e.words(o))if(n!==t&&isNaN(Number(n))&&(s.add(n),s.size>y.o))break e}return{words:Array.from(s),duration:i.elapsed()}}))}computeWordRanges(e,t,n,r){return l(this,void 0,void 0,(function*(){const i=this.h(e);if(!i)return Object.create(null);const o=new RegExp(n,r),s=Object.create(null);for(let e=t.startLineNumber;e<t.endLineNumber;e++){const t=i.getLineWords(e,o);for(const n of t){if(!isNaN(Number(n.word)))continue;let t=s[n.word];t||(t=[],s[n.word]=t),t.push({startLineNumber:e,startColumn:n.startColumn,endLineNumber:e,endColumn:n.endColumn})}}return s}))}navigateValueSet(e,t,n,r,i){return l(this,void 0,void 0,(function*(){const o=this.h(e);if(!o)return null;const s=new RegExp(r,i);t.startColumn===t.endColumn&&(t={startLineNumber:t.startLineNumber,startColumn:t.startColumn,endLineNumber:t.endLineNumber,endColumn:t.endColumn+1});const a=o.getValueInRange(t),l=o.getWordAtPosition({lineNumber:t.startLineNumber,column:t.startColumn},s);if(!l)return null;const u=o.getValueInRange(l);return d.BasicInplaceReplace.INSTANCE.navigateValueSet(t,a,l,u,n)}))}loadForeignModule(t,n,r){const i={host:(0,p.createProxyObject)(r,((e,t)=>this.c.fhr(e,t))),getMirrorModels:()=>this.j()};return this.f?(this.g=this.f(i,n),Promise.resolve((0,p.getAllMethodNames)(this.g))):new Promise(((r,o)=>{e([t],(e=>{this.g=e.create(i,n),r((0,p.getAllMethodNames)(this.g))}),o)}))}fmr(e,t){if(!this.g||"function"!=typeof this.g[e])return Promise.reject(new Error("Missing requestHandler or method: "+e));try{return Promise.resolve(this.g[e].apply(this.g,t))}catch(e){return Promise.reject(e)}}}y.n=1e5,y.o=1e4,t.EditorSimpleWorker=y,t.create=function(e){return new y(e,null)},"function"==typeof importScripts&&(r.globals.monaco=(0,h.createMonacoBaseAPI)())}))}).call(this);